{-# OPTIONS_GHC -fno-warn-unused-binds -fno-warn-missing-signatures #-}
{-# LANGUAGE CPP #-}
{-# LINE 1 "Lexer.x" #-}

{-# LANGUAGE BangPatterns #-}
{-# OPTIONS_GHC -fno-warn-tabs -fno-warn-unused-binds #-}
module Language.Java.Lexer (L(..), Token(..), lexer) where

import Numeric
import Data.Char

#if __GLASGOW_HASKELL__ >= 603
#include "ghcconfig.h"
#elif defined(__GLASGOW_HASKELL__)
#include "config.h"
#endif
#if __GLASGOW_HASKELL__ >= 503
import Data.Array
import Data.Array.Base (unsafeAt)
#else
import Array
#endif
{-# LINE 1 "templates/wrappers.hs" #-}
{-# LINE 1 "templates/wrappers.hs" #-}
{-# LINE 1 "<built-in>" #-}
{-# LINE 16 "<built-in>" #-}
{-# LINE 1 "/usr/local/Cellar/ghc/8.2.1/lib/ghc-8.2.1/include/ghcversion.h" #-}
















{-# LINE 17 "<built-in>" #-}
{-# LINE 1 "/var/folders/cb/97yq0wgj167gl60_pbxlyc540000gn/T/ghc10939_0/ghc_2.h" #-}













































































































































































































{-# LINE 18 "<built-in>" #-}
{-# LINE 1 "templates/wrappers.hs" #-}
-- -----------------------------------------------------------------------------
-- Alex wrapper code.
--
-- This code is in the PUBLIC DOMAIN; you may copy it freely and use
-- it for any purpose whatsoever.






import Data.Word (Word8)

{-# LINE 28 "templates/wrappers.hs" #-}

import Data.Char (ord)
import qualified Data.Bits

-- | Encode a Haskell String to a list of Word8 values, in UTF8 format.
utf8Encode :: Char -> [Word8]
utf8Encode = map fromIntegral . go . ord
 where
  go oc
   | oc <= 0x7f       = [oc]

   | oc <= 0x7ff      = [ 0xc0 + (oc `Data.Bits.shiftR` 6)
                        , 0x80 + oc Data.Bits..&. 0x3f
                        ]

   | oc <= 0xffff     = [ 0xe0 + (oc `Data.Bits.shiftR` 12)
                        , 0x80 + ((oc `Data.Bits.shiftR` 6) Data.Bits..&. 0x3f)
                        , 0x80 + oc Data.Bits..&. 0x3f
                        ]
   | otherwise        = [ 0xf0 + (oc `Data.Bits.shiftR` 18)
                        , 0x80 + ((oc `Data.Bits.shiftR` 12) Data.Bits..&. 0x3f)
                        , 0x80 + ((oc `Data.Bits.shiftR` 6) Data.Bits..&. 0x3f)
                        , 0x80 + oc Data.Bits..&. 0x3f
                        ]



type Byte = Word8

-- -----------------------------------------------------------------------------
-- The input type


type AlexInput = (AlexPosn,     -- current position,
                  Char,         -- previous char
                  [Byte],       -- pending bytes on current char
                  String)       -- current input string

ignorePendingBytes :: AlexInput -> AlexInput
ignorePendingBytes (p,c,_ps,s) = (p,c,[],s)

alexInputPrevChar :: AlexInput -> Char
alexInputPrevChar (_p,c,_bs,_s) = c

alexGetByte :: AlexInput -> Maybe (Byte,AlexInput)
alexGetByte (p,c,(b:bs),s) = Just (b,(p,c,bs,s))
alexGetByte (_,_,[],[]) = Nothing
alexGetByte (p,_,[],(c:s))  = let p' = alexMove p c
                                  (b:bs) = utf8Encode c
                              in p' `seq`  Just (b, (p', c, bs, s))



{-# LINE 102 "templates/wrappers.hs" #-}


{-# LINE 120 "templates/wrappers.hs" #-}


{-# LINE 138 "templates/wrappers.hs" #-}

-- -----------------------------------------------------------------------------
-- Token positions

-- `Posn' records the location of a token in the input text.  It has three
-- fields: the address (number of chacaters preceding the token), line number
-- and column of a token within the file. `start_pos' gives the position of the
-- start of the file and `eof_pos' a standard encoding for the end of file.
-- `move_pos' calculates the new position after traversing a given character,
-- assuming the usual eight character tab stops.


data AlexPosn = AlexPn !Int !Int !Int
        deriving (Eq,Show)

alexStartPos :: AlexPosn
alexStartPos = AlexPn 0 1 1

alexMove :: AlexPosn -> Char -> AlexPosn
alexMove (AlexPn a l c) '\t' = AlexPn (a+1)  l     (((c+alex_tab_size-1) `div` alex_tab_size)*alex_tab_size+1)
alexMove (AlexPn a l _) '\n' = AlexPn (a+1) (l+1)   1
alexMove (AlexPn a l c) _    = AlexPn (a+1)  l     (c+1)


-- -----------------------------------------------------------------------------
-- Default monad


{-# LINE 272 "templates/wrappers.hs" #-}


-- -----------------------------------------------------------------------------
-- Monad (with ByteString input)


{-# LINE 375 "templates/wrappers.hs" #-}


-- -----------------------------------------------------------------------------
-- Basic wrapper


{-# LINE 402 "templates/wrappers.hs" #-}


-- -----------------------------------------------------------------------------
-- Basic wrapper, ByteString version


{-# LINE 422 "templates/wrappers.hs" #-}


{-# LINE 438 "templates/wrappers.hs" #-}


-- -----------------------------------------------------------------------------
-- Posn wrapper

-- Adds text positions to the basic model.


--alexScanTokens :: String -> [token]
alexScanTokens str = go (alexStartPos,'\n',[],str)
  where go inp@(pos,_,_,str) =
          case alexScan inp 0 of
                AlexEOF -> []
                AlexError ((AlexPn _ line column),_,_,_) -> error $ "lexical error at line " ++ (show line) ++ ", column " ++ (show column)
                AlexSkip  inp' _ln     -> go inp'
                AlexToken inp' len act -> act pos (take len str) : go inp'



-- -----------------------------------------------------------------------------
-- Posn wrapper, ByteString version


{-# LINE 471 "templates/wrappers.hs" #-}


-- -----------------------------------------------------------------------------
-- GScan wrapper

-- For compatibility with previous versions of Alex, and because we can.


alex_tab_size :: Int
alex_tab_size = 8
alex_base :: Array Int Int
alex_base = listArray (0 :: Int, 392)
  [ -8
  , 77
  , -95
  , -32
  , 81
  , 89
  , -53
  , -51
  , -88
  , 205
  , -85
  , 333
  , 461
  , 589
  , 717
  , 845
  , 973
  , 1101
  , -87
  , -97
  , -101
  , 97
  , 1309
  , -98
  , 0
  , 1269
  , 1477
  , 0
  , 1437
  , 1645
  , 0
  , 1605
  , -84
  , 0
  , 1670
  , 0
  , 1783
  , 1991
  , 0
  , 1903
  , 2111
  , 0
  , 2023
  , 2279
  , 2215
  , 0
  , 0
  , 2280
  , 2536
  , 2616
  , 2640
  , 2566
  , 0
  , 2822
  , 2902
  , 2926
  , 2952
  , 3016
  , 0
  , 3224
  , 3240
  , 3496
  , 3432
  , 0
  , 3678
  , 125
  , 135
  , 1337
  , 1347
  , 1505
  , 1515
  , 1673
  , 1683
  , 3648
  , 3924
  , 2040
  , 0
  , 4170
  , 0
  , 3899
  , 4145
  , 4390
  , 4477
  , 4564
  , 4651
  , 4738
  , 4825
  , 4912
  , 4999
  , 5086
  , 5173
  , 5260
  , 5347
  , 5434
  , 5521
  , 5608
  , 5695
  , 5782
  , 5869
  , 5956
  , 6043
  , 6130
  , 6217
  , 6304
  , 6391
  , 6478
  , 6565
  , 6652
  , 6739
  , 6826
  , 6913
  , 7000
  , 7087
  , 7174
  , 7261
  , 7348
  , 7435
  , 7522
  , 7609
  , 7696
  , 7783
  , 7870
  , 7957
  , 8044
  , 8131
  , 8218
  , 8305
  , 8392
  , 8479
  , 3683
  , 0
  , 3259
  , 0
  , 8556
  , 0
  , 8585
  , 0
  , 0
  , 2651
  , 2957
  , 0
  , 8620
  , 8655
  , 0
  , 0
  , 8678
  , 0
  , 0
  , 0
  , 8688
  , 0
  , 8743
  , 8830
  , 0
  , 0
  , 8917
  , 9004
  , 9091
  , 9178
  , 9265
  , 9352
  , 9439
  , 9526
  , 9613
  , 9700
  , 9787
  , 9874
  , 9961
  , 10048
  , 10135
  , 10222
  , 10309
  , 10396
  , 10483
  , 10570
  , 10657
  , 10744
  , 10831
  , 10918
  , 11005
  , 11092
  , 11179
  , 11266
  , 11353
  , 11440
  , 11527
  , 11614
  , 11701
  , 11788
  , 11875
  , 11962
  , 12049
  , 12136
  , 12223
  , 12310
  , 12397
  , 12484
  , 12571
  , 12658
  , 12745
  , 12832
  , 12919
  , 13006
  , 13093
  , 13180
  , 13267
  , 13354
  , 13441
  , 13528
  , 13615
  , 13702
  , 13789
  , 13876
  , 13963
  , 14050
  , 14137
  , 14224
  , 14311
  , 14398
  , 14485
  , 14572
  , 14659
  , 14746
  , 14833
  , 14920
  , 15007
  , 15094
  , 15181
  , 15268
  , 15355
  , 15442
  , 15529
  , 15616
  , 15703
  , 15790
  , 15877
  , 15964
  , 16051
  , 16138
  , 16225
  , 16312
  , 16399
  , 16486
  , 16573
  , 16660
  , 16747
  , 16834
  , 16921
  , 17008
  , 17095
  , 17182
  , 17269
  , 17356
  , 17443
  , 17530
  , 17617
  , 17704
  , 17791
  , 17878
  , 17965
  , 18052
  , 18139
  , 18226
  , 18313
  , 18400
  , 18487
  , 18574
  , 18661
  , 18748
  , 18835
  , 18922
  , 19009
  , 19096
  , 19183
  , 19270
  , 19357
  , 19444
  , 19531
  , 19618
  , 19705
  , 19792
  , 19879
  , 19966
  , 20053
  , 20140
  , 20227
  , 20314
  , 20401
  , 20488
  , 20575
  , 20662
  , 20749
  , 20836
  , 20923
  , 21010
  , 21097
  , 21184
  , 21271
  , 21358
  , 21445
  , 21532
  , 21619
  , 21706
  , 21793
  , 21880
  , 21967
  , 22054
  , 22141
  , 22228
  , 22315
  , 22402
  , 22489
  , 22576
  , 22663
  , 22750
  , 22837
  , 22924
  , 23011
  , 23098
  , 23185
  , 23272
  , 23359
  , 23446
  , 23533
  , 23620
  , 23707
  , 23794
  , 23881
  , 23968
  , 24055
  , 24142
  , 24229
  , 24316
  , 24403
  , 24490
  , 24577
  , 24664
  , 24751
  , 24838
  , 24925
  , 25012
  , 25099
  , 25186
  , 25273
  , 25360
  , 25447
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 2014
  , 0
  , 0
  , -44
  , -42
  , -39
  , -38
  , 0
  , 0
  , -31
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 2012
  , 110
  , 23
  , 2127
  , 2016
  , 2615
  , 27
  , 60
  , 61
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 18
  ]

alex_table :: Array Int Int
alex_table = listArray (0 :: Int, 25702)
  [ 0
  , 75
  , 75
  , 75
  , 75
  , 75
  , 78
  , 153
  , 390
  , 7
  , 391
  , 2
  , 8
  , 20
  , 23
  , 18
  , 32
  , 364
  , 10
  , 366
  , 6
  , 380
  , 365
  , 367
  , 75
  , 360
  , 64
  , 356
  , 264
  , 379
  , 376
  , 56
  , 346
  , 347
  , 374
  , 372
  , 353
  , 373
  , 354
  , 375
  , 129
  , 133
  , 133
  , 133
  , 133
  , 133
  , 133
  , 133
  , 133
  , 133
  , 363
  , 352
  , 359
  , 357
  , 358
  , 362
  , 392
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 348
  , 383
  , 349
  , 378
  , 264
  , 387
  , 248
  , 216
  , 217
  , 161
  , 299
  , 197
  , 221
  , 264
  , 335
  , 264
  , 264
  , 225
  , 264
  , 200
  , 264
  , 254
  , 264
  , 255
  , 279
  , 306
  , 264
  , 232
  , 277
  , 264
  , 264
  , 264
  , 350
  , 377
  , 351
  , 361
  , 1
  , 153
  , 388
  , 389
  , 19
  , 76
  , 0
  , 0
  , 0
  , 153
  , 3
  , 3
  , 3
  , 3
  , 3
  , 3
  , 3
  , 3
  , 4
  , 4
  , 4
  , 4
  , 4
  , 4
  , 4
  , 4
  , 26
  , 26
  , 26
  , 26
  , 26
  , 26
  , 26
  , 26
  , 26
  , 26
  , 371
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 26
  , 26
  , 26
  , 26
  , 26
  , 26
  , 66
  , 0
  , 66
  , 382
  , 355
  , 149
  , 149
  , 149
  , 149
  , 149
  , 149
  , 149
  , 149
  , 149
  , 149
  , 149
  , 149
  , 149
  , 149
  , 149
  , 149
  , 149
  , 149
  , 149
  , 149
  , 0
  , 26
  , 26
  , 26
  , 26
  , 26
  , 26
  , 0
  , 0
  , 0
  , 0
  , 0
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 43
  , 45
  , 45
  , 45
  , 45
  , 45
  , 45
  , 45
  , 45
  , 45
  , 45
  , 45
  , 45
  , 45
  , 45
  , 45
  , 45
  , 45
  , 45
  , 45
  , 45
  , 45
  , 45
  , 45
  , 45
  , 45
  , 45
  , 45
  , 45
  , 44
  , 14
  , 33
  , 33
  , 33
  , 33
  , 33
  , 33
  , 33
  , 33
  , 33
  , 33
  , 33
  , 33
  , 33
  , 33
  , 34
  , 17
  , 24
  , 24
  , 24
  , 25
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 61
  , 63
  , 63
  , 63
  , 63
  , 63
  , 63
  , 63
  , 63
  , 63
  , 63
  , 63
  , 63
  , 63
  , 63
  , 63
  , 63
  , 63
  , 63
  , 63
  , 63
  , 63
  , 63
  , 63
  , 63
  , 63
  , 63
  , 63
  , 63
  , 63
  , 63
  , 63
  , 63
  , 63
  , 63
  , 63
  , 63
  , 63
  , 63
  , 63
  , 63
  , 63
  , 63
  , 63
  , 63
  , 63
  , 63
  , 63
  , 63
  , 63
  , 63
  , 63
  , 63
  , 63
  , 63
  , 63
  , 63
  , 63
  , 63
  , 63
  , 63
  , 63
  , 63
  , 63
  , 63
  , 63
  , 63
  , 63
  , 63
  , 63
  , 63
  , 63
  , 63
  , 63
  , 63
  , 63
  , 63
  , 63
  , 63
  , 63
  , 63
  , 63
  , 63
  , 63
  , 63
  , 63
  , 63
  , 63
  , 63
  , 63
  , 63
  , 63
  , 63
  , 63
  , 63
  , 63
  , 63
  , 63
  , 63
  , 63
  , 63
  , 63
  , 63
  , 63
  , 63
  , 63
  , 63
  , 63
  , 63
  , 63
  , 63
  , 63
  , 63
  , 63
  , 63
  , 63
  , 63
  , 63
  , 63
  , 63
  , 63
  , 63
  , 63
  , 63
  , 63
  , 63
  , 63
  , 63
  , 53
  , 58
  , 58
  , 58
  , 58
  , 58
  , 58
  , 58
  , 58
  , 58
  , 58
  , 58
  , 58
  , 58
  , 58
  , 58
  , 58
  , 58
  , 58
  , 58
  , 58
  , 58
  , 58
  , 58
  , 58
  , 58
  , 58
  , 58
  , 58
  , 58
  , 58
  , 58
  , 58
  , 58
  , 58
  , 58
  , 58
  , 58
  , 58
  , 58
  , 58
  , 58
  , 58
  , 58
  , 58
  , 58
  , 58
  , 58
  , 58
  , 58
  , 58
  , 58
  , 58
  , 58
  , 58
  , 58
  , 58
  , 58
  , 58
  , 58
  , 58
  , 58
  , 58
  , 58
  , 58
  , 58
  , 58
  , 58
  , 58
  , 58
  , 58
  , 58
  , 58
  , 58
  , 58
  , 58
  , 58
  , 58
  , 58
  , 58
  , 58
  , 58
  , 58
  , 58
  , 58
  , 58
  , 58
  , 58
  , 58
  , 58
  , 58
  , 58
  , 58
  , 58
  , 58
  , 58
  , 58
  , 58
  , 58
  , 58
  , 58
  , 58
  , 58
  , 58
  , 58
  , 58
  , 58
  , 58
  , 58
  , 58
  , 58
  , 58
  , 58
  , 58
  , 58
  , 58
  , 58
  , 58
  , 58
  , 58
  , 58
  , 58
  , 58
  , 58
  , 58
  , 58
  , 58
  , 58
  , 48
  , 52
  , 52
  , 52
  , 52
  , 52
  , 52
  , 52
  , 52
  , 52
  , 52
  , 52
  , 52
  , 52
  , 52
  , 52
  , 52
  , 52
  , 52
  , 52
  , 52
  , 52
  , 52
  , 52
  , 52
  , 52
  , 52
  , 52
  , 52
  , 52
  , 52
  , 52
  , 52
  , 52
  , 52
  , 52
  , 52
  , 52
  , 52
  , 52
  , 52
  , 52
  , 52
  , 52
  , 52
  , 52
  , 52
  , 52
  , 52
  , 52
  , 52
  , 52
  , 52
  , 52
  , 52
  , 52
  , 52
  , 52
  , 52
  , 52
  , 52
  , 52
  , 52
  , 52
  , 52
  , 52
  , 52
  , 52
  , 52
  , 52
  , 52
  , 52
  , 52
  , 52
  , 52
  , 52
  , 52
  , 52
  , 52
  , 52
  , 52
  , 52
  , 52
  , 52
  , 52
  , 52
  , 52
  , 52
  , 52
  , 52
  , 52
  , 52
  , 52
  , 52
  , 52
  , 52
  , 52
  , 52
  , 52
  , 52
  , 52
  , 52
  , 52
  , 52
  , 52
  , 52
  , 52
  , 52
  , 52
  , 52
  , 52
  , 52
  , 52
  , 52
  , 52
  , 52
  , 52
  , 52
  , 52
  , 52
  , 52
  , 52
  , 52
  , 52
  , 52
  , 52
  , 52
  , 52
  , 9
  , 46
  , 46
  , 46
  , 46
  , 46
  , 46
  , 46
  , 46
  , 46
  , 46
  , 46
  , 46
  , 46
  , 46
  , 46
  , 46
  , 46
  , 46
  , 46
  , 46
  , 46
  , 46
  , 46
  , 46
  , 46
  , 46
  , 46
  , 46
  , 46
  , 46
  , 46
  , 46
  , 46
  , 46
  , 46
  , 46
  , 46
  , 46
  , 46
  , 46
  , 46
  , 46
  , 46
  , 46
  , 46
  , 46
  , 46
  , 46
  , 46
  , 46
  , 46
  , 46
  , 46
  , 46
  , 46
  , 46
  , 46
  , 46
  , 46
  , 46
  , 46
  , 46
  , 46
  , 46
  , 46
  , 46
  , 46
  , 46
  , 46
  , 46
  , 46
  , 46
  , 46
  , 46
  , 46
  , 46
  , 46
  , 46
  , 46
  , 46
  , 46
  , 46
  , 46
  , 46
  , 46
  , 46
  , 46
  , 46
  , 46
  , 46
  , 46
  , 46
  , 46
  , 46
  , 46
  , 46
  , 46
  , 46
  , 46
  , 46
  , 46
  , 46
  , 46
  , 46
  , 46
  , 46
  , 46
  , 46
  , 46
  , 46
  , 46
  , 46
  , 46
  , 46
  , 46
  , 46
  , 46
  , 46
  , 46
  , 46
  , 46
  , 46
  , 46
  , 46
  , 46
  , 46
  , 46
  , 43
  , 45
  , 45
  , 45
  , 45
  , 45
  , 45
  , 45
  , 45
  , 45
  , 45
  , 45
  , 45
  , 45
  , 45
  , 45
  , 45
  , 45
  , 45
  , 45
  , 45
  , 45
  , 45
  , 45
  , 45
  , 45
  , 45
  , 45
  , 45
  , 45
  , 45
  , 45
  , 45
  , 45
  , 45
  , 45
  , 45
  , 45
  , 45
  , 45
  , 45
  , 45
  , 45
  , 45
  , 45
  , 45
  , 45
  , 45
  , 45
  , 45
  , 45
  , 45
  , 45
  , 45
  , 45
  , 45
  , 45
  , 45
  , 45
  , 45
  , 45
  , 45
  , 45
  , 45
  , 45
  , 45
  , 45
  , 45
  , 45
  , 45
  , 45
  , 45
  , 45
  , 45
  , 45
  , 45
  , 45
  , 45
  , 45
  , 45
  , 45
  , 45
  , 45
  , 45
  , 45
  , 45
  , 45
  , 45
  , 45
  , 45
  , 45
  , 45
  , 45
  , 45
  , 45
  , 45
  , 45
  , 45
  , 45
  , 45
  , 45
  , 45
  , 45
  , 45
  , 45
  , 45
  , 45
  , 45
  , 45
  , 45
  , 45
  , 45
  , 45
  , 45
  , 45
  , 45
  , 45
  , 45
  , 45
  , 45
  , 45
  , 45
  , 45
  , 45
  , 45
  , 45
  , 45
  , 45
  , 11
  , 41
  , 41
  , 41
  , 41
  , 41
  , 41
  , 41
  , 41
  , 41
  , 41
  , 41
  , 41
  , 41
  , 41
  , 41
  , 41
  , 41
  , 41
  , 41
  , 41
  , 41
  , 41
  , 41
  , 41
  , 41
  , 41
  , 41
  , 41
  , 41
  , 41
  , 41
  , 41
  , 41
  , 41
  , 41
  , 41
  , 41
  , 41
  , 41
  , 41
  , 41
  , 41
  , 41
  , 41
  , 41
  , 41
  , 41
  , 41
  , 41
  , 41
  , 41
  , 41
  , 41
  , 41
  , 41
  , 41
  , 41
  , 41
  , 41
  , 41
  , 41
  , 41
  , 41
  , 41
  , 41
  , 41
  , 41
  , 41
  , 41
  , 41
  , 41
  , 41
  , 41
  , 41
  , 41
  , 41
  , 41
  , 41
  , 41
  , 41
  , 41
  , 41
  , 41
  , 41
  , 41
  , 41
  , 41
  , 41
  , 41
  , 41
  , 41
  , 41
  , 41
  , 41
  , 41
  , 41
  , 41
  , 41
  , 41
  , 41
  , 41
  , 41
  , 41
  , 41
  , 41
  , 41
  , 41
  , 41
  , 41
  , 41
  , 41
  , 41
  , 41
  , 41
  , 41
  , 41
  , 41
  , 41
  , 41
  , 41
  , 41
  , 41
  , 41
  , 41
  , 41
  , 41
  , 41
  , 12
  , 38
  , 38
  , 38
  , 38
  , 38
  , 38
  , 38
  , 38
  , 38
  , 38
  , 38
  , 38
  , 38
  , 38
  , 38
  , 38
  , 38
  , 38
  , 38
  , 38
  , 38
  , 38
  , 38
  , 38
  , 38
  , 38
  , 38
  , 38
  , 38
  , 38
  , 38
  , 38
  , 38
  , 38
  , 38
  , 38
  , 38
  , 38
  , 38
  , 38
  , 38
  , 38
  , 38
  , 38
  , 38
  , 38
  , 38
  , 38
  , 38
  , 38
  , 38
  , 38
  , 38
  , 38
  , 38
  , 38
  , 38
  , 38
  , 38
  , 38
  , 38
  , 38
  , 38
  , 38
  , 38
  , 38
  , 38
  , 38
  , 38
  , 38
  , 38
  , 38
  , 38
  , 38
  , 38
  , 38
  , 38
  , 38
  , 38
  , 38
  , 38
  , 38
  , 38
  , 38
  , 38
  , 38
  , 38
  , 38
  , 38
  , 38
  , 38
  , 38
  , 38
  , 38
  , 38
  , 38
  , 38
  , 38
  , 38
  , 38
  , 38
  , 38
  , 38
  , 38
  , 38
  , 38
  , 38
  , 38
  , 38
  , 38
  , 38
  , 38
  , 38
  , 38
  , 38
  , 38
  , 38
  , 38
  , 38
  , 38
  , 38
  , 38
  , 38
  , 38
  , 38
  , 38
  , 38
  , 14
  , 33
  , 33
  , 33
  , 33
  , 33
  , 33
  , 33
  , 33
  , 33
  , 33
  , 33
  , 33
  , 33
  , 33
  , 33
  , 33
  , 33
  , 33
  , 33
  , 33
  , 33
  , 33
  , 33
  , 33
  , 33
  , 33
  , 33
  , 33
  , 33
  , 33
  , 33
  , 33
  , 33
  , 33
  , 33
  , 33
  , 33
  , 33
  , 33
  , 33
  , 33
  , 33
  , 33
  , 33
  , 33
  , 33
  , 33
  , 33
  , 33
  , 33
  , 33
  , 33
  , 33
  , 33
  , 33
  , 33
  , 33
  , 33
  , 33
  , 33
  , 33
  , 33
  , 33
  , 33
  , 33
  , 33
  , 33
  , 33
  , 33
  , 33
  , 33
  , 33
  , 33
  , 33
  , 33
  , 33
  , 33
  , 33
  , 33
  , 33
  , 33
  , 33
  , 33
  , 33
  , 33
  , 33
  , 33
  , 33
  , 33
  , 33
  , 33
  , 33
  , 33
  , 33
  , 33
  , 33
  , 33
  , 33
  , 33
  , 33
  , 33
  , 33
  , 33
  , 33
  , 33
  , 33
  , 33
  , 33
  , 33
  , 33
  , 33
  , 33
  , 33
  , 33
  , 33
  , 33
  , 33
  , 33
  , 33
  , 33
  , 33
  , 33
  , 33
  , 33
  , 33
  , 33
  , 33
  , 29
  , 29
  , 29
  , 29
  , 29
  , 29
  , 29
  , 29
  , 29
  , 29
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 29
  , 29
  , 29
  , 29
  , 29
  , 29
  , 68
  , 0
  , 68
  , 0
  , 0
  , 145
  , 145
  , 145
  , 145
  , 145
  , 145
  , 145
  , 145
  , 145
  , 145
  , 145
  , 145
  , 145
  , 145
  , 145
  , 145
  , 145
  , 145
  , 145
  , 145
  , 0
  , 29
  , 29
  , 29
  , 29
  , 29
  , 29
  , 34
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 37
  , 37
  , 37
  , 37
  , 37
  , 37
  , 37
  , 37
  , 37
  , 37
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 37
  , 37
  , 37
  , 37
  , 37
  , 37
  , 70
  , 0
  , 70
  , 0
  , 0
  , 142
  , 142
  , 142
  , 142
  , 142
  , 142
  , 142
  , 142
  , 142
  , 142
  , 142
  , 142
  , 142
  , 142
  , 142
  , 142
  , 142
  , 142
  , 142
  , 142
  , 0
  , 37
  , 37
  , 37
  , 37
  , 37
  , 37
  , 39
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 40
  , 40
  , 40
  , 40
  , 40
  , 40
  , 40
  , 40
  , 40
  , 40
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 40
  , 40
  , 40
  , 40
  , 40
  , 40
  , 72
  , 0
  , 72
  , 0
  , 0
  , 139
  , 139
  , 139
  , 139
  , 139
  , 139
  , 139
  , 139
  , 139
  , 139
  , 139
  , 139
  , 139
  , 139
  , 139
  , 139
  , 139
  , 139
  , 139
  , 139
  , 0
  , 40
  , 40
  , 40
  , 40
  , 40
  , 40
  , 42
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 44
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 47
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 49
  , 49
  , 49
  , 49
  , 49
  , 49
  , 49
  , 49
  , 49
  , 49
  , 75
  , 75
  , 75
  , 75
  , 75
  , 368
  , 370
  , 49
  , 49
  , 49
  , 49
  , 49
  , 49
  , 141
  , 141
  , 141
  , 141
  , 141
  , 141
  , 141
  , 141
  , 141
  , 141
  , 75
  , 381
  , 0
  , 0
  , 0
  , 385
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 49
  , 49
  , 49
  , 49
  , 49
  , 49
  , 51
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 54
  , 54
  , 54
  , 54
  , 54
  , 54
  , 54
  , 54
  , 54
  , 54
  , 60
  , 0
  , 0
  , 0
  , 0
  , 74
  , 0
  , 54
  , 54
  , 54
  , 54
  , 54
  , 54
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 384
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 54
  , 54
  , 54
  , 54
  , 54
  , 54
  , 57
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 62
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 64
  , 64
  , 64
  , 64
  , 64
  , 64
  , 64
  , 64
  , 64
  , 64
  , 64
  , 0
  , 386
  , 0
  , 0
  , 64
  , 0
  , 64
  , 64
  , 64
  , 64
  , 64
  , 64
  , 0
  , 64
  , 64
  , 64
  , 64
  , 64
  , 64
  , 64
  , 64
  , 0
  , 0
  , 0
  , 138
  , 138
  , 138
  , 138
  , 138
  , 138
  , 138
  , 138
  , 138
  , 138
  , 0
  , 0
  , 0
  , 0
  , 64
  , 64
  , 64
  , 64
  , 64
  , 64
  , 137
  , 71
  , 143
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 64
  , 0
  , 0
  , 0
  , 0
  , 0
  , 64
  , 369
  , 0
  , 0
  , 64
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 64
  , 137
  , 71
  , 143
  , 64
  , 0
  , 64
  , 21
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 3
  , 3
  , 3
  , 3
  , 3
  , 3
  , 3
  , 3
  , 3
  , 3
  , 3
  , 0
  , -1
  , 0
  , 0
  , 3
  , 0
  , 3
  , 3
  , 3
  , 3
  , 3
  , 3
  , 0
  , 5
  , 5
  , 5
  , 5
  , 4
  , 4
  , 4
  , 4
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , -1
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 3
  , 3
  , 3
  , 3
  , 3
  , 3
  , 139
  , 139
  , 139
  , 139
  , 139
  , 139
  , 139
  , 139
  , 139
  , 139
  , 0
  , 0
  , 0
  , 3
  , 0
  , 0
  , 0
  , 0
  , 0
  , 3
  , 137
  , 0
  , 143
  , 3
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 3
  , 0
  , 0
  , 0
  , 3
  , 0
  , 3
  , 22
  , 55
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 137
  , 0
  , 143
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 53
  , 58
  , 58
  , 58
  , 58
  , 58
  , 58
  , 58
  , 58
  , 58
  , 58
  , 58
  , 58
  , 58
  , 58
  , 58
  , 58
  , 58
  , 58
  , 58
  , 58
  , 58
  , 58
  , 58
  , 58
  , 58
  , 58
  , 58
  , 58
  , 57
  , 11
  , 41
  , 41
  , 41
  , 41
  , 41
  , 41
  , 41
  , 41
  , 41
  , 41
  , 41
  , 41
  , 41
  , 41
  , 42
  , 15
  , 30
  , 30
  , 30
  , 31
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 59
  , 59
  , 59
  , 59
  , 59
  , 59
  , 59
  , 59
  , 59
  , 59
  , 1
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 59
  , 59
  , 59
  , 59
  , 59
  , 59
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 65
  , 138
  , 0
  , 131
  , 131
  , 131
  , 131
  , 131
  , 131
  , 131
  , 131
  , 131
  , 131
  , 0
  , 0
  , 0
  , 0
  , 59
  , 59
  , 59
  , 59
  , 59
  , 59
  , 146
  , 67
  , 147
  , 0
  , 0
  , 0
  , 0
  , 0
  , 132
  , 65
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 146
  , 67
  , 147
  , 0
  , 0
  , 0
  , 0
  , 0
  , 132
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 43
  , 45
  , 45
  , 45
  , 45
  , 45
  , 45
  , 45
  , 45
  , 45
  , 45
  , 45
  , 45
  , 45
  , 45
  , 45
  , 45
  , 45
  , 45
  , 45
  , 45
  , 45
  , 45
  , 45
  , 45
  , 45
  , 45
  , 45
  , 45
  , 44
  , 14
  , 33
  , 33
  , 33
  , 33
  , 33
  , 33
  , 33
  , 33
  , 33
  , 33
  , 33
  , 33
  , 33
  , 33
  , 34
  , 17
  , 24
  , 24
  , 24
  , 25
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 0
  , 0
  , 0
  , 0
  , 0
  , 59
  , 0
  , 135
  , 135
  , 135
  , 135
  , 135
  , 135
  , 135
  , 135
  , 135
  , 135
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 154
  , 135
  , 135
  , 135
  , 135
  , 135
  , 135
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 65
  , 138
  , 0
  , 131
  , 131
  , 131
  , 131
  , 131
  , 131
  , 131
  , 131
  , 131
  , 131
  , 0
  , 0
  , 0
  , 0
  , 135
  , 135
  , 135
  , 135
  , 135
  , 135
  , 146
  , 67
  , 147
  , 0
  , 0
  , 0
  , 0
  , 0
  , 130
  , 65
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 50
  , 73
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 146
  , 67
  , 147
  , 0
  , 0
  , 0
  , 0
  , 0
  , 130
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 73
  , 0
  , 0
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 48
  , 52
  , 52
  , 52
  , 52
  , 52
  , 52
  , 52
  , 52
  , 52
  , 52
  , 52
  , 52
  , 52
  , 52
  , 52
  , 52
  , 52
  , 52
  , 52
  , 52
  , 52
  , 52
  , 52
  , 52
  , 52
  , 52
  , 52
  , 52
  , 51
  , 12
  , 38
  , 38
  , 38
  , 38
  , 38
  , 38
  , 38
  , 38
  , 38
  , 38
  , 38
  , 38
  , 38
  , 38
  , 39
  , 16
  , 27
  , 27
  , 27
  , 28
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 76
  , 264
  , 0
  , 77
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 264
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 61
  , 63
  , 63
  , 63
  , 63
  , 63
  , 63
  , 63
  , 63
  , 63
  , 63
  , 63
  , 63
  , 63
  , 63
  , 63
  , 63
  , 63
  , 63
  , 63
  , 63
  , 63
  , 63
  , 63
  , 63
  , 63
  , 63
  , 63
  , 63
  , 62
  , 9
  , 46
  , 46
  , 46
  , 46
  , 46
  , 46
  , 46
  , 46
  , 46
  , 46
  , 46
  , 46
  , 46
  , 46
  , 47
  , 13
  , 35
  , 35
  , 35
  , 36
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 76
  , 264
  , 0
  , 77
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 264
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 61
  , 63
  , 63
  , 63
  , 63
  , 63
  , 63
  , 63
  , 63
  , 63
  , 63
  , 63
  , 63
  , 63
  , 63
  , 63
  , 63
  , 63
  , 63
  , 63
  , 63
  , 63
  , 63
  , 63
  , 63
  , 63
  , 63
  , 63
  , 63
  , 62
  , 9
  , 46
  , 46
  , 46
  , 46
  , 46
  , 46
  , 46
  , 46
  , 46
  , 46
  , 46
  , 46
  , 46
  , 46
  , 47
  , 13
  , 35
  , 35
  , 35
  , 36
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 264
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 264
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 264
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 264
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 264
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 264
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 264
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 264
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 264
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 264
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 264
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 300
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 264
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 264
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 264
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 264
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 264
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 166
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 264
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 264
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 264
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 264
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 264
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 264
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 264
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 264
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 264
  , 0
  , 264
  , 264
  , 264
  , 264
  , 272
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 264
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 264
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 264
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 264
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 264
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 264
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 264
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 264
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 264
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 264
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 264
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 264
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 264
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 264
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 264
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 264
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 264
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 123
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 264
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 264
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 264
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 264
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 264
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 264
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 138
  , 0
  , 133
  , 133
  , 133
  , 133
  , 133
  , 133
  , 133
  , 133
  , 133
  , 133
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 146
  , 67
  , 147
  , 0
  , 0
  , 0
  , 0
  , 59
  , 134
  , 135
  , 135
  , 135
  , 135
  , 135
  , 135
  , 135
  , 135
  , 135
  , 135
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 135
  , 135
  , 135
  , 135
  , 135
  , 135
  , 146
  , 67
  , 147
  , 0
  , 0
  , 136
  , 0
  , 0
  , 134
  , 65
  , 0
  , 0
  , 141
  , 141
  , 141
  , 141
  , 141
  , 141
  , 141
  , 141
  , 141
  , 141
  , 0
  , 0
  , 0
  , 0
  , 135
  , 135
  , 135
  , 135
  , 135
  , 135
  , 140
  , 69
  , 144
  , 0
  , 0
  , 136
  , 0
  , 0
  , 0
  , 65
  , 0
  , 0
  , 0
  , 0
  , 0
  , 142
  , 142
  , 142
  , 142
  , 142
  , 142
  , 142
  , 142
  , 142
  , 142
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 140
  , 69
  , 144
  , 140
  , 0
  , 144
  , 145
  , 145
  , 145
  , 145
  , 145
  , 145
  , 145
  , 145
  , 145
  , 145
  , 149
  , 149
  , 149
  , 149
  , 149
  , 149
  , 149
  , 149
  , 149
  , 149
  , 146
  , 0
  , 147
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 140
  , 148
  , 144
  , 150
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 146
  , 264
  , 147
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 148
  , 0
  , 150
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 264
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 264
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 264
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 264
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 82
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 264
  , 0
  , 264
  , 264
  , 264
  , 264
  , 83
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 264
  , 0
  , 264
  , 264
  , 264
  , 264
  , 84
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 264
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 87
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 264
  , 0
  , 264
  , 264
  , 264
  , 264
  , 89
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 264
  , 0
  , 264
  , 264
  , 264
  , 264
  , 275
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 91
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 264
  , 0
  , 264
  , 264
  , 264
  , 264
  , 92
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 264
  , 0
  , 264
  , 264
  , 264
  , 264
  , 93
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 264
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 94
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 264
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 95
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 264
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 97
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 264
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 100
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 264
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 102
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 264
  , 0
  , 264
  , 264
  , 264
  , 264
  , 106
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 264
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 107
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 264
  , 0
  , 264
  , 264
  , 264
  , 264
  , 108
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 264
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 109
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 264
  , 0
  , 264
  , 264
  , 264
  , 264
  , 110
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 264
  , 0
  , 264
  , 264
  , 264
  , 264
  , 111
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 264
  , 0
  , 264
  , 264
  , 113
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 264
  , 0
  , 264
  , 264
  , 116
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 264
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 121
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 264
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 122
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 264
  , 0
  , 269
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 182
  , 264
  , 264
  , 264
  , 125
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 264
  , 0
  , 264
  , 264
  , 264
  , 264
  , 127
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 264
  , 0
  , 264
  , 264
  , 264
  , 264
  , 128
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 264
  , 0
  , 264
  , 264
  , 264
  , 264
  , 151
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 264
  , 0
  , 264
  , 264
  , 264
  , 264
  , 152
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 264
  , 0
  , 264
  , 264
  , 345
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 264
  , 0
  , 343
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 264
  , 0
  , 156
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 264
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 158
  , 188
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 264
  , 0
  , 264
  , 264
  , 342
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 264
  , 0
  , 341
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 264
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 159
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 264
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 340
  , 236
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 264
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 160
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 264
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 163
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 264
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 164
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 264
  , 0
  , 338
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 264
  , 0
  , 337
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 264
  , 0
  , 288
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 297
  , 264
  , 264
  , 220
  , 264
  , 264
  , 336
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 264
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 333
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 264
  , 0
  , 264
  , 264
  , 169
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 264
  , 0
  , 283
  , 264
  , 264
  , 264
  , 172
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 303
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 264
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 173
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 264
  , 0
  , 264
  , 264
  , 264
  , 264
  , 331
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 264
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 175
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 264
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 176
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 264
  , 0
  , 264
  , 264
  , 264
  , 264
  , 327
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 264
  , 0
  , 264
  , 264
  , 326
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 264
  , 0
  , 264
  , 264
  , 264
  , 264
  , 325
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 264
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 177
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 209
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 264
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 178
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 264
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 323
  , 264
  , 264
  , 258
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 264
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 183
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 264
  , 0
  , 184
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 264
  , 0
  , 264
  , 264
  , 264
  , 264
  , 321
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 264
  , 0
  , 264
  , 264
  , 264
  , 264
  , 185
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 264
  , 0
  , 264
  , 264
  , 264
  , 264
  , 186
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 264
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 249
  , 264
  , 264
  , 215
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 320
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 264
  , 0
  , 187
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 189
  , 264
  , 264
  , 264
  , 218
  , 264
  , 264
  , 302
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 264
  , 0
  , 190
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 264
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 319
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 264
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 196
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 264
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 316
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 264
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 260
  , 264
  , 264
  , 314
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 264
  , 0
  , 264
  , 264
  , 264
  , 264
  , 198
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 264
  , 0
  , 199
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 264
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 313
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 264
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 312
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 264
  , 0
  , 201
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 264
  , 0
  , 311
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 264
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 310
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 264
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 309
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 264
  , 0
  , 264
  , 264
  , 264
  , 264
  , 307
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 264
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 210
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 264
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 305
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 264
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 304
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 264
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 213
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 264
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 301
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 264
  , 0
  , 219
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 264
  , 0
  , 264
  , 264
  , 264
  , 264
  , 298
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 264
  , 0
  , 264
  , 264
  , 264
  , 264
  , 296
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 264
  , 0
  , 264
  , 264
  , 223
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 264
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 227
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 264
  , 0
  , 264
  , 264
  , 295
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 264
  , 0
  , 293
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 256
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 264
  , 0
  , 264
  , 264
  , 292
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 264
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 290
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 264
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 289
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 264
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 231
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 264
  , 0
  , 264
  , 259
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 235
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 264
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 286
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 264
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 239
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 264
  , 0
  , 264
  , 264
  , 241
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 264
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 282
  , 264
  , 264
  , 264
  , 264
  , 264
  , 270
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 264
  , 0
  , 264
  , 264
  , 264
  , 264
  , 242
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 264
  , 0
  , 251
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 252
  , 264
  , 264
  , 281
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 264
  , 0
  , 264
  , 264
  , 264
  , 264
  , 280
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 264
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 244
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 264
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 247
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 264
  , 0
  , 278
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 264
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 276
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 264
  , 0
  , 264
  , 264
  , 264
  , 264
  , 250
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 264
  , 0
  , 273
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 264
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 271
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 264
  , 0
  , 264
  , 264
  , 266
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 264
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 264
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 263
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 264
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 267
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 264
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 262
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 264
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 261
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 264
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 257
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 264
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 253
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 264
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 246
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 264
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 284
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 264
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 240
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 264
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 238
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 264
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 237
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 264
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 287
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 264
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 234
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 264
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 233
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 264
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 230
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 243
  , 291
  , 264
  , 245
  , 264
  , 265
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 264
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 229
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 264
  , 0
  , 264
  , 294
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 264
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 228
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 264
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 226
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 264
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 224
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 264
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 222
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 264
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 214
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 264
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 212
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 264
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 211
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 264
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 207
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 264
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 206
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 264
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 205
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 264
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 308
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 264
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 204
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 264
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 203
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 264
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 202
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 264
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 315
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 264
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 195
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 264
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 317
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 264
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 193
  , 264
  , 194
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 274
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 264
  , 0
  , 264
  , 318
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 264
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 192
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 264
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 191
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 264
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 322
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 264
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 181
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 264
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 180
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 264
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 208
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 179
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 264
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 324
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 264
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 328
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 264
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 329
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 264
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 330
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 264
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 174
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 264
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 171
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 264
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 170
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 264
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 334
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 264
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 168
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 264
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 167
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 264
  , 0
  , 264
  , 264
  , 264
  , 165
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 264
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 162
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 264
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 339
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 264
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 157
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 264
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 344
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 264
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 155
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 264
  , 0
  , 264
  , 264
  , 264
  , 126
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 264
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 124
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 264
  , 0
  , 264
  , 264
  , 264
  , 120
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 264
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 119
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 264
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 118
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 264
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 117
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 264
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 115
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 264
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 114
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 264
  , 0
  , 264
  , 264
  , 264
  , 112
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 264
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 268
  , 105
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 264
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 104
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 264
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 103
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 264
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 101
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 285
  , 332
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 264
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 99
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 264
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 98
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 264
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 96
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 264
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 90
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 264
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 88
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 264
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 86
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 264
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 85
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 264
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 81
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 264
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 80
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 264
  , 0
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 79
  , 264
  , 264
  , 264
  , 264
  , 264
  , 264
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  , 0
  ]

alex_check :: Array Int Int
alex_check = listArray (0 :: Int, 25702)
  [ -1
  , 9
  , 10
  , 11
  , 12
  , 13
  , 101
  , 39
  , 61
  , 62
  , 61
  , 99
  , 97
  , 110
  , 101
  , 116
  , 114
  , 61
  , 102
  , 61
  , 62
  , 60
  , 61
  , 61
  , 32
  , 33
  , 34
  , 58
  , 36
  , 37
  , 38
  , 39
  , 40
  , 41
  , 42
  , 43
  , 44
  , 45
  , 46
  , 47
  , 48
  , 49
  , 50
  , 51
  , 52
  , 53
  , 54
  , 55
  , 56
  , 57
  , 58
  , 59
  , 60
  , 61
  , 62
  , 63
  , 64
  , 65
  , 66
  , 67
  , 68
  , 69
  , 70
  , 71
  , 72
  , 73
  , 74
  , 75
  , 76
  , 77
  , 78
  , 79
  , 80
  , 81
  , 82
  , 83
  , 84
  , 85
  , 86
  , 87
  , 88
  , 89
  , 90
  , 91
  , 61
  , 93
  , 94
  , 95
  , 61
  , 97
  , 98
  , 99
  , 100
  , 101
  , 102
  , 103
  , 104
  , 105
  , 106
  , 107
  , 108
  , 109
  , 110
  , 111
  , 112
  , 113
  , 114
  , 115
  , 116
  , 117
  , 118
  , 119
  , 120
  , 121
  , 122
  , 123
  , 124
  , 125
  , 126
  , 42
  , 39
  , 61
  , 61
  , 105
  , 47
  , -1
  , -1
  , -1
  , 39
  , 48
  , 49
  , 50
  , 51
  , 52
  , 53
  , 54
  , 55
  , 48
  , 49
  , 50
  , 51
  , 52
  , 53
  , 54
  , 55
  , 48
  , 49
  , 50
  , 51
  , 52
  , 53
  , 54
  , 55
  , 56
  , 57
  , 45
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 65
  , 66
  , 67
  , 68
  , 69
  , 70
  , 43
  , -1
  , 45
  , 61
  , 62
  , 48
  , 49
  , 50
  , 51
  , 52
  , 53
  , 54
  , 55
  , 56
  , 57
  , 48
  , 49
  , 50
  , 51
  , 52
  , 53
  , 54
  , 55
  , 56
  , 57
  , -1
  , 97
  , 98
  , 99
  , 100
  , 101
  , 102
  , -1
  , -1
  , -1
  , -1
  , -1
  , 128
  , 129
  , 130
  , 131
  , 132
  , 133
  , 134
  , 135
  , 136
  , 137
  , 138
  , 139
  , 140
  , 141
  , 142
  , 143
  , 144
  , 145
  , 146
  , 147
  , 148
  , 149
  , 150
  , 151
  , 152
  , 153
  , 154
  , 155
  , 156
  , 157
  , 158
  , 159
  , 160
  , 161
  , 162
  , 163
  , 164
  , 165
  , 166
  , 167
  , 168
  , 169
  , 170
  , 171
  , 172
  , 173
  , 174
  , 175
  , 176
  , 177
  , 178
  , 179
  , 180
  , 181
  , 182
  , 183
  , 184
  , 185
  , 186
  , 187
  , 188
  , 189
  , 190
  , 191
  , 192
  , 193
  , 194
  , 195
  , 196
  , 197
  , 198
  , 199
  , 200
  , 201
  , 202
  , 203
  , 204
  , 205
  , 206
  , 207
  , 208
  , 209
  , 210
  , 211
  , 212
  , 213
  , 214
  , 215
  , 216
  , 217
  , 218
  , 219
  , 220
  , 221
  , 222
  , 223
  , 224
  , 225
  , 226
  , 227
  , 228
  , 229
  , 230
  , 231
  , 232
  , 233
  , 234
  , 235
  , 236
  , 237
  , 238
  , 239
  , 240
  , 241
  , 242
  , 243
  , 244
  , 245
  , 246
  , 247
  , 248
  , 249
  , 250
  , 251
  , 252
  , 253
  , 254
  , 255
  , 128
  , 129
  , 130
  , 131
  , 132
  , 133
  , 134
  , 135
  , 136
  , 137
  , 138
  , 139
  , 140
  , 141
  , 142
  , 143
  , 144
  , 145
  , 146
  , 147
  , 148
  , 149
  , 150
  , 151
  , 152
  , 153
  , 154
  , 155
  , 156
  , 157
  , 158
  , 159
  , 160
  , 161
  , 162
  , 163
  , 164
  , 165
  , 166
  , 167
  , 168
  , 169
  , 170
  , 171
  , 172
  , 173
  , 174
  , 175
  , 176
  , 177
  , 178
  , 179
  , 180
  , 181
  , 182
  , 183
  , 184
  , 185
  , 186
  , 187
  , 188
  , 189
  , 190
  , 191
  , 192
  , 193
  , 194
  , 195
  , 196
  , 197
  , 198
  , 199
  , 200
  , 201
  , 202
  , 203
  , 204
  , 205
  , 206
  , 207
  , 208
  , 209
  , 210
  , 211
  , 212
  , 213
  , 214
  , 215
  , 216
  , 217
  , 218
  , 219
  , 220
  , 221
  , 222
  , 223
  , 224
  , 225
  , 226
  , 227
  , 228
  , 229
  , 230
  , 231
  , 232
  , 233
  , 234
  , 235
  , 236
  , 237
  , 238
  , 239
  , 240
  , 241
  , 242
  , 243
  , 244
  , 245
  , 246
  , 247
  , 248
  , 249
  , 250
  , 251
  , 252
  , 253
  , 254
  , 255
  , 128
  , 129
  , 130
  , 131
  , 132
  , 133
  , 134
  , 135
  , 136
  , 137
  , 138
  , 139
  , 140
  , 141
  , 142
  , 143
  , 144
  , 145
  , 146
  , 147
  , 148
  , 149
  , 150
  , 151
  , 152
  , 153
  , 154
  , 155
  , 156
  , 157
  , 158
  , 159
  , 160
  , 161
  , 162
  , 163
  , 164
  , 165
  , 166
  , 167
  , 168
  , 169
  , 170
  , 171
  , 172
  , 173
  , 174
  , 175
  , 176
  , 177
  , 178
  , 179
  , 180
  , 181
  , 182
  , 183
  , 184
  , 185
  , 186
  , 187
  , 188
  , 189
  , 190
  , 191
  , 192
  , 193
  , 194
  , 195
  , 196
  , 197
  , 198
  , 199
  , 200
  , 201
  , 202
  , 203
  , 204
  , 205
  , 206
  , 207
  , 208
  , 209
  , 210
  , 211
  , 212
  , 213
  , 214
  , 215
  , 216
  , 217
  , 218
  , 219
  , 220
  , 221
  , 222
  , 223
  , 224
  , 225
  , 226
  , 227
  , 228
  , 229
  , 230
  , 231
  , 232
  , 233
  , 234
  , 235
  , 236
  , 237
  , 238
  , 239
  , 240
  , 241
  , 242
  , 243
  , 244
  , 245
  , 246
  , 247
  , 248
  , 249
  , 250
  , 251
  , 252
  , 253
  , 254
  , 255
  , 128
  , 129
  , 130
  , 131
  , 132
  , 133
  , 134
  , 135
  , 136
  , 137
  , 138
  , 139
  , 140
  , 141
  , 142
  , 143
  , 144
  , 145
  , 146
  , 147
  , 148
  , 149
  , 150
  , 151
  , 152
  , 153
  , 154
  , 155
  , 156
  , 157
  , 158
  , 159
  , 160
  , 161
  , 162
  , 163
  , 164
  , 165
  , 166
  , 167
  , 168
  , 169
  , 170
  , 171
  , 172
  , 173
  , 174
  , 175
  , 176
  , 177
  , 178
  , 179
  , 180
  , 181
  , 182
  , 183
  , 184
  , 185
  , 186
  , 187
  , 188
  , 189
  , 190
  , 191
  , 192
  , 193
  , 194
  , 195
  , 196
  , 197
  , 198
  , 199
  , 200
  , 201
  , 202
  , 203
  , 204
  , 205
  , 206
  , 207
  , 208
  , 209
  , 210
  , 211
  , 212
  , 213
  , 214
  , 215
  , 216
  , 217
  , 218
  , 219
  , 220
  , 221
  , 222
  , 223
  , 224
  , 225
  , 226
  , 227
  , 228
  , 229
  , 230
  , 231
  , 232
  , 233
  , 234
  , 235
  , 236
  , 237
  , 238
  , 239
  , 240
  , 241
  , 242
  , 243
  , 244
  , 245
  , 246
  , 247
  , 248
  , 249
  , 250
  , 251
  , 252
  , 253
  , 254
  , 255
  , 128
  , 129
  , 130
  , 131
  , 132
  , 133
  , 134
  , 135
  , 136
  , 137
  , 138
  , 139
  , 140
  , 141
  , 142
  , 143
  , 144
  , 145
  , 146
  , 147
  , 148
  , 149
  , 150
  , 151
  , 152
  , 153
  , 154
  , 155
  , 156
  , 157
  , 158
  , 159
  , 160
  , 161
  , 162
  , 163
  , 164
  , 165
  , 166
  , 167
  , 168
  , 169
  , 170
  , 171
  , 172
  , 173
  , 174
  , 175
  , 176
  , 177
  , 178
  , 179
  , 180
  , 181
  , 182
  , 183
  , 184
  , 185
  , 186
  , 187
  , 188
  , 189
  , 190
  , 191
  , 192
  , 193
  , 194
  , 195
  , 196
  , 197
  , 198
  , 199
  , 200
  , 201
  , 202
  , 203
  , 204
  , 205
  , 206
  , 207
  , 208
  , 209
  , 210
  , 211
  , 212
  , 213
  , 214
  , 215
  , 216
  , 217
  , 218
  , 219
  , 220
  , 221
  , 222
  , 223
  , 224
  , 225
  , 226
  , 227
  , 228
  , 229
  , 230
  , 231
  , 232
  , 233
  , 234
  , 235
  , 236
  , 237
  , 238
  , 239
  , 240
  , 241
  , 242
  , 243
  , 244
  , 245
  , 246
  , 247
  , 248
  , 249
  , 250
  , 251
  , 252
  , 253
  , 254
  , 255
  , 128
  , 129
  , 130
  , 131
  , 132
  , 133
  , 134
  , 135
  , 136
  , 137
  , 138
  , 139
  , 140
  , 141
  , 142
  , 143
  , 144
  , 145
  , 146
  , 147
  , 148
  , 149
  , 150
  , 151
  , 152
  , 153
  , 154
  , 155
  , 156
  , 157
  , 158
  , 159
  , 160
  , 161
  , 162
  , 163
  , 164
  , 165
  , 166
  , 167
  , 168
  , 169
  , 170
  , 171
  , 172
  , 173
  , 174
  , 175
  , 176
  , 177
  , 178
  , 179
  , 180
  , 181
  , 182
  , 183
  , 184
  , 185
  , 186
  , 187
  , 188
  , 189
  , 190
  , 191
  , 192
  , 193
  , 194
  , 195
  , 196
  , 197
  , 198
  , 199
  , 200
  , 201
  , 202
  , 203
  , 204
  , 205
  , 206
  , 207
  , 208
  , 209
  , 210
  , 211
  , 212
  , 213
  , 214
  , 215
  , 216
  , 217
  , 218
  , 219
  , 220
  , 221
  , 222
  , 223
  , 224
  , 225
  , 226
  , 227
  , 228
  , 229
  , 230
  , 231
  , 232
  , 233
  , 234
  , 235
  , 236
  , 237
  , 238
  , 239
  , 240
  , 241
  , 242
  , 243
  , 244
  , 245
  , 246
  , 247
  , 248
  , 249
  , 250
  , 251
  , 252
  , 253
  , 254
  , 255
  , 128
  , 129
  , 130
  , 131
  , 132
  , 133
  , 134
  , 135
  , 136
  , 137
  , 138
  , 139
  , 140
  , 141
  , 142
  , 143
  , 144
  , 145
  , 146
  , 147
  , 148
  , 149
  , 150
  , 151
  , 152
  , 153
  , 154
  , 155
  , 156
  , 157
  , 158
  , 159
  , 160
  , 161
  , 162
  , 163
  , 164
  , 165
  , 166
  , 167
  , 168
  , 169
  , 170
  , 171
  , 172
  , 173
  , 174
  , 175
  , 176
  , 177
  , 178
  , 179
  , 180
  , 181
  , 182
  , 183
  , 184
  , 185
  , 186
  , 187
  , 188
  , 189
  , 190
  , 191
  , 192
  , 193
  , 194
  , 195
  , 196
  , 197
  , 198
  , 199
  , 200
  , 201
  , 202
  , 203
  , 204
  , 205
  , 206
  , 207
  , 208
  , 209
  , 210
  , 211
  , 212
  , 213
  , 214
  , 215
  , 216
  , 217
  , 218
  , 219
  , 220
  , 221
  , 222
  , 223
  , 224
  , 225
  , 226
  , 227
  , 228
  , 229
  , 230
  , 231
  , 232
  , 233
  , 234
  , 235
  , 236
  , 237
  , 238
  , 239
  , 240
  , 241
  , 242
  , 243
  , 244
  , 245
  , 246
  , 247
  , 248
  , 249
  , 250
  , 251
  , 252
  , 253
  , 254
  , 255
  , 128
  , 129
  , 130
  , 131
  , 132
  , 133
  , 134
  , 135
  , 136
  , 137
  , 138
  , 139
  , 140
  , 141
  , 142
  , 143
  , 144
  , 145
  , 146
  , 147
  , 148
  , 149
  , 150
  , 151
  , 152
  , 153
  , 154
  , 155
  , 156
  , 157
  , 158
  , 159
  , 160
  , 161
  , 162
  , 163
  , 164
  , 165
  , 166
  , 167
  , 168
  , 169
  , 170
  , 171
  , 172
  , 173
  , 174
  , 175
  , 176
  , 177
  , 178
  , 179
  , 180
  , 181
  , 182
  , 183
  , 184
  , 185
  , 186
  , 187
  , 188
  , 189
  , 190
  , 191
  , 192
  , 193
  , 194
  , 195
  , 196
  , 197
  , 198
  , 199
  , 200
  , 201
  , 202
  , 203
  , 204
  , 205
  , 206
  , 207
  , 208
  , 209
  , 210
  , 211
  , 212
  , 213
  , 214
  , 215
  , 216
  , 217
  , 218
  , 219
  , 220
  , 221
  , 222
  , 223
  , 224
  , 225
  , 226
  , 227
  , 228
  , 229
  , 230
  , 231
  , 232
  , 233
  , 234
  , 235
  , 236
  , 237
  , 238
  , 239
  , 240
  , 241
  , 242
  , 243
  , 244
  , 245
  , 246
  , 247
  , 248
  , 249
  , 250
  , 251
  , 252
  , 253
  , 254
  , 255
  , 128
  , 129
  , 130
  , 131
  , 132
  , 133
  , 134
  , 135
  , 136
  , 137
  , 138
  , 139
  , 140
  , 141
  , 142
  , 143
  , 144
  , 145
  , 146
  , 147
  , 148
  , 149
  , 150
  , 151
  , 152
  , 153
  , 154
  , 155
  , 156
  , 157
  , 158
  , 159
  , 160
  , 161
  , 162
  , 163
  , 164
  , 165
  , 166
  , 167
  , 168
  , 169
  , 170
  , 171
  , 172
  , 173
  , 174
  , 175
  , 176
  , 177
  , 178
  , 179
  , 180
  , 181
  , 182
  , 183
  , 184
  , 185
  , 186
  , 187
  , 188
  , 189
  , 190
  , 191
  , 192
  , 193
  , 194
  , 195
  , 196
  , 197
  , 198
  , 199
  , 200
  , 201
  , 202
  , 203
  , 204
  , 205
  , 206
  , 207
  , 208
  , 209
  , 210
  , 211
  , 212
  , 213
  , 214
  , 215
  , 216
  , 217
  , 218
  , 219
  , 220
  , 221
  , 222
  , 223
  , 224
  , 225
  , 226
  , 227
  , 228
  , 229
  , 230
  , 231
  , 232
  , 233
  , 234
  , 235
  , 236
  , 237
  , 238
  , 239
  , 240
  , 241
  , 242
  , 243
  , 244
  , 245
  , 246
  , 247
  , 248
  , 249
  , 250
  , 251
  , 252
  , 253
  , 254
  , 255
  , 48
  , 49
  , 50
  , 51
  , 52
  , 53
  , 54
  , 55
  , 56
  , 57
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 65
  , 66
  , 67
  , 68
  , 69
  , 70
  , 43
  , -1
  , 45
  , -1
  , -1
  , 48
  , 49
  , 50
  , 51
  , 52
  , 53
  , 54
  , 55
  , 56
  , 57
  , 48
  , 49
  , 50
  , 51
  , 52
  , 53
  , 54
  , 55
  , 56
  , 57
  , -1
  , 97
  , 98
  , 99
  , 100
  , 101
  , 102
  , 143
  , 144
  , 145
  , 146
  , 147
  , 148
  , 149
  , 150
  , 151
  , 152
  , 153
  , 154
  , 155
  , 156
  , 157
  , 158
  , 159
  , 160
  , 161
  , 162
  , 163
  , 164
  , 165
  , 166
  , 167
  , 168
  , 169
  , 170
  , 171
  , 172
  , 173
  , 174
  , 175
  , 176
  , 177
  , 178
  , 179
  , 180
  , 181
  , 182
  , 183
  , 184
  , 185
  , 186
  , 187
  , 188
  , 189
  , 190
  , 191
  , 192
  , 193
  , 194
  , 195
  , 196
  , 197
  , 198
  , 199
  , 200
  , 201
  , 202
  , 203
  , 204
  , 205
  , 206
  , 207
  , 208
  , 209
  , 210
  , 211
  , 212
  , 213
  , 214
  , 215
  , 216
  , 217
  , 218
  , 219
  , 220
  , 221
  , 222
  , 223
  , 224
  , 225
  , 226
  , 227
  , 228
  , 229
  , 230
  , 231
  , 232
  , 233
  , 234
  , 235
  , 236
  , 237
  , 238
  , 239
  , 240
  , 241
  , 242
  , 243
  , 244
  , 245
  , 246
  , 247
  , 248
  , 249
  , 250
  , 251
  , 252
  , 253
  , 254
  , 255
  , 48
  , 49
  , 50
  , 51
  , 52
  , 53
  , 54
  , 55
  , 56
  , 57
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 65
  , 66
  , 67
  , 68
  , 69
  , 70
  , 43
  , -1
  , 45
  , -1
  , -1
  , 48
  , 49
  , 50
  , 51
  , 52
  , 53
  , 54
  , 55
  , 56
  , 57
  , 48
  , 49
  , 50
  , 51
  , 52
  , 53
  , 54
  , 55
  , 56
  , 57
  , -1
  , 97
  , 98
  , 99
  , 100
  , 101
  , 102
  , 143
  , 144
  , 145
  , 146
  , 147
  , 148
  , 149
  , 150
  , 151
  , 152
  , 153
  , 154
  , 155
  , 156
  , 157
  , 158
  , 159
  , 160
  , 161
  , 162
  , 163
  , 164
  , 165
  , 166
  , 167
  , 168
  , 169
  , 170
  , 171
  , 172
  , 173
  , 174
  , 175
  , 176
  , 177
  , 178
  , 179
  , 180
  , 181
  , 182
  , 183
  , 184
  , 185
  , 186
  , 187
  , 188
  , 189
  , 190
  , 191
  , 192
  , 193
  , 194
  , 195
  , 196
  , 197
  , 198
  , 199
  , 200
  , 201
  , 202
  , 203
  , 204
  , 205
  , 206
  , 207
  , 208
  , 209
  , 210
  , 211
  , 212
  , 213
  , 214
  , 215
  , 216
  , 217
  , 218
  , 219
  , 220
  , 221
  , 222
  , 223
  , 224
  , 225
  , 226
  , 227
  , 228
  , 229
  , 230
  , 231
  , 232
  , 233
  , 234
  , 235
  , 236
  , 237
  , 238
  , 239
  , 240
  , 241
  , 242
  , 243
  , 244
  , 245
  , 246
  , 247
  , 248
  , 249
  , 250
  , 251
  , 252
  , 253
  , 254
  , 255
  , 48
  , 49
  , 50
  , 51
  , 52
  , 53
  , 54
  , 55
  , 56
  , 57
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 65
  , 66
  , 67
  , 68
  , 69
  , 70
  , 43
  , -1
  , 45
  , -1
  , -1
  , 48
  , 49
  , 50
  , 51
  , 52
  , 53
  , 54
  , 55
  , 56
  , 57
  , 48
  , 49
  , 50
  , 51
  , 52
  , 53
  , 54
  , 55
  , 56
  , 57
  , -1
  , 97
  , 98
  , 99
  , 100
  , 101
  , 102
  , 143
  , 144
  , 145
  , 146
  , 147
  , 148
  , 149
  , 150
  , 151
  , 152
  , 153
  , 154
  , 155
  , 156
  , 157
  , 158
  , 159
  , 160
  , 161
  , 162
  , 163
  , 164
  , 165
  , 166
  , 167
  , 168
  , 169
  , 170
  , 171
  , 172
  , 173
  , 174
  , 175
  , 176
  , 177
  , 178
  , 179
  , 180
  , 181
  , 182
  , 183
  , 184
  , 185
  , 186
  , 187
  , 188
  , 189
  , 190
  , 191
  , 192
  , 193
  , 194
  , 195
  , 196
  , 197
  , 198
  , 199
  , 200
  , 201
  , 202
  , 203
  , 204
  , 205
  , 206
  , 207
  , 208
  , 209
  , 210
  , 211
  , 212
  , 213
  , 214
  , 215
  , 216
  , 217
  , 218
  , 219
  , 220
  , 221
  , 222
  , 223
  , 224
  , 225
  , 226
  , 227
  , 228
  , 229
  , 230
  , 231
  , 232
  , 233
  , 234
  , 235
  , 236
  , 237
  , 238
  , 239
  , 240
  , 241
  , 242
  , 243
  , 244
  , 245
  , 246
  , 247
  , 248
  , 249
  , 250
  , 251
  , 252
  , 253
  , 254
  , 255
  , 191
  , 192
  , 193
  , 194
  , 195
  , 196
  , 197
  , 198
  , 199
  , 200
  , 201
  , 202
  , 203
  , 204
  , 205
  , 206
  , 207
  , 208
  , 209
  , 210
  , 211
  , 212
  , 213
  , 214
  , 215
  , 216
  , 217
  , 218
  , 219
  , 220
  , 221
  , 222
  , 223
  , 224
  , 225
  , 226
  , 227
  , 228
  , 229
  , 230
  , 231
  , 232
  , 233
  , 234
  , 235
  , 236
  , 237
  , 238
  , 239
  , 240
  , 241
  , 242
  , 243
  , 244
  , 245
  , 246
  , 247
  , 248
  , 249
  , 250
  , 251
  , 252
  , 253
  , 254
  , 255
  , 143
  , 144
  , 145
  , 146
  , 147
  , 148
  , 149
  , 150
  , 151
  , 152
  , 153
  , 154
  , 155
  , 156
  , 157
  , 158
  , 159
  , 160
  , 161
  , 162
  , 163
  , 164
  , 165
  , 166
  , 167
  , 168
  , 169
  , 170
  , 171
  , 172
  , 173
  , 174
  , 175
  , 176
  , 177
  , 178
  , 179
  , 180
  , 181
  , 182
  , 183
  , 184
  , 185
  , 186
  , 187
  , 188
  , 189
  , 190
  , 191
  , 192
  , 193
  , 194
  , 195
  , 196
  , 197
  , 198
  , 199
  , 200
  , 201
  , 202
  , 203
  , 204
  , 205
  , 206
  , 207
  , 208
  , 209
  , 210
  , 211
  , 212
  , 213
  , 214
  , 215
  , 216
  , 217
  , 218
  , 219
  , 220
  , 221
  , 222
  , 223
  , 224
  , 225
  , 226
  , 227
  , 228
  , 229
  , 230
  , 231
  , 232
  , 233
  , 234
  , 235
  , 236
  , 237
  , 238
  , 239
  , 240
  , 241
  , 242
  , 243
  , 244
  , 245
  , 246
  , 247
  , 248
  , 249
  , 250
  , 251
  , 252
  , 253
  , 254
  , 255
  , 48
  , 49
  , 50
  , 51
  , 52
  , 53
  , 54
  , 55
  , 56
  , 57
  , 9
  , 10
  , 11
  , 12
  , 13
  , 38
  , 43
  , 65
  , 66
  , 67
  , 68
  , 69
  , 70
  , 48
  , 49
  , 50
  , 51
  , 52
  , 53
  , 54
  , 55
  , 56
  , 57
  , 32
  , 61
  , -1
  , -1
  , -1
  , 61
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 97
  , 98
  , 99
  , 100
  , 101
  , 102
  , 191
  , 192
  , 193
  , 194
  , 195
  , 196
  , 197
  , 198
  , 199
  , 200
  , 201
  , 202
  , 203
  , 204
  , 205
  , 206
  , 207
  , 208
  , 209
  , 210
  , 211
  , 212
  , 213
  , 214
  , 215
  , 216
  , 217
  , 218
  , 219
  , 220
  , 221
  , 222
  , 223
  , 224
  , 225
  , 226
  , 227
  , 228
  , 229
  , 230
  , 231
  , 232
  , 233
  , 234
  , 235
  , 236
  , 237
  , 238
  , 239
  , 240
  , 241
  , 242
  , 243
  , 244
  , 245
  , 246
  , 247
  , 248
  , 249
  , 250
  , 251
  , 252
  , 253
  , 254
  , 255
  , 48
  , 49
  , 50
  , 51
  , 52
  , 53
  , 54
  , 55
  , 56
  , 57
  , 42
  , -1
  , -1
  , -1
  , -1
  , 47
  , -1
  , 65
  , 66
  , 67
  , 68
  , 69
  , 70
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 61
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 97
  , 98
  , 99
  , 100
  , 101
  , 102
  , 191
  , 192
  , 193
  , 194
  , 195
  , 196
  , 197
  , 198
  , 199
  , 200
  , 201
  , 202
  , 203
  , 204
  , 205
  , 206
  , 207
  , 208
  , 209
  , 210
  , 211
  , 212
  , 213
  , 214
  , 215
  , 216
  , 217
  , 218
  , 219
  , 220
  , 221
  , 222
  , 223
  , 224
  , 225
  , 226
  , 227
  , 228
  , 229
  , 230
  , 231
  , 232
  , 233
  , 234
  , 235
  , 236
  , 237
  , 238
  , 239
  , 240
  , 241
  , 242
  , 243
  , 244
  , 245
  , 246
  , 247
  , 248
  , 249
  , 250
  , 251
  , 252
  , 253
  , 254
  , 255
  , 0
  , 1
  , 2
  , 3
  , 4
  , 5
  , 6
  , 7
  , 8
  , 9
  , 10
  , 11
  , 12
  , 13
  , 14
  , 15
  , 16
  , 17
  , 18
  , 19
  , 20
  , 21
  , 22
  , 23
  , 24
  , 25
  , 26
  , 27
  , 28
  , 29
  , 30
  , 31
  , 32
  , 33
  , 34
  , 35
  , 36
  , 37
  , 38
  , 39
  , 40
  , 41
  , 42
  , 43
  , 44
  , 45
  , 46
  , 47
  , 48
  , 49
  , 50
  , 51
  , 52
  , 53
  , 54
  , 55
  , 56
  , 57
  , 58
  , 59
  , 60
  , 61
  , 62
  , 63
  , 64
  , 65
  , 66
  , 67
  , 68
  , 69
  , 70
  , 71
  , 72
  , 73
  , 74
  , 75
  , 76
  , 77
  , 78
  , 79
  , 80
  , 81
  , 82
  , 83
  , 84
  , 85
  , 86
  , 87
  , 88
  , 89
  , 90
  , 91
  , 92
  , 93
  , 94
  , 95
  , 96
  , 97
  , 98
  , 99
  , 100
  , 101
  , 102
  , 103
  , 104
  , 105
  , 106
  , 107
  , 108
  , 109
  , 110
  , 111
  , 112
  , 113
  , 114
  , 115
  , 116
  , 117
  , 118
  , 119
  , 120
  , 121
  , 122
  , 123
  , 124
  , 125
  , 126
  , 127
  , 192
  , 193
  , 194
  , 195
  , 196
  , 197
  , 198
  , 199
  , 200
  , 201
  , 202
  , 203
  , 204
  , 205
  , 206
  , 207
  , 208
  , 209
  , 210
  , 211
  , 212
  , 213
  , 214
  , 215
  , 216
  , 217
  , 218
  , 219
  , 220
  , 221
  , 222
  , 223
  , 224
  , 225
  , 226
  , 227
  , 228
  , 229
  , 230
  , 231
  , 232
  , 233
  , 234
  , 235
  , 236
  , 237
  , 238
  , 239
  , 240
  , 241
  , 242
  , 243
  , 244
  , 245
  , 246
  , 247
  , 248
  , 249
  , 250
  , 251
  , 252
  , 253
  , 254
  , 255
  , 191
  , 192
  , 193
  , 194
  , 195
  , 196
  , 197
  , 198
  , 199
  , 200
  , 201
  , 202
  , 203
  , 204
  , 205
  , 206
  , 207
  , 208
  , 209
  , 210
  , 211
  , 212
  , 213
  , 214
  , 215
  , 216
  , 217
  , 218
  , 219
  , 220
  , 221
  , 222
  , 223
  , 224
  , 225
  , 226
  , 227
  , 228
  , 229
  , 230
  , 231
  , 232
  , 233
  , 234
  , 235
  , 236
  , 237
  , 238
  , 239
  , 240
  , 241
  , 242
  , 243
  , 244
  , 245
  , 246
  , 247
  , 248
  , 249
  , 250
  , 251
  , 252
  , 253
  , 254
  , 255
  , 0
  , 1
  , 2
  , 3
  , 4
  , 5
  , 6
  , 7
  , 8
  , 9
  , 10
  , 11
  , 12
  , 13
  , 14
  , 15
  , 16
  , 17
  , 18
  , 19
  , 20
  , 21
  , 22
  , 23
  , 24
  , 25
  , 26
  , 27
  , 28
  , 29
  , 30
  , 31
  , 32
  , 33
  , 34
  , 35
  , 36
  , 37
  , 38
  , 39
  , 40
  , 41
  , 42
  , 43
  , 44
  , 45
  , 46
  , 47
  , 48
  , 49
  , 50
  , 51
  , 52
  , 53
  , 54
  , 55
  , 56
  , 57
  , 58
  , 59
  , 60
  , 61
  , 62
  , 63
  , 64
  , 65
  , 66
  , 67
  , 68
  , 69
  , 70
  , 71
  , 72
  , 73
  , 74
  , 75
  , 76
  , 77
  , 78
  , 79
  , 80
  , 81
  , 82
  , 83
  , 84
  , 85
  , 86
  , 87
  , 88
  , 89
  , 90
  , 91
  , 92
  , 93
  , 94
  , 95
  , 96
  , 97
  , 98
  , 99
  , 100
  , 101
  , 102
  , 103
  , 104
  , 105
  , 106
  , 107
  , 108
  , 109
  , 110
  , 111
  , 112
  , 113
  , 114
  , 115
  , 116
  , 117
  , 118
  , 119
  , 120
  , 121
  , 122
  , 123
  , 124
  , 125
  , 126
  , 127
  , 48
  , 49
  , 50
  , 51
  , 52
  , 53
  , 54
  , 55
  , 56
  , 57
  , 34
  , -1
  , 61
  , -1
  , -1
  , 39
  , -1
  , 65
  , 66
  , 67
  , 68
  , 69
  , 70
  , -1
  , 48
  , 49
  , 50
  , 51
  , 52
  , 53
  , 54
  , 55
  , -1
  , -1
  , -1
  , 48
  , 49
  , 50
  , 51
  , 52
  , 53
  , 54
  , 55
  , 56
  , 57
  , -1
  , -1
  , -1
  , -1
  , 97
  , 98
  , 99
  , 100
  , 101
  , 102
  , 68
  , 69
  , 70
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 92
  , -1
  , -1
  , -1
  , -1
  , -1
  , 98
  , 124
  , -1
  , -1
  , 102
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 110
  , 100
  , 101
  , 102
  , 114
  , -1
  , 116
  , 117
  , 192
  , 193
  , 194
  , 195
  , 196
  , 197
  , 198
  , 199
  , 200
  , 201
  , 202
  , 203
  , 204
  , 205
  , 206
  , 207
  , 208
  , 209
  , 210
  , 211
  , 212
  , 213
  , 214
  , 215
  , 216
  , 217
  , 218
  , 219
  , 220
  , 221
  , 222
  , 223
  , 224
  , 225
  , 226
  , 227
  , 228
  , 229
  , 230
  , 231
  , 232
  , 233
  , 234
  , 235
  , 236
  , 237
  , 238
  , 239
  , 240
  , 241
  , 242
  , 243
  , 244
  , 245
  , 246
  , 247
  , 248
  , 249
  , 250
  , 251
  , 252
  , 253
  , 254
  , 255
  , 0
  , 1
  , 2
  , 3
  , 4
  , 5
  , 6
  , 7
  , 8
  , 9
  , 10
  , 11
  , 12
  , 13
  , 14
  , 15
  , 16
  , 17
  , 18
  , 19
  , 20
  , 21
  , 22
  , 23
  , 24
  , 25
  , 26
  , 27
  , 28
  , 29
  , 30
  , 31
  , 32
  , 33
  , 34
  , 35
  , 36
  , 37
  , 38
  , 39
  , 40
  , 41
  , 42
  , 43
  , 44
  , 45
  , 46
  , 47
  , 48
  , 49
  , 50
  , 51
  , 52
  , 53
  , 54
  , 55
  , 56
  , 57
  , 58
  , 59
  , 60
  , 61
  , 62
  , 63
  , 64
  , 65
  , 66
  , 67
  , 68
  , 69
  , 70
  , 71
  , 72
  , 73
  , 74
  , 75
  , 76
  , 77
  , 78
  , 79
  , 80
  , 81
  , 82
  , 83
  , 84
  , 85
  , 86
  , 87
  , 88
  , 89
  , 90
  , 91
  , 92
  , 93
  , 94
  , 95
  , 96
  , 97
  , 98
  , 99
  , 100
  , 101
  , 102
  , 103
  , 104
  , 105
  , 106
  , 107
  , 108
  , 109
  , 110
  , 111
  , 112
  , 113
  , 114
  , 115
  , 116
  , 117
  , 118
  , 119
  , 120
  , 121
  , 122
  , 123
  , 124
  , 125
  , 126
  , 127
  , 48
  , 49
  , 50
  , 51
  , 52
  , 53
  , 54
  , 55
  , 56
  , 57
  , 34
  , -1
  , 10
  , -1
  , -1
  , 39
  , -1
  , 65
  , 66
  , 67
  , 68
  , 69
  , 70
  , -1
  , 48
  , 49
  , 50
  , 51
  , 52
  , 53
  , 54
  , 55
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 39
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 97
  , 98
  , 99
  , 100
  , 101
  , 102
  , 48
  , 49
  , 50
  , 51
  , 52
  , 53
  , 54
  , 55
  , 56
  , 57
  , -1
  , -1
  , -1
  , 92
  , -1
  , -1
  , -1
  , -1
  , -1
  , 98
  , 68
  , -1
  , 70
  , 102
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 110
  , -1
  , -1
  , -1
  , 114
  , -1
  , 116
  , 117
  , 92
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 100
  , -1
  , 102
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 128
  , 129
  , 130
  , 131
  , 132
  , 133
  , 134
  , 135
  , 136
  , 137
  , 138
  , 139
  , 140
  , 141
  , 142
  , 143
  , 144
  , 145
  , 146
  , 147
  , 148
  , 149
  , 150
  , 151
  , 152
  , 153
  , 154
  , 155
  , 156
  , 157
  , 158
  , 159
  , 160
  , 161
  , 162
  , 163
  , 164
  , 165
  , 166
  , 167
  , 168
  , 169
  , 170
  , 171
  , 172
  , 173
  , 174
  , 175
  , 176
  , 177
  , 178
  , 179
  , 180
  , 181
  , 182
  , 183
  , 184
  , 185
  , 186
  , 187
  , 188
  , 189
  , 190
  , 191
  , 192
  , 193
  , 194
  , 195
  , 196
  , 197
  , 198
  , 199
  , 200
  , 201
  , 202
  , 203
  , 204
  , 205
  , 206
  , 207
  , 208
  , 209
  , 210
  , 211
  , 212
  , 213
  , 214
  , 215
  , 216
  , 217
  , 218
  , 219
  , 220
  , 221
  , 222
  , 223
  , 224
  , 225
  , 226
  , 227
  , 228
  , 229
  , 230
  , 231
  , 232
  , 233
  , 234
  , 235
  , 236
  , 237
  , 238
  , 239
  , 240
  , 241
  , 242
  , 243
  , 244
  , 245
  , 246
  , 247
  , 248
  , 249
  , 250
  , 251
  , 252
  , 253
  , 254
  , 255
  , 192
  , 193
  , 194
  , 195
  , 196
  , 197
  , 198
  , 199
  , 200
  , 201
  , 202
  , 203
  , 204
  , 205
  , 206
  , 207
  , 208
  , 209
  , 210
  , 211
  , 212
  , 213
  , 214
  , 215
  , 216
  , 217
  , 218
  , 219
  , 220
  , 221
  , 222
  , 223
  , 224
  , 225
  , 226
  , 227
  , 228
  , 229
  , 230
  , 231
  , 232
  , 233
  , 234
  , 235
  , 236
  , 237
  , 238
  , 239
  , 240
  , 241
  , 242
  , 243
  , 244
  , 245
  , 246
  , 247
  , 248
  , 249
  , 250
  , 251
  , 252
  , 253
  , 254
  , 255
  , 48
  , 49
  , 50
  , 51
  , 52
  , 53
  , 54
  , 55
  , 56
  , 57
  , 42
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 65
  , 66
  , 67
  , 68
  , 69
  , 70
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 80
  , 46
  , -1
  , 48
  , 49
  , 50
  , 51
  , 52
  , 53
  , 54
  , 55
  , 56
  , 57
  , -1
  , -1
  , -1
  , -1
  , 97
  , 98
  , 99
  , 100
  , 101
  , 102
  , 68
  , 69
  , 70
  , -1
  , -1
  , -1
  , -1
  , -1
  , 76
  , 112
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 100
  , 101
  , 102
  , -1
  , -1
  , -1
  , -1
  , -1
  , 108
  , 128
  , 129
  , 130
  , 131
  , 132
  , 133
  , 134
  , 135
  , 136
  , 137
  , 138
  , 139
  , 140
  , 141
  , 142
  , 143
  , 144
  , 145
  , 146
  , 147
  , 148
  , 149
  , 150
  , 151
  , 152
  , 153
  , 154
  , 155
  , 156
  , 157
  , 158
  , 159
  , 160
  , 161
  , 162
  , 163
  , 164
  , 165
  , 166
  , 167
  , 168
  , 169
  , 170
  , 171
  , 172
  , 173
  , 174
  , 175
  , 176
  , 177
  , 178
  , 179
  , 180
  , 181
  , 182
  , 183
  , 184
  , 185
  , 186
  , 187
  , 188
  , 189
  , 190
  , 191
  , 192
  , 193
  , 194
  , 195
  , 196
  , 197
  , 198
  , 199
  , 200
  , 201
  , 202
  , 203
  , 204
  , 205
  , 206
  , 207
  , 208
  , 209
  , 210
  , 211
  , 212
  , 213
  , 214
  , 215
  , 216
  , 217
  , 218
  , 219
  , 220
  , 221
  , 222
  , 223
  , 224
  , 225
  , 226
  , 227
  , 228
  , 229
  , 230
  , 231
  , 232
  , 233
  , 234
  , 235
  , 236
  , 237
  , 238
  , 239
  , 240
  , 241
  , 242
  , 243
  , 244
  , 245
  , 246
  , 247
  , 248
  , 249
  , 250
  , 251
  , 252
  , 253
  , 254
  , 255
  , 0
  , 1
  , 2
  , 3
  , 4
  , 5
  , 6
  , 7
  , 8
  , 9
  , 10
  , 11
  , 12
  , 13
  , 14
  , 15
  , 16
  , 17
  , 18
  , 19
  , 20
  , 21
  , 22
  , 23
  , 24
  , 25
  , 26
  , 27
  , 28
  , 29
  , 30
  , 31
  , 32
  , 33
  , 34
  , 35
  , 36
  , 37
  , 38
  , 39
  , 40
  , 41
  , 42
  , 43
  , 44
  , 45
  , 46
  , 47
  , 48
  , 49
  , 50
  , 51
  , 52
  , 53
  , 54
  , 55
  , 56
  , 57
  , 58
  , 59
  , 60
  , 61
  , 62
  , 63
  , 64
  , 65
  , 66
  , 67
  , 68
  , 69
  , 70
  , 71
  , 72
  , 73
  , 74
  , 75
  , 76
  , 77
  , 78
  , 79
  , 80
  , 81
  , 82
  , 83
  , 84
  , 85
  , 86
  , 87
  , 88
  , 89
  , 90
  , 91
  , 92
  , 93
  , 94
  , 95
  , 96
  , 97
  , 98
  , 99
  , 100
  , 101
  , 102
  , 103
  , 104
  , 105
  , 106
  , 107
  , 108
  , 109
  , 110
  , 111
  , 112
  , 113
  , 114
  , 115
  , 116
  , 117
  , 118
  , 119
  , 120
  , 121
  , 122
  , 123
  , 124
  , 125
  , 126
  , 127
  , 192
  , 193
  , 194
  , 195
  , 196
  , 197
  , 198
  , 199
  , 200
  , 201
  , 202
  , 203
  , 204
  , 205
  , 206
  , 207
  , 208
  , 209
  , 210
  , 211
  , 212
  , 213
  , 214
  , 215
  , 216
  , 217
  , 218
  , 219
  , 220
  , 221
  , 222
  , 223
  , 224
  , 225
  , 226
  , 227
  , 228
  , 229
  , 230
  , 231
  , 232
  , 233
  , 234
  , 235
  , 236
  , 237
  , 238
  , 239
  , 240
  , 241
  , 242
  , 243
  , 244
  , 245
  , 246
  , 247
  , 248
  , 249
  , 250
  , 251
  , 252
  , 253
  , 254
  , 255
  , 10
  , -1
  , -1
  , -1
  , -1
  , -1
  , 46
  , -1
  , 48
  , 49
  , 50
  , 51
  , 52
  , 53
  , 54
  , 55
  , 56
  , 57
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 34
  , 65
  , 66
  , 67
  , 68
  , 69
  , 70
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 80
  , 46
  , -1
  , 48
  , 49
  , 50
  , 51
  , 52
  , 53
  , 54
  , 55
  , 56
  , 57
  , -1
  , -1
  , -1
  , -1
  , 97
  , 98
  , 99
  , 100
  , 101
  , 102
  , 68
  , 69
  , 70
  , -1
  , -1
  , -1
  , -1
  , -1
  , 76
  , 112
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 92
  , 88
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 100
  , 101
  , 102
  , -1
  , -1
  , -1
  , -1
  , -1
  , 108
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 120
  , -1
  , -1
  , 128
  , 129
  , 130
  , 131
  , 132
  , 133
  , 134
  , 135
  , 136
  , 137
  , 138
  , 139
  , 140
  , 141
  , 142
  , 143
  , 144
  , 145
  , 146
  , 147
  , 148
  , 149
  , 150
  , 151
  , 152
  , 153
  , 154
  , 155
  , 156
  , 157
  , 158
  , 159
  , 160
  , 161
  , 162
  , 163
  , 164
  , 165
  , 166
  , 167
  , 168
  , 169
  , 170
  , 171
  , 172
  , 173
  , 174
  , 175
  , 176
  , 177
  , 178
  , 179
  , 180
  , 181
  , 182
  , 183
  , 184
  , 185
  , 186
  , 187
  , 188
  , 189
  , 190
  , 191
  , 192
  , 193
  , 194
  , 195
  , 196
  , 197
  , 198
  , 199
  , 200
  , 201
  , 202
  , 203
  , 204
  , 205
  , 206
  , 207
  , 208
  , 209
  , 210
  , 211
  , 212
  , 213
  , 214
  , 215
  , 216
  , 217
  , 218
  , 219
  , 220
  , 221
  , 222
  , 223
  , 224
  , 225
  , 226
  , 227
  , 228
  , 229
  , 230
  , 231
  , 232
  , 233
  , 234
  , 235
  , 236
  , 237
  , 238
  , 239
  , 240
  , 241
  , 242
  , 243
  , 244
  , 245
  , 246
  , 247
  , 248
  , 249
  , 250
  , 251
  , 252
  , 253
  , 254
  , 255
  , 10
  , 36
  , -1
  , 13
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 48
  , 49
  , 50
  , 51
  , 52
  , 53
  , 54
  , 55
  , 56
  , 57
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 65
  , 66
  , 67
  , 68
  , 69
  , 70
  , 71
  , 72
  , 73
  , 74
  , 75
  , 76
  , 77
  , 78
  , 79
  , 80
  , 81
  , 82
  , 83
  , 84
  , 85
  , 86
  , 87
  , 88
  , 89
  , 90
  , -1
  , -1
  , -1
  , -1
  , 95
  , -1
  , 97
  , 98
  , 99
  , 100
  , 101
  , 102
  , 103
  , 104
  , 105
  , 106
  , 107
  , 108
  , 109
  , 110
  , 111
  , 112
  , 113
  , 114
  , 115
  , 116
  , 117
  , 118
  , 119
  , 120
  , 121
  , 122
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 128
  , 129
  , 130
  , 131
  , 132
  , 133
  , 134
  , 135
  , 136
  , 137
  , 138
  , 139
  , 140
  , 141
  , 142
  , 143
  , 144
  , 145
  , 146
  , 147
  , 148
  , 149
  , 150
  , 151
  , 152
  , 153
  , 154
  , 155
  , 156
  , 157
  , 158
  , 159
  , 160
  , 161
  , 162
  , 163
  , 164
  , 165
  , 166
  , 167
  , 168
  , 169
  , 170
  , 171
  , 172
  , 173
  , 174
  , 175
  , 176
  , 177
  , 178
  , 179
  , 180
  , 181
  , 182
  , 183
  , 184
  , 185
  , 186
  , 187
  , 188
  , 189
  , 190
  , 191
  , 192
  , 193
  , 194
  , 195
  , 196
  , 197
  , 198
  , 199
  , 200
  , 201
  , 202
  , 203
  , 204
  , 205
  , 206
  , 207
  , 208
  , 209
  , 210
  , 211
  , 212
  , 213
  , 214
  , 215
  , 216
  , 217
  , 218
  , 219
  , 220
  , 221
  , 222
  , 223
  , 224
  , 225
  , 226
  , 227
  , 228
  , 229
  , 230
  , 231
  , 232
  , 233
  , 234
  , 235
  , 236
  , 237
  , 238
  , 239
  , 240
  , 241
  , 242
  , 243
  , 244
  , 245
  , 246
  , 247
  , 248
  , 249
  , 250
  , 251
  , 252
  , 253
  , 254
  , 255
  , 10
  , 36
  , -1
  , 13
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 48
  , 49
  , 50
  , 51
  , 52
  , 53
  , 54
  , 55
  , 56
  , 57
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 65
  , 66
  , 67
  , 68
  , 69
  , 70
  , 71
  , 72
  , 73
  , 74
  , 75
  , 76
  , 77
  , 78
  , 79
  , 80
  , 81
  , 82
  , 83
  , 84
  , 85
  , 86
  , 87
  , 88
  , 89
  , 90
  , -1
  , -1
  , -1
  , -1
  , 95
  , -1
  , 97
  , 98
  , 99
  , 100
  , 101
  , 102
  , 103
  , 104
  , 105
  , 106
  , 107
  , 108
  , 109
  , 110
  , 111
  , 112
  , 113
  , 114
  , 115
  , 116
  , 117
  , 118
  , 119
  , 120
  , 121
  , 122
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 128
  , 129
  , 130
  , 131
  , 132
  , 133
  , 134
  , 135
  , 136
  , 137
  , 138
  , 139
  , 140
  , 141
  , 142
  , 143
  , 144
  , 145
  , 146
  , 147
  , 148
  , 149
  , 150
  , 151
  , 152
  , 153
  , 154
  , 155
  , 156
  , 157
  , 158
  , 159
  , 160
  , 161
  , 162
  , 163
  , 164
  , 165
  , 166
  , 167
  , 168
  , 169
  , 170
  , 171
  , 172
  , 173
  , 174
  , 175
  , 176
  , 177
  , 178
  , 179
  , 180
  , 181
  , 182
  , 183
  , 184
  , 185
  , 186
  , 187
  , 188
  , 189
  , 190
  , 191
  , 192
  , 193
  , 194
  , 195
  , 196
  , 197
  , 198
  , 199
  , 200
  , 201
  , 202
  , 203
  , 204
  , 205
  , 206
  , 207
  , 208
  , 209
  , 210
  , 211
  , 212
  , 213
  , 214
  , 215
  , 216
  , 217
  , 218
  , 219
  , 220
  , 221
  , 222
  , 223
  , 224
  , 225
  , 226
  , 227
  , 228
  , 229
  , 230
  , 231
  , 232
  , 233
  , 234
  , 235
  , 236
  , 237
  , 238
  , 239
  , 240
  , 241
  , 242
  , 243
  , 244
  , 245
  , 246
  , 247
  , 248
  , 249
  , 250
  , 251
  , 252
  , 253
  , 254
  , 255
  , 36
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 48
  , 49
  , 50
  , 51
  , 52
  , 53
  , 54
  , 55
  , 56
  , 57
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 65
  , 66
  , 67
  , 68
  , 69
  , 70
  , 71
  , 72
  , 73
  , 74
  , 75
  , 76
  , 77
  , 78
  , 79
  , 80
  , 81
  , 82
  , 83
  , 84
  , 85
  , 86
  , 87
  , 88
  , 89
  , 90
  , -1
  , -1
  , -1
  , -1
  , 95
  , -1
  , 97
  , 98
  , 99
  , 100
  , 101
  , 102
  , 103
  , 104
  , 105
  , 106
  , 107
  , 108
  , 109
  , 110
  , 111
  , 112
  , 113
  , 114
  , 115
  , 116
  , 117
  , 118
  , 119
  , 120
  , 121
  , 122
  , 36
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 48
  , 49
  , 50
  , 51
  , 52
  , 53
  , 54
  , 55
  , 56
  , 57
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 65
  , 66
  , 67
  , 68
  , 69
  , 70
  , 71
  , 72
  , 73
  , 74
  , 75
  , 76
  , 77
  , 78
  , 79
  , 80
  , 81
  , 82
  , 83
  , 84
  , 85
  , 86
  , 87
  , 88
  , 89
  , 90
  , -1
  , -1
  , -1
  , -1
  , 95
  , -1
  , 97
  , 98
  , 99
  , 100
  , 101
  , 102
  , 103
  , 104
  , 105
  , 106
  , 107
  , 108
  , 109
  , 110
  , 111
  , 112
  , 113
  , 114
  , 115
  , 116
  , 117
  , 118
  , 119
  , 120
  , 121
  , 122
  , 36
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 48
  , 49
  , 50
  , 51
  , 52
  , 53
  , 54
  , 55
  , 56
  , 57
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 65
  , 66
  , 67
  , 68
  , 69
  , 70
  , 71
  , 72
  , 73
  , 74
  , 75
  , 76
  , 77
  , 78
  , 79
  , 80
  , 81
  , 82
  , 83
  , 84
  , 85
  , 86
  , 87
  , 88
  , 89
  , 90
  , -1
  , -1
  , -1
  , -1
  , 95
  , -1
  , 97
  , 98
  , 99
  , 100
  , 101
  , 102
  , 103
  , 104
  , 105
  , 106
  , 107
  , 108
  , 109
  , 110
  , 111
  , 112
  , 113
  , 114
  , 115
  , 116
  , 117
  , 118
  , 119
  , 120
  , 121
  , 122
  , 36
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 48
  , 49
  , 50
  , 51
  , 52
  , 53
  , 54
  , 55
  , 56
  , 57
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 65
  , 66
  , 67
  , 68
  , 69
  , 70
  , 71
  , 72
  , 73
  , 74
  , 75
  , 76
  , 77
  , 78
  , 79
  , 80
  , 81
  , 82
  , 83
  , 84
  , 85
  , 86
  , 87
  , 88
  , 89
  , 90
  , -1
  , -1
  , -1
  , -1
  , 95
  , -1
  , 97
  , 98
  , 99
  , 100
  , 101
  , 102
  , 103
  , 104
  , 105
  , 106
  , 107
  , 108
  , 109
  , 110
  , 111
  , 112
  , 113
  , 114
  , 115
  , 116
  , 117
  , 118
  , 119
  , 120
  , 121
  , 122
  , 36
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 48
  , 49
  , 50
  , 51
  , 52
  , 53
  , 54
  , 55
  , 56
  , 57
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 65
  , 66
  , 67
  , 68
  , 69
  , 70
  , 71
  , 72
  , 73
  , 74
  , 75
  , 76
  , 77
  , 78
  , 79
  , 80
  , 81
  , 82
  , 83
  , 84
  , 85
  , 86
  , 87
  , 88
  , 89
  , 90
  , -1
  , -1
  , -1
  , -1
  , 95
  , -1
  , 97
  , 98
  , 99
  , 100
  , 101
  , 102
  , 103
  , 104
  , 105
  , 106
  , 107
  , 108
  , 109
  , 110
  , 111
  , 112
  , 113
  , 114
  , 115
  , 116
  , 117
  , 118
  , 119
  , 120
  , 121
  , 122
  , 36
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 48
  , 49
  , 50
  , 51
  , 52
  , 53
  , 54
  , 55
  , 56
  , 57
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 65
  , 66
  , 67
  , 68
  , 69
  , 70
  , 71
  , 72
  , 73
  , 74
  , 75
  , 76
  , 77
  , 78
  , 79
  , 80
  , 81
  , 82
  , 83
  , 84
  , 85
  , 86
  , 87
  , 88
  , 89
  , 90
  , -1
  , -1
  , -1
  , -1
  , 95
  , -1
  , 97
  , 98
  , 99
  , 100
  , 101
  , 102
  , 103
  , 104
  , 105
  , 106
  , 107
  , 108
  , 109
  , 110
  , 111
  , 112
  , 113
  , 114
  , 115
  , 116
  , 117
  , 118
  , 119
  , 120
  , 121
  , 122
  , 36
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 48
  , 49
  , 50
  , 51
  , 52
  , 53
  , 54
  , 55
  , 56
  , 57
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 65
  , 66
  , 67
  , 68
  , 69
  , 70
  , 71
  , 72
  , 73
  , 74
  , 75
  , 76
  , 77
  , 78
  , 79
  , 80
  , 81
  , 82
  , 83
  , 84
  , 85
  , 86
  , 87
  , 88
  , 89
  , 90
  , -1
  , -1
  , -1
  , -1
  , 95
  , -1
  , 97
  , 98
  , 99
  , 100
  , 101
  , 102
  , 103
  , 104
  , 105
  , 106
  , 107
  , 108
  , 109
  , 110
  , 111
  , 112
  , 113
  , 114
  , 115
  , 116
  , 117
  , 118
  , 119
  , 120
  , 121
  , 122
  , 36
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 48
  , 49
  , 50
  , 51
  , 52
  , 53
  , 54
  , 55
  , 56
  , 57
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 65
  , 66
  , 67
  , 68
  , 69
  , 70
  , 71
  , 72
  , 73
  , 74
  , 75
  , 76
  , 77
  , 78
  , 79
  , 80
  , 81
  , 82
  , 83
  , 84
  , 85
  , 86
  , 87
  , 88
  , 89
  , 90
  , -1
  , -1
  , -1
  , -1
  , 95
  , -1
  , 97
  , 98
  , 99
  , 100
  , 101
  , 102
  , 103
  , 104
  , 105
  , 106
  , 107
  , 108
  , 109
  , 110
  , 111
  , 112
  , 113
  , 114
  , 115
  , 116
  , 117
  , 118
  , 119
  , 120
  , 121
  , 122
  , 36
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 48
  , 49
  , 50
  , 51
  , 52
  , 53
  , 54
  , 55
  , 56
  , 57
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 65
  , 66
  , 67
  , 68
  , 69
  , 70
  , 71
  , 72
  , 73
  , 74
  , 75
  , 76
  , 77
  , 78
  , 79
  , 80
  , 81
  , 82
  , 83
  , 84
  , 85
  , 86
  , 87
  , 88
  , 89
  , 90
  , -1
  , -1
  , -1
  , -1
  , 95
  , -1
  , 97
  , 98
  , 99
  , 100
  , 101
  , 102
  , 103
  , 104
  , 105
  , 106
  , 107
  , 108
  , 109
  , 110
  , 111
  , 112
  , 113
  , 114
  , 115
  , 116
  , 117
  , 118
  , 119
  , 120
  , 121
  , 122
  , 36
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 48
  , 49
  , 50
  , 51
  , 52
  , 53
  , 54
  , 55
  , 56
  , 57
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 65
  , 66
  , 67
  , 68
  , 69
  , 70
  , 71
  , 72
  , 73
  , 74
  , 75
  , 76
  , 77
  , 78
  , 79
  , 80
  , 81
  , 82
  , 83
  , 84
  , 85
  , 86
  , 87
  , 88
  , 89
  , 90
  , -1
  , -1
  , -1
  , -1
  , 95
  , -1
  , 97
  , 98
  , 99
  , 100
  , 101
  , 102
  , 103
  , 104
  , 105
  , 106
  , 107
  , 108
  , 109
  , 110
  , 111
  , 112
  , 113
  , 114
  , 115
  , 116
  , 117
  , 118
  , 119
  , 120
  , 121
  , 122
  , 36
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 48
  , 49
  , 50
  , 51
  , 52
  , 53
  , 54
  , 55
  , 56
  , 57
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 65
  , 66
  , 67
  , 68
  , 69
  , 70
  , 71
  , 72
  , 73
  , 74
  , 75
  , 76
  , 77
  , 78
  , 79
  , 80
  , 81
  , 82
  , 83
  , 84
  , 85
  , 86
  , 87
  , 88
  , 89
  , 90
  , -1
  , -1
  , -1
  , -1
  , 95
  , -1
  , 97
  , 98
  , 99
  , 100
  , 101
  , 102
  , 103
  , 104
  , 105
  , 106
  , 107
  , 108
  , 109
  , 110
  , 111
  , 112
  , 113
  , 114
  , 115
  , 116
  , 117
  , 118
  , 119
  , 120
  , 121
  , 122
  , 36
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 48
  , 49
  , 50
  , 51
  , 52
  , 53
  , 54
  , 55
  , 56
  , 57
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 65
  , 66
  , 67
  , 68
  , 69
  , 70
  , 71
  , 72
  , 73
  , 74
  , 75
  , 76
  , 77
  , 78
  , 79
  , 80
  , 81
  , 82
  , 83
  , 84
  , 85
  , 86
  , 87
  , 88
  , 89
  , 90
  , -1
  , -1
  , -1
  , -1
  , 95
  , -1
  , 97
  , 98
  , 99
  , 100
  , 101
  , 102
  , 103
  , 104
  , 105
  , 106
  , 107
  , 108
  , 109
  , 110
  , 111
  , 112
  , 113
  , 114
  , 115
  , 116
  , 117
  , 118
  , 119
  , 120
  , 121
  , 122
  , 36
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 48
  , 49
  , 50
  , 51
  , 52
  , 53
  , 54
  , 55
  , 56
  , 57
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 65
  , 66
  , 67
  , 68
  , 69
  , 70
  , 71
  , 72
  , 73
  , 74
  , 75
  , 76
  , 77
  , 78
  , 79
  , 80
  , 81
  , 82
  , 83
  , 84
  , 85
  , 86
  , 87
  , 88
  , 89
  , 90
  , -1
  , -1
  , -1
  , -1
  , 95
  , -1
  , 97
  , 98
  , 99
  , 100
  , 101
  , 102
  , 103
  , 104
  , 105
  , 106
  , 107
  , 108
  , 109
  , 110
  , 111
  , 112
  , 113
  , 114
  , 115
  , 116
  , 117
  , 118
  , 119
  , 120
  , 121
  , 122
  , 36
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 48
  , 49
  , 50
  , 51
  , 52
  , 53
  , 54
  , 55
  , 56
  , 57
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 65
  , 66
  , 67
  , 68
  , 69
  , 70
  , 71
  , 72
  , 73
  , 74
  , 75
  , 76
  , 77
  , 78
  , 79
  , 80
  , 81
  , 82
  , 83
  , 84
  , 85
  , 86
  , 87
  , 88
  , 89
  , 90
  , -1
  , -1
  , -1
  , -1
  , 95
  , -1
  , 97
  , 98
  , 99
  , 100
  , 101
  , 102
  , 103
  , 104
  , 105
  , 106
  , 107
  , 108
  , 109
  , 110
  , 111
  , 112
  , 113
  , 114
  , 115
  , 116
  , 117
  , 118
  , 119
  , 120
  , 121
  , 122
  , 36
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 48
  , 49
  , 50
  , 51
  , 52
  , 53
  , 54
  , 55
  , 56
  , 57
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 65
  , 66
  , 67
  , 68
  , 69
  , 70
  , 71
  , 72
  , 73
  , 74
  , 75
  , 76
  , 77
  , 78
  , 79
  , 80
  , 81
  , 82
  , 83
  , 84
  , 85
  , 86
  , 87
  , 88
  , 89
  , 90
  , -1
  , -1
  , -1
  , -1
  , 95
  , -1
  , 97
  , 98
  , 99
  , 100
  , 101
  , 102
  , 103
  , 104
  , 105
  , 106
  , 107
  , 108
  , 109
  , 110
  , 111
  , 112
  , 113
  , 114
  , 115
  , 116
  , 117
  , 118
  , 119
  , 120
  , 121
  , 122
  , 36
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 48
  , 49
  , 50
  , 51
  , 52
  , 53
  , 54
  , 55
  , 56
  , 57
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 65
  , 66
  , 67
  , 68
  , 69
  , 70
  , 71
  , 72
  , 73
  , 74
  , 75
  , 76
  , 77
  , 78
  , 79
  , 80
  , 81
  , 82
  , 83
  , 84
  , 85
  , 86
  , 87
  , 88
  , 89
  , 90
  , -1
  , -1
  , -1
  , -1
  , 95
  , -1
  , 97
  , 98
  , 99
  , 100
  , 101
  , 102
  , 103
  , 104
  , 105
  , 106
  , 107
  , 108
  , 109
  , 110
  , 111
  , 112
  , 113
  , 114
  , 115
  , 116
  , 117
  , 118
  , 119
  , 120
  , 121
  , 122
  , 36
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 48
  , 49
  , 50
  , 51
  , 52
  , 53
  , 54
  , 55
  , 56
  , 57
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 65
  , 66
  , 67
  , 68
  , 69
  , 70
  , 71
  , 72
  , 73
  , 74
  , 75
  , 76
  , 77
  , 78
  , 79
  , 80
  , 81
  , 82
  , 83
  , 84
  , 85
  , 86
  , 87
  , 88
  , 89
  , 90
  , -1
  , -1
  , -1
  , -1
  , 95
  , -1
  , 97
  , 98
  , 99
  , 100
  , 101
  , 102
  , 103
  , 104
  , 105
  , 106
  , 107
  , 108
  , 109
  , 110
  , 111
  , 112
  , 113
  , 114
  , 115
  , 116
  , 117
  , 118
  , 119
  , 120
  , 121
  , 122
  , 36
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 48
  , 49
  , 50
  , 51
  , 52
  , 53
  , 54
  , 55
  , 56
  , 57
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 65
  , 66
  , 67
  , 68
  , 69
  , 70
  , 71
  , 72
  , 73
  , 74
  , 75
  , 76
  , 77
  , 78
  , 79
  , 80
  , 81
  , 82
  , 83
  , 84
  , 85
  , 86
  , 87
  , 88
  , 89
  , 90
  , -1
  , -1
  , -1
  , -1
  , 95
  , -1
  , 97
  , 98
  , 99
  , 100
  , 101
  , 102
  , 103
  , 104
  , 105
  , 106
  , 107
  , 108
  , 109
  , 110
  , 111
  , 112
  , 113
  , 114
  , 115
  , 116
  , 117
  , 118
  , 119
  , 120
  , 121
  , 122
  , 36
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 48
  , 49
  , 50
  , 51
  , 52
  , 53
  , 54
  , 55
  , 56
  , 57
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 65
  , 66
  , 67
  , 68
  , 69
  , 70
  , 71
  , 72
  , 73
  , 74
  , 75
  , 76
  , 77
  , 78
  , 79
  , 80
  , 81
  , 82
  , 83
  , 84
  , 85
  , 86
  , 87
  , 88
  , 89
  , 90
  , -1
  , -1
  , -1
  , -1
  , 95
  , -1
  , 97
  , 98
  , 99
  , 100
  , 101
  , 102
  , 103
  , 104
  , 105
  , 106
  , 107
  , 108
  , 109
  , 110
  , 111
  , 112
  , 113
  , 114
  , 115
  , 116
  , 117
  , 118
  , 119
  , 120
  , 121
  , 122
  , 36
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 48
  , 49
  , 50
  , 51
  , 52
  , 53
  , 54
  , 55
  , 56
  , 57
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 65
  , 66
  , 67
  , 68
  , 69
  , 70
  , 71
  , 72
  , 73
  , 74
  , 75
  , 76
  , 77
  , 78
  , 79
  , 80
  , 81
  , 82
  , 83
  , 84
  , 85
  , 86
  , 87
  , 88
  , 89
  , 90
  , -1
  , -1
  , -1
  , -1
  , 95
  , -1
  , 97
  , 98
  , 99
  , 100
  , 101
  , 102
  , 103
  , 104
  , 105
  , 106
  , 107
  , 108
  , 109
  , 110
  , 111
  , 112
  , 113
  , 114
  , 115
  , 116
  , 117
  , 118
  , 119
  , 120
  , 121
  , 122
  , 36
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 48
  , 49
  , 50
  , 51
  , 52
  , 53
  , 54
  , 55
  , 56
  , 57
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 65
  , 66
  , 67
  , 68
  , 69
  , 70
  , 71
  , 72
  , 73
  , 74
  , 75
  , 76
  , 77
  , 78
  , 79
  , 80
  , 81
  , 82
  , 83
  , 84
  , 85
  , 86
  , 87
  , 88
  , 89
  , 90
  , -1
  , -1
  , -1
  , -1
  , 95
  , -1
  , 97
  , 98
  , 99
  , 100
  , 101
  , 102
  , 103
  , 104
  , 105
  , 106
  , 107
  , 108
  , 109
  , 110
  , 111
  , 112
  , 113
  , 114
  , 115
  , 116
  , 117
  , 118
  , 119
  , 120
  , 121
  , 122
  , 36
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 48
  , 49
  , 50
  , 51
  , 52
  , 53
  , 54
  , 55
  , 56
  , 57
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 65
  , 66
  , 67
  , 68
  , 69
  , 70
  , 71
  , 72
  , 73
  , 74
  , 75
  , 76
  , 77
  , 78
  , 79
  , 80
  , 81
  , 82
  , 83
  , 84
  , 85
  , 86
  , 87
  , 88
  , 89
  , 90
  , -1
  , -1
  , -1
  , -1
  , 95
  , -1
  , 97
  , 98
  , 99
  , 100
  , 101
  , 102
  , 103
  , 104
  , 105
  , 106
  , 107
  , 108
  , 109
  , 110
  , 111
  , 112
  , 113
  , 114
  , 115
  , 116
  , 117
  , 118
  , 119
  , 120
  , 121
  , 122
  , 36
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 48
  , 49
  , 50
  , 51
  , 52
  , 53
  , 54
  , 55
  , 56
  , 57
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 65
  , 66
  , 67
  , 68
  , 69
  , 70
  , 71
  , 72
  , 73
  , 74
  , 75
  , 76
  , 77
  , 78
  , 79
  , 80
  , 81
  , 82
  , 83
  , 84
  , 85
  , 86
  , 87
  , 88
  , 89
  , 90
  , -1
  , -1
  , -1
  , -1
  , 95
  , -1
  , 97
  , 98
  , 99
  , 100
  , 101
  , 102
  , 103
  , 104
  , 105
  , 106
  , 107
  , 108
  , 109
  , 110
  , 111
  , 112
  , 113
  , 114
  , 115
  , 116
  , 117
  , 118
  , 119
  , 120
  , 121
  , 122
  , 36
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 48
  , 49
  , 50
  , 51
  , 52
  , 53
  , 54
  , 55
  , 56
  , 57
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 65
  , 66
  , 67
  , 68
  , 69
  , 70
  , 71
  , 72
  , 73
  , 74
  , 75
  , 76
  , 77
  , 78
  , 79
  , 80
  , 81
  , 82
  , 83
  , 84
  , 85
  , 86
  , 87
  , 88
  , 89
  , 90
  , -1
  , -1
  , -1
  , -1
  , 95
  , -1
  , 97
  , 98
  , 99
  , 100
  , 101
  , 102
  , 103
  , 104
  , 105
  , 106
  , 107
  , 108
  , 109
  , 110
  , 111
  , 112
  , 113
  , 114
  , 115
  , 116
  , 117
  , 118
  , 119
  , 120
  , 121
  , 122
  , 36
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 48
  , 49
  , 50
  , 51
  , 52
  , 53
  , 54
  , 55
  , 56
  , 57
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 65
  , 66
  , 67
  , 68
  , 69
  , 70
  , 71
  , 72
  , 73
  , 74
  , 75
  , 76
  , 77
  , 78
  , 79
  , 80
  , 81
  , 82
  , 83
  , 84
  , 85
  , 86
  , 87
  , 88
  , 89
  , 90
  , -1
  , -1
  , -1
  , -1
  , 95
  , -1
  , 97
  , 98
  , 99
  , 100
  , 101
  , 102
  , 103
  , 104
  , 105
  , 106
  , 107
  , 108
  , 109
  , 110
  , 111
  , 112
  , 113
  , 114
  , 115
  , 116
  , 117
  , 118
  , 119
  , 120
  , 121
  , 122
  , 36
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 48
  , 49
  , 50
  , 51
  , 52
  , 53
  , 54
  , 55
  , 56
  , 57
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 65
  , 66
  , 67
  , 68
  , 69
  , 70
  , 71
  , 72
  , 73
  , 74
  , 75
  , 76
  , 77
  , 78
  , 79
  , 80
  , 81
  , 82
  , 83
  , 84
  , 85
  , 86
  , 87
  , 88
  , 89
  , 90
  , -1
  , -1
  , -1
  , -1
  , 95
  , -1
  , 97
  , 98
  , 99
  , 100
  , 101
  , 102
  , 103
  , 104
  , 105
  , 106
  , 107
  , 108
  , 109
  , 110
  , 111
  , 112
  , 113
  , 114
  , 115
  , 116
  , 117
  , 118
  , 119
  , 120
  , 121
  , 122
  , 36
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 48
  , 49
  , 50
  , 51
  , 52
  , 53
  , 54
  , 55
  , 56
  , 57
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 65
  , 66
  , 67
  , 68
  , 69
  , 70
  , 71
  , 72
  , 73
  , 74
  , 75
  , 76
  , 77
  , 78
  , 79
  , 80
  , 81
  , 82
  , 83
  , 84
  , 85
  , 86
  , 87
  , 88
  , 89
  , 90
  , -1
  , -1
  , -1
  , -1
  , 95
  , -1
  , 97
  , 98
  , 99
  , 100
  , 101
  , 102
  , 103
  , 104
  , 105
  , 106
  , 107
  , 108
  , 109
  , 110
  , 111
  , 112
  , 113
  , 114
  , 115
  , 116
  , 117
  , 118
  , 119
  , 120
  , 121
  , 122
  , 36
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 48
  , 49
  , 50
  , 51
  , 52
  , 53
  , 54
  , 55
  , 56
  , 57
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 65
  , 66
  , 67
  , 68
  , 69
  , 70
  , 71
  , 72
  , 73
  , 74
  , 75
  , 76
  , 77
  , 78
  , 79
  , 80
  , 81
  , 82
  , 83
  , 84
  , 85
  , 86
  , 87
  , 88
  , 89
  , 90
  , -1
  , -1
  , -1
  , -1
  , 95
  , -1
  , 97
  , 98
  , 99
  , 100
  , 101
  , 102
  , 103
  , 104
  , 105
  , 106
  , 107
  , 108
  , 109
  , 110
  , 111
  , 112
  , 113
  , 114
  , 115
  , 116
  , 117
  , 118
  , 119
  , 120
  , 121
  , 122
  , 36
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 48
  , 49
  , 50
  , 51
  , 52
  , 53
  , 54
  , 55
  , 56
  , 57
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 65
  , 66
  , 67
  , 68
  , 69
  , 70
  , 71
  , 72
  , 73
  , 74
  , 75
  , 76
  , 77
  , 78
  , 79
  , 80
  , 81
  , 82
  , 83
  , 84
  , 85
  , 86
  , 87
  , 88
  , 89
  , 90
  , -1
  , -1
  , -1
  , -1
  , 95
  , -1
  , 97
  , 98
  , 99
  , 100
  , 101
  , 102
  , 103
  , 104
  , 105
  , 106
  , 107
  , 108
  , 109
  , 110
  , 111
  , 112
  , 113
  , 114
  , 115
  , 116
  , 117
  , 118
  , 119
  , 120
  , 121
  , 122
  , 36
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 48
  , 49
  , 50
  , 51
  , 52
  , 53
  , 54
  , 55
  , 56
  , 57
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 65
  , 66
  , 67
  , 68
  , 69
  , 70
  , 71
  , 72
  , 73
  , 74
  , 75
  , 76
  , 77
  , 78
  , 79
  , 80
  , 81
  , 82
  , 83
  , 84
  , 85
  , 86
  , 87
  , 88
  , 89
  , 90
  , -1
  , -1
  , -1
  , -1
  , 95
  , -1
  , 97
  , 98
  , 99
  , 100
  , 101
  , 102
  , 103
  , 104
  , 105
  , 106
  , 107
  , 108
  , 109
  , 110
  , 111
  , 112
  , 113
  , 114
  , 115
  , 116
  , 117
  , 118
  , 119
  , 120
  , 121
  , 122
  , 36
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 48
  , 49
  , 50
  , 51
  , 52
  , 53
  , 54
  , 55
  , 56
  , 57
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 65
  , 66
  , 67
  , 68
  , 69
  , 70
  , 71
  , 72
  , 73
  , 74
  , 75
  , 76
  , 77
  , 78
  , 79
  , 80
  , 81
  , 82
  , 83
  , 84
  , 85
  , 86
  , 87
  , 88
  , 89
  , 90
  , -1
  , -1
  , -1
  , -1
  , 95
  , -1
  , 97
  , 98
  , 99
  , 100
  , 101
  , 102
  , 103
  , 104
  , 105
  , 106
  , 107
  , 108
  , 109
  , 110
  , 111
  , 112
  , 113
  , 114
  , 115
  , 116
  , 117
  , 118
  , 119
  , 120
  , 121
  , 122
  , 36
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 48
  , 49
  , 50
  , 51
  , 52
  , 53
  , 54
  , 55
  , 56
  , 57
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 65
  , 66
  , 67
  , 68
  , 69
  , 70
  , 71
  , 72
  , 73
  , 74
  , 75
  , 76
  , 77
  , 78
  , 79
  , 80
  , 81
  , 82
  , 83
  , 84
  , 85
  , 86
  , 87
  , 88
  , 89
  , 90
  , -1
  , -1
  , -1
  , -1
  , 95
  , -1
  , 97
  , 98
  , 99
  , 100
  , 101
  , 102
  , 103
  , 104
  , 105
  , 106
  , 107
  , 108
  , 109
  , 110
  , 111
  , 112
  , 113
  , 114
  , 115
  , 116
  , 117
  , 118
  , 119
  , 120
  , 121
  , 122
  , 36
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 48
  , 49
  , 50
  , 51
  , 52
  , 53
  , 54
  , 55
  , 56
  , 57
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 65
  , 66
  , 67
  , 68
  , 69
  , 70
  , 71
  , 72
  , 73
  , 74
  , 75
  , 76
  , 77
  , 78
  , 79
  , 80
  , 81
  , 82
  , 83
  , 84
  , 85
  , 86
  , 87
  , 88
  , 89
  , 90
  , -1
  , -1
  , -1
  , -1
  , 95
  , -1
  , 97
  , 98
  , 99
  , 100
  , 101
  , 102
  , 103
  , 104
  , 105
  , 106
  , 107
  , 108
  , 109
  , 110
  , 111
  , 112
  , 113
  , 114
  , 115
  , 116
  , 117
  , 118
  , 119
  , 120
  , 121
  , 122
  , 36
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 48
  , 49
  , 50
  , 51
  , 52
  , 53
  , 54
  , 55
  , 56
  , 57
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 65
  , 66
  , 67
  , 68
  , 69
  , 70
  , 71
  , 72
  , 73
  , 74
  , 75
  , 76
  , 77
  , 78
  , 79
  , 80
  , 81
  , 82
  , 83
  , 84
  , 85
  , 86
  , 87
  , 88
  , 89
  , 90
  , -1
  , -1
  , -1
  , -1
  , 95
  , -1
  , 97
  , 98
  , 99
  , 100
  , 101
  , 102
  , 103
  , 104
  , 105
  , 106
  , 107
  , 108
  , 109
  , 110
  , 111
  , 112
  , 113
  , 114
  , 115
  , 116
  , 117
  , 118
  , 119
  , 120
  , 121
  , 122
  , 36
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 48
  , 49
  , 50
  , 51
  , 52
  , 53
  , 54
  , 55
  , 56
  , 57
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 65
  , 66
  , 67
  , 68
  , 69
  , 70
  , 71
  , 72
  , 73
  , 74
  , 75
  , 76
  , 77
  , 78
  , 79
  , 80
  , 81
  , 82
  , 83
  , 84
  , 85
  , 86
  , 87
  , 88
  , 89
  , 90
  , -1
  , -1
  , -1
  , -1
  , 95
  , -1
  , 97
  , 98
  , 99
  , 100
  , 101
  , 102
  , 103
  , 104
  , 105
  , 106
  , 107
  , 108
  , 109
  , 110
  , 111
  , 112
  , 113
  , 114
  , 115
  , 116
  , 117
  , 118
  , 119
  , 120
  , 121
  , 122
  , 36
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 48
  , 49
  , 50
  , 51
  , 52
  , 53
  , 54
  , 55
  , 56
  , 57
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 65
  , 66
  , 67
  , 68
  , 69
  , 70
  , 71
  , 72
  , 73
  , 74
  , 75
  , 76
  , 77
  , 78
  , 79
  , 80
  , 81
  , 82
  , 83
  , 84
  , 85
  , 86
  , 87
  , 88
  , 89
  , 90
  , -1
  , -1
  , -1
  , -1
  , 95
  , -1
  , 97
  , 98
  , 99
  , 100
  , 101
  , 102
  , 103
  , 104
  , 105
  , 106
  , 107
  , 108
  , 109
  , 110
  , 111
  , 112
  , 113
  , 114
  , 115
  , 116
  , 117
  , 118
  , 119
  , 120
  , 121
  , 122
  , 36
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 48
  , 49
  , 50
  , 51
  , 52
  , 53
  , 54
  , 55
  , 56
  , 57
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 65
  , 66
  , 67
  , 68
  , 69
  , 70
  , 71
  , 72
  , 73
  , 74
  , 75
  , 76
  , 77
  , 78
  , 79
  , 80
  , 81
  , 82
  , 83
  , 84
  , 85
  , 86
  , 87
  , 88
  , 89
  , 90
  , -1
  , -1
  , -1
  , -1
  , 95
  , -1
  , 97
  , 98
  , 99
  , 100
  , 101
  , 102
  , 103
  , 104
  , 105
  , 106
  , 107
  , 108
  , 109
  , 110
  , 111
  , 112
  , 113
  , 114
  , 115
  , 116
  , 117
  , 118
  , 119
  , 120
  , 121
  , 122
  , 36
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 48
  , 49
  , 50
  , 51
  , 52
  , 53
  , 54
  , 55
  , 56
  , 57
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 65
  , 66
  , 67
  , 68
  , 69
  , 70
  , 71
  , 72
  , 73
  , 74
  , 75
  , 76
  , 77
  , 78
  , 79
  , 80
  , 81
  , 82
  , 83
  , 84
  , 85
  , 86
  , 87
  , 88
  , 89
  , 90
  , -1
  , -1
  , -1
  , -1
  , 95
  , -1
  , 97
  , 98
  , 99
  , 100
  , 101
  , 102
  , 103
  , 104
  , 105
  , 106
  , 107
  , 108
  , 109
  , 110
  , 111
  , 112
  , 113
  , 114
  , 115
  , 116
  , 117
  , 118
  , 119
  , 120
  , 121
  , 122
  , 36
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 48
  , 49
  , 50
  , 51
  , 52
  , 53
  , 54
  , 55
  , 56
  , 57
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 65
  , 66
  , 67
  , 68
  , 69
  , 70
  , 71
  , 72
  , 73
  , 74
  , 75
  , 76
  , 77
  , 78
  , 79
  , 80
  , 81
  , 82
  , 83
  , 84
  , 85
  , 86
  , 87
  , 88
  , 89
  , 90
  , -1
  , -1
  , -1
  , -1
  , 95
  , -1
  , 97
  , 98
  , 99
  , 100
  , 101
  , 102
  , 103
  , 104
  , 105
  , 106
  , 107
  , 108
  , 109
  , 110
  , 111
  , 112
  , 113
  , 114
  , 115
  , 116
  , 117
  , 118
  , 119
  , 120
  , 121
  , 122
  , 36
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 48
  , 49
  , 50
  , 51
  , 52
  , 53
  , 54
  , 55
  , 56
  , 57
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 65
  , 66
  , 67
  , 68
  , 69
  , 70
  , 71
  , 72
  , 73
  , 74
  , 75
  , 76
  , 77
  , 78
  , 79
  , 80
  , 81
  , 82
  , 83
  , 84
  , 85
  , 86
  , 87
  , 88
  , 89
  , 90
  , -1
  , -1
  , -1
  , -1
  , 95
  , -1
  , 97
  , 98
  , 99
  , 100
  , 101
  , 102
  , 103
  , 104
  , 105
  , 106
  , 107
  , 108
  , 109
  , 110
  , 111
  , 112
  , 113
  , 114
  , 115
  , 116
  , 117
  , 118
  , 119
  , 120
  , 121
  , 122
  , 36
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 48
  , 49
  , 50
  , 51
  , 52
  , 53
  , 54
  , 55
  , 56
  , 57
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 65
  , 66
  , 67
  , 68
  , 69
  , 70
  , 71
  , 72
  , 73
  , 74
  , 75
  , 76
  , 77
  , 78
  , 79
  , 80
  , 81
  , 82
  , 83
  , 84
  , 85
  , 86
  , 87
  , 88
  , 89
  , 90
  , -1
  , -1
  , -1
  , -1
  , 95
  , -1
  , 97
  , 98
  , 99
  , 100
  , 101
  , 102
  , 103
  , 104
  , 105
  , 106
  , 107
  , 108
  , 109
  , 110
  , 111
  , 112
  , 113
  , 114
  , 115
  , 116
  , 117
  , 118
  , 119
  , 120
  , 121
  , 122
  , 36
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 48
  , 49
  , 50
  , 51
  , 52
  , 53
  , 54
  , 55
  , 56
  , 57
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 65
  , 66
  , 67
  , 68
  , 69
  , 70
  , 71
  , 72
  , 73
  , 74
  , 75
  , 76
  , 77
  , 78
  , 79
  , 80
  , 81
  , 82
  , 83
  , 84
  , 85
  , 86
  , 87
  , 88
  , 89
  , 90
  , -1
  , -1
  , -1
  , -1
  , 95
  , -1
  , 97
  , 98
  , 99
  , 100
  , 101
  , 102
  , 103
  , 104
  , 105
  , 106
  , 107
  , 108
  , 109
  , 110
  , 111
  , 112
  , 113
  , 114
  , 115
  , 116
  , 117
  , 118
  , 119
  , 120
  , 121
  , 122
  , 36
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 48
  , 49
  , 50
  , 51
  , 52
  , 53
  , 54
  , 55
  , 56
  , 57
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 65
  , 66
  , 67
  , 68
  , 69
  , 70
  , 71
  , 72
  , 73
  , 74
  , 75
  , 76
  , 77
  , 78
  , 79
  , 80
  , 81
  , 82
  , 83
  , 84
  , 85
  , 86
  , 87
  , 88
  , 89
  , 90
  , -1
  , -1
  , -1
  , -1
  , 95
  , -1
  , 97
  , 98
  , 99
  , 100
  , 101
  , 102
  , 103
  , 104
  , 105
  , 106
  , 107
  , 108
  , 109
  , 110
  , 111
  , 112
  , 113
  , 114
  , 115
  , 116
  , 117
  , 118
  , 119
  , 120
  , 121
  , 122
  , 36
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 48
  , 49
  , 50
  , 51
  , 52
  , 53
  , 54
  , 55
  , 56
  , 57
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 65
  , 66
  , 67
  , 68
  , 69
  , 70
  , 71
  , 72
  , 73
  , 74
  , 75
  , 76
  , 77
  , 78
  , 79
  , 80
  , 81
  , 82
  , 83
  , 84
  , 85
  , 86
  , 87
  , 88
  , 89
  , 90
  , -1
  , -1
  , -1
  , -1
  , 95
  , -1
  , 97
  , 98
  , 99
  , 100
  , 101
  , 102
  , 103
  , 104
  , 105
  , 106
  , 107
  , 108
  , 109
  , 110
  , 111
  , 112
  , 113
  , 114
  , 115
  , 116
  , 117
  , 118
  , 119
  , 120
  , 121
  , 122
  , 36
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 48
  , 49
  , 50
  , 51
  , 52
  , 53
  , 54
  , 55
  , 56
  , 57
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 65
  , 66
  , 67
  , 68
  , 69
  , 70
  , 71
  , 72
  , 73
  , 74
  , 75
  , 76
  , 77
  , 78
  , 79
  , 80
  , 81
  , 82
  , 83
  , 84
  , 85
  , 86
  , 87
  , 88
  , 89
  , 90
  , -1
  , -1
  , -1
  , -1
  , 95
  , -1
  , 97
  , 98
  , 99
  , 100
  , 101
  , 102
  , 103
  , 104
  , 105
  , 106
  , 107
  , 108
  , 109
  , 110
  , 111
  , 112
  , 113
  , 114
  , 115
  , 116
  , 117
  , 118
  , 119
  , 120
  , 121
  , 122
  , 36
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 48
  , 49
  , 50
  , 51
  , 52
  , 53
  , 54
  , 55
  , 56
  , 57
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 65
  , 66
  , 67
  , 68
  , 69
  , 70
  , 71
  , 72
  , 73
  , 74
  , 75
  , 76
  , 77
  , 78
  , 79
  , 80
  , 81
  , 82
  , 83
  , 84
  , 85
  , 86
  , 87
  , 88
  , 89
  , 90
  , -1
  , -1
  , -1
  , -1
  , 95
  , -1
  , 97
  , 98
  , 99
  , 100
  , 101
  , 102
  , 103
  , 104
  , 105
  , 106
  , 107
  , 108
  , 109
  , 110
  , 111
  , 112
  , 113
  , 114
  , 115
  , 116
  , 117
  , 118
  , 119
  , 120
  , 121
  , 122
  , 36
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 48
  , 49
  , 50
  , 51
  , 52
  , 53
  , 54
  , 55
  , 56
  , 57
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 65
  , 66
  , 67
  , 68
  , 69
  , 70
  , 71
  , 72
  , 73
  , 74
  , 75
  , 76
  , 77
  , 78
  , 79
  , 80
  , 81
  , 82
  , 83
  , 84
  , 85
  , 86
  , 87
  , 88
  , 89
  , 90
  , -1
  , -1
  , -1
  , -1
  , 95
  , -1
  , 97
  , 98
  , 99
  , 100
  , 101
  , 102
  , 103
  , 104
  , 105
  , 106
  , 107
  , 108
  , 109
  , 110
  , 111
  , 112
  , 113
  , 114
  , 115
  , 116
  , 117
  , 118
  , 119
  , 120
  , 121
  , 122
  , 36
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 48
  , 49
  , 50
  , 51
  , 52
  , 53
  , 54
  , 55
  , 56
  , 57
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 65
  , 66
  , 67
  , 68
  , 69
  , 70
  , 71
  , 72
  , 73
  , 74
  , 75
  , 76
  , 77
  , 78
  , 79
  , 80
  , 81
  , 82
  , 83
  , 84
  , 85
  , 86
  , 87
  , 88
  , 89
  , 90
  , -1
  , -1
  , -1
  , -1
  , 95
  , -1
  , 97
  , 98
  , 99
  , 100
  , 101
  , 102
  , 103
  , 104
  , 105
  , 106
  , 107
  , 108
  , 109
  , 110
  , 111
  , 112
  , 113
  , 114
  , 115
  , 116
  , 117
  , 118
  , 119
  , 120
  , 121
  , 122
  , 46
  , -1
  , 48
  , 49
  , 50
  , 51
  , 52
  , 53
  , 54
  , 55
  , 56
  , 57
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 68
  , 69
  , 70
  , -1
  , -1
  , -1
  , -1
  , 46
  , 76
  , 48
  , 49
  , 50
  , 51
  , 52
  , 53
  , 54
  , 55
  , 56
  , 57
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 65
  , 66
  , 67
  , 68
  , 69
  , 70
  , 100
  , 101
  , 102
  , -1
  , -1
  , 76
  , -1
  , -1
  , 108
  , 80
  , -1
  , -1
  , 48
  , 49
  , 50
  , 51
  , 52
  , 53
  , 54
  , 55
  , 56
  , 57
  , -1
  , -1
  , -1
  , -1
  , 97
  , 98
  , 99
  , 100
  , 101
  , 102
  , 68
  , 69
  , 70
  , -1
  , -1
  , 108
  , -1
  , -1
  , -1
  , 112
  , -1
  , -1
  , -1
  , -1
  , -1
  , 48
  , 49
  , 50
  , 51
  , 52
  , 53
  , 54
  , 55
  , 56
  , 57
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 100
  , 101
  , 102
  , 68
  , -1
  , 70
  , 48
  , 49
  , 50
  , 51
  , 52
  , 53
  , 54
  , 55
  , 56
  , 57
  , 48
  , 49
  , 50
  , 51
  , 52
  , 53
  , 54
  , 55
  , 56
  , 57
  , 68
  , -1
  , 70
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 100
  , 68
  , 102
  , 70
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 100
  , 36
  , 102
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 100
  , -1
  , 102
  , 48
  , 49
  , 50
  , 51
  , 52
  , 53
  , 54
  , 55
  , 56
  , 57
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 65
  , 66
  , 67
  , 68
  , 69
  , 70
  , 71
  , 72
  , 73
  , 74
  , 75
  , 76
  , 77
  , 78
  , 79
  , 80
  , 81
  , 82
  , 83
  , 84
  , 85
  , 86
  , 87
  , 88
  , 89
  , 90
  , -1
  , -1
  , -1
  , -1
  , 95
  , -1
  , 97
  , 98
  , 99
  , 100
  , 101
  , 102
  , 103
  , 104
  , 105
  , 106
  , 107
  , 108
  , 109
  , 110
  , 111
  , 112
  , 113
  , 114
  , 115
  , 116
  , 117
  , 118
  , 119
  , 120
  , 121
  , 122
  , 36
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 48
  , 49
  , 50
  , 51
  , 52
  , 53
  , 54
  , 55
  , 56
  , 57
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 65
  , 66
  , 67
  , 68
  , 69
  , 70
  , 71
  , 72
  , 73
  , 74
  , 75
  , 76
  , 77
  , 78
  , 79
  , 80
  , 81
  , 82
  , 83
  , 84
  , 85
  , 86
  , 87
  , 88
  , 89
  , 90
  , -1
  , -1
  , -1
  , -1
  , 95
  , -1
  , 97
  , 98
  , 99
  , 100
  , 101
  , 102
  , 103
  , 104
  , 105
  , 106
  , 107
  , 108
  , 109
  , 110
  , 111
  , 112
  , 113
  , 114
  , 115
  , 116
  , 117
  , 118
  , 119
  , 120
  , 121
  , 122
  , 36
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 48
  , 49
  , 50
  , 51
  , 52
  , 53
  , 54
  , 55
  , 56
  , 57
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 65
  , 66
  , 67
  , 68
  , 69
  , 70
  , 71
  , 72
  , 73
  , 74
  , 75
  , 76
  , 77
  , 78
  , 79
  , 80
  , 81
  , 82
  , 83
  , 84
  , 85
  , 86
  , 87
  , 88
  , 89
  , 90
  , -1
  , -1
  , -1
  , -1
  , 95
  , -1
  , 97
  , 98
  , 99
  , 100
  , 101
  , 102
  , 103
  , 104
  , 105
  , 106
  , 107
  , 108
  , 109
  , 110
  , 111
  , 112
  , 113
  , 114
  , 115
  , 116
  , 117
  , 118
  , 119
  , 120
  , 121
  , 122
  , 36
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 48
  , 49
  , 50
  , 51
  , 52
  , 53
  , 54
  , 55
  , 56
  , 57
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 65
  , 66
  , 67
  , 68
  , 69
  , 70
  , 71
  , 72
  , 73
  , 74
  , 75
  , 76
  , 77
  , 78
  , 79
  , 80
  , 81
  , 82
  , 83
  , 84
  , 85
  , 86
  , 87
  , 88
  , 89
  , 90
  , -1
  , -1
  , -1
  , -1
  , 95
  , -1
  , 97
  , 98
  , 99
  , 100
  , 101
  , 102
  , 103
  , 104
  , 105
  , 106
  , 107
  , 108
  , 109
  , 110
  , 111
  , 112
  , 113
  , 114
  , 115
  , 116
  , 117
  , 118
  , 119
  , 120
  , 121
  , 122
  , 36
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 48
  , 49
  , 50
  , 51
  , 52
  , 53
  , 54
  , 55
  , 56
  , 57
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 65
  , 66
  , 67
  , 68
  , 69
  , 70
  , 71
  , 72
  , 73
  , 74
  , 75
  , 76
  , 77
  , 78
  , 79
  , 80
  , 81
  , 82
  , 83
  , 84
  , 85
  , 86
  , 87
  , 88
  , 89
  , 90
  , -1
  , -1
  , -1
  , -1
  , 95
  , -1
  , 97
  , 98
  , 99
  , 100
  , 101
  , 102
  , 103
  , 104
  , 105
  , 106
  , 107
  , 108
  , 109
  , 110
  , 111
  , 112
  , 113
  , 114
  , 115
  , 116
  , 117
  , 118
  , 119
  , 120
  , 121
  , 122
  , 36
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 48
  , 49
  , 50
  , 51
  , 52
  , 53
  , 54
  , 55
  , 56
  , 57
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 65
  , 66
  , 67
  , 68
  , 69
  , 70
  , 71
  , 72
  , 73
  , 74
  , 75
  , 76
  , 77
  , 78
  , 79
  , 80
  , 81
  , 82
  , 83
  , 84
  , 85
  , 86
  , 87
  , 88
  , 89
  , 90
  , -1
  , -1
  , -1
  , -1
  , 95
  , -1
  , 97
  , 98
  , 99
  , 100
  , 101
  , 102
  , 103
  , 104
  , 105
  , 106
  , 107
  , 108
  , 109
  , 110
  , 111
  , 112
  , 113
  , 114
  , 115
  , 116
  , 117
  , 118
  , 119
  , 120
  , 121
  , 122
  , 36
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 48
  , 49
  , 50
  , 51
  , 52
  , 53
  , 54
  , 55
  , 56
  , 57
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 65
  , 66
  , 67
  , 68
  , 69
  , 70
  , 71
  , 72
  , 73
  , 74
  , 75
  , 76
  , 77
  , 78
  , 79
  , 80
  , 81
  , 82
  , 83
  , 84
  , 85
  , 86
  , 87
  , 88
  , 89
  , 90
  , -1
  , -1
  , -1
  , -1
  , 95
  , -1
  , 97
  , 98
  , 99
  , 100
  , 101
  , 102
  , 103
  , 104
  , 105
  , 106
  , 107
  , 108
  , 109
  , 110
  , 111
  , 112
  , 113
  , 114
  , 115
  , 116
  , 117
  , 118
  , 119
  , 120
  , 121
  , 122
  , 36
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 48
  , 49
  , 50
  , 51
  , 52
  , 53
  , 54
  , 55
  , 56
  , 57
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 65
  , 66
  , 67
  , 68
  , 69
  , 70
  , 71
  , 72
  , 73
  , 74
  , 75
  , 76
  , 77
  , 78
  , 79
  , 80
  , 81
  , 82
  , 83
  , 84
  , 85
  , 86
  , 87
  , 88
  , 89
  , 90
  , -1
  , -1
  , -1
  , -1
  , 95
  , -1
  , 97
  , 98
  , 99
  , 100
  , 101
  , 102
  , 103
  , 104
  , 105
  , 106
  , 107
  , 108
  , 109
  , 110
  , 111
  , 112
  , 113
  , 114
  , 115
  , 116
  , 117
  , 118
  , 119
  , 120
  , 121
  , 122
  , 36
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 48
  , 49
  , 50
  , 51
  , 52
  , 53
  , 54
  , 55
  , 56
  , 57
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 65
  , 66
  , 67
  , 68
  , 69
  , 70
  , 71
  , 72
  , 73
  , 74
  , 75
  , 76
  , 77
  , 78
  , 79
  , 80
  , 81
  , 82
  , 83
  , 84
  , 85
  , 86
  , 87
  , 88
  , 89
  , 90
  , -1
  , -1
  , -1
  , -1
  , 95
  , -1
  , 97
  , 98
  , 99
  , 100
  , 101
  , 102
  , 103
  , 104
  , 105
  , 106
  , 107
  , 108
  , 109
  , 110
  , 111
  , 112
  , 113
  , 114
  , 115
  , 116
  , 117
  , 118
  , 119
  , 120
  , 121
  , 122
  , 36
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 48
  , 49
  , 50
  , 51
  , 52
  , 53
  , 54
  , 55
  , 56
  , 57
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 65
  , 66
  , 67
  , 68
  , 69
  , 70
  , 71
  , 72
  , 73
  , 74
  , 75
  , 76
  , 77
  , 78
  , 79
  , 80
  , 81
  , 82
  , 83
  , 84
  , 85
  , 86
  , 87
  , 88
  , 89
  , 90
  , -1
  , -1
  , -1
  , -1
  , 95
  , -1
  , 97
  , 98
  , 99
  , 100
  , 101
  , 102
  , 103
  , 104
  , 105
  , 106
  , 107
  , 108
  , 109
  , 110
  , 111
  , 112
  , 113
  , 114
  , 115
  , 116
  , 117
  , 118
  , 119
  , 120
  , 121
  , 122
  , 36
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 48
  , 49
  , 50
  , 51
  , 52
  , 53
  , 54
  , 55
  , 56
  , 57
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 65
  , 66
  , 67
  , 68
  , 69
  , 70
  , 71
  , 72
  , 73
  , 74
  , 75
  , 76
  , 77
  , 78
  , 79
  , 80
  , 81
  , 82
  , 83
  , 84
  , 85
  , 86
  , 87
  , 88
  , 89
  , 90
  , -1
  , -1
  , -1
  , -1
  , 95
  , -1
  , 97
  , 98
  , 99
  , 100
  , 101
  , 102
  , 103
  , 104
  , 105
  , 106
  , 107
  , 108
  , 109
  , 110
  , 111
  , 112
  , 113
  , 114
  , 115
  , 116
  , 117
  , 118
  , 119
  , 120
  , 121
  , 122
  , 36
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 48
  , 49
  , 50
  , 51
  , 52
  , 53
  , 54
  , 55
  , 56
  , 57
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 65
  , 66
  , 67
  , 68
  , 69
  , 70
  , 71
  , 72
  , 73
  , 74
  , 75
  , 76
  , 77
  , 78
  , 79
  , 80
  , 81
  , 82
  , 83
  , 84
  , 85
  , 86
  , 87
  , 88
  , 89
  , 90
  , -1
  , -1
  , -1
  , -1
  , 95
  , -1
  , 97
  , 98
  , 99
  , 100
  , 101
  , 102
  , 103
  , 104
  , 105
  , 106
  , 107
  , 108
  , 109
  , 110
  , 111
  , 112
  , 113
  , 114
  , 115
  , 116
  , 117
  , 118
  , 119
  , 120
  , 121
  , 122
  , 36
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 48
  , 49
  , 50
  , 51
  , 52
  , 53
  , 54
  , 55
  , 56
  , 57
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 65
  , 66
  , 67
  , 68
  , 69
  , 70
  , 71
  , 72
  , 73
  , 74
  , 75
  , 76
  , 77
  , 78
  , 79
  , 80
  , 81
  , 82
  , 83
  , 84
  , 85
  , 86
  , 87
  , 88
  , 89
  , 90
  , -1
  , -1
  , -1
  , -1
  , 95
  , -1
  , 97
  , 98
  , 99
  , 100
  , 101
  , 102
  , 103
  , 104
  , 105
  , 106
  , 107
  , 108
  , 109
  , 110
  , 111
  , 112
  , 113
  , 114
  , 115
  , 116
  , 117
  , 118
  , 119
  , 120
  , 121
  , 122
  , 36
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 48
  , 49
  , 50
  , 51
  , 52
  , 53
  , 54
  , 55
  , 56
  , 57
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 65
  , 66
  , 67
  , 68
  , 69
  , 70
  , 71
  , 72
  , 73
  , 74
  , 75
  , 76
  , 77
  , 78
  , 79
  , 80
  , 81
  , 82
  , 83
  , 84
  , 85
  , 86
  , 87
  , 88
  , 89
  , 90
  , -1
  , -1
  , -1
  , -1
  , 95
  , -1
  , 97
  , 98
  , 99
  , 100
  , 101
  , 102
  , 103
  , 104
  , 105
  , 106
  , 107
  , 108
  , 109
  , 110
  , 111
  , 112
  , 113
  , 114
  , 115
  , 116
  , 117
  , 118
  , 119
  , 120
  , 121
  , 122
  , 36
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 48
  , 49
  , 50
  , 51
  , 52
  , 53
  , 54
  , 55
  , 56
  , 57
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 65
  , 66
  , 67
  , 68
  , 69
  , 70
  , 71
  , 72
  , 73
  , 74
  , 75
  , 76
  , 77
  , 78
  , 79
  , 80
  , 81
  , 82
  , 83
  , 84
  , 85
  , 86
  , 87
  , 88
  , 89
  , 90
  , -1
  , -1
  , -1
  , -1
  , 95
  , -1
  , 97
  , 98
  , 99
  , 100
  , 101
  , 102
  , 103
  , 104
  , 105
  , 106
  , 107
  , 108
  , 109
  , 110
  , 111
  , 112
  , 113
  , 114
  , 115
  , 116
  , 117
  , 118
  , 119
  , 120
  , 121
  , 122
  , 36
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 48
  , 49
  , 50
  , 51
  , 52
  , 53
  , 54
  , 55
  , 56
  , 57
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 65
  , 66
  , 67
  , 68
  , 69
  , 70
  , 71
  , 72
  , 73
  , 74
  , 75
  , 76
  , 77
  , 78
  , 79
  , 80
  , 81
  , 82
  , 83
  , 84
  , 85
  , 86
  , 87
  , 88
  , 89
  , 90
  , -1
  , -1
  , -1
  , -1
  , 95
  , -1
  , 97
  , 98
  , 99
  , 100
  , 101
  , 102
  , 103
  , 104
  , 105
  , 106
  , 107
  , 108
  , 109
  , 110
  , 111
  , 112
  , 113
  , 114
  , 115
  , 116
  , 117
  , 118
  , 119
  , 120
  , 121
  , 122
  , 36
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 48
  , 49
  , 50
  , 51
  , 52
  , 53
  , 54
  , 55
  , 56
  , 57
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 65
  , 66
  , 67
  , 68
  , 69
  , 70
  , 71
  , 72
  , 73
  , 74
  , 75
  , 76
  , 77
  , 78
  , 79
  , 80
  , 81
  , 82
  , 83
  , 84
  , 85
  , 86
  , 87
  , 88
  , 89
  , 90
  , -1
  , -1
  , -1
  , -1
  , 95
  , -1
  , 97
  , 98
  , 99
  , 100
  , 101
  , 102
  , 103
  , 104
  , 105
  , 106
  , 107
  , 108
  , 109
  , 110
  , 111
  , 112
  , 113
  , 114
  , 115
  , 116
  , 117
  , 118
  , 119
  , 120
  , 121
  , 122
  , 36
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 48
  , 49
  , 50
  , 51
  , 52
  , 53
  , 54
  , 55
  , 56
  , 57
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 65
  , 66
  , 67
  , 68
  , 69
  , 70
  , 71
  , 72
  , 73
  , 74
  , 75
  , 76
  , 77
  , 78
  , 79
  , 80
  , 81
  , 82
  , 83
  , 84
  , 85
  , 86
  , 87
  , 88
  , 89
  , 90
  , -1
  , -1
  , -1
  , -1
  , 95
  , -1
  , 97
  , 98
  , 99
  , 100
  , 101
  , 102
  , 103
  , 104
  , 105
  , 106
  , 107
  , 108
  , 109
  , 110
  , 111
  , 112
  , 113
  , 114
  , 115
  , 116
  , 117
  , 118
  , 119
  , 120
  , 121
  , 122
  , 36
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 48
  , 49
  , 50
  , 51
  , 52
  , 53
  , 54
  , 55
  , 56
  , 57
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 65
  , 66
  , 67
  , 68
  , 69
  , 70
  , 71
  , 72
  , 73
  , 74
  , 75
  , 76
  , 77
  , 78
  , 79
  , 80
  , 81
  , 82
  , 83
  , 84
  , 85
  , 86
  , 87
  , 88
  , 89
  , 90
  , -1
  , -1
  , -1
  , -1
  , 95
  , -1
  , 97
  , 98
  , 99
  , 100
  , 101
  , 102
  , 103
  , 104
  , 105
  , 106
  , 107
  , 108
  , 109
  , 110
  , 111
  , 112
  , 113
  , 114
  , 115
  , 116
  , 117
  , 118
  , 119
  , 120
  , 121
  , 122
  , 36
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 48
  , 49
  , 50
  , 51
  , 52
  , 53
  , 54
  , 55
  , 56
  , 57
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 65
  , 66
  , 67
  , 68
  , 69
  , 70
  , 71
  , 72
  , 73
  , 74
  , 75
  , 76
  , 77
  , 78
  , 79
  , 80
  , 81
  , 82
  , 83
  , 84
  , 85
  , 86
  , 87
  , 88
  , 89
  , 90
  , -1
  , -1
  , -1
  , -1
  , 95
  , -1
  , 97
  , 98
  , 99
  , 100
  , 101
  , 102
  , 103
  , 104
  , 105
  , 106
  , 107
  , 108
  , 109
  , 110
  , 111
  , 112
  , 113
  , 114
  , 115
  , 116
  , 117
  , 118
  , 119
  , 120
  , 121
  , 122
  , 36
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 48
  , 49
  , 50
  , 51
  , 52
  , 53
  , 54
  , 55
  , 56
  , 57
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 65
  , 66
  , 67
  , 68
  , 69
  , 70
  , 71
  , 72
  , 73
  , 74
  , 75
  , 76
  , 77
  , 78
  , 79
  , 80
  , 81
  , 82
  , 83
  , 84
  , 85
  , 86
  , 87
  , 88
  , 89
  , 90
  , -1
  , -1
  , -1
  , -1
  , 95
  , -1
  , 97
  , 98
  , 99
  , 100
  , 101
  , 102
  , 103
  , 104
  , 105
  , 106
  , 107
  , 108
  , 109
  , 110
  , 111
  , 112
  , 113
  , 114
  , 115
  , 116
  , 117
  , 118
  , 119
  , 120
  , 121
  , 122
  , 36
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 48
  , 49
  , 50
  , 51
  , 52
  , 53
  , 54
  , 55
  , 56
  , 57
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 65
  , 66
  , 67
  , 68
  , 69
  , 70
  , 71
  , 72
  , 73
  , 74
  , 75
  , 76
  , 77
  , 78
  , 79
  , 80
  , 81
  , 82
  , 83
  , 84
  , 85
  , 86
  , 87
  , 88
  , 89
  , 90
  , -1
  , -1
  , -1
  , -1
  , 95
  , -1
  , 97
  , 98
  , 99
  , 100
  , 101
  , 102
  , 103
  , 104
  , 105
  , 106
  , 107
  , 108
  , 109
  , 110
  , 111
  , 112
  , 113
  , 114
  , 115
  , 116
  , 117
  , 118
  , 119
  , 120
  , 121
  , 122
  , 36
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 48
  , 49
  , 50
  , 51
  , 52
  , 53
  , 54
  , 55
  , 56
  , 57
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 65
  , 66
  , 67
  , 68
  , 69
  , 70
  , 71
  , 72
  , 73
  , 74
  , 75
  , 76
  , 77
  , 78
  , 79
  , 80
  , 81
  , 82
  , 83
  , 84
  , 85
  , 86
  , 87
  , 88
  , 89
  , 90
  , -1
  , -1
  , -1
  , -1
  , 95
  , -1
  , 97
  , 98
  , 99
  , 100
  , 101
  , 102
  , 103
  , 104
  , 105
  , 106
  , 107
  , 108
  , 109
  , 110
  , 111
  , 112
  , 113
  , 114
  , 115
  , 116
  , 117
  , 118
  , 119
  , 120
  , 121
  , 122
  , 36
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 48
  , 49
  , 50
  , 51
  , 52
  , 53
  , 54
  , 55
  , 56
  , 57
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 65
  , 66
  , 67
  , 68
  , 69
  , 70
  , 71
  , 72
  , 73
  , 74
  , 75
  , 76
  , 77
  , 78
  , 79
  , 80
  , 81
  , 82
  , 83
  , 84
  , 85
  , 86
  , 87
  , 88
  , 89
  , 90
  , -1
  , -1
  , -1
  , -1
  , 95
  , -1
  , 97
  , 98
  , 99
  , 100
  , 101
  , 102
  , 103
  , 104
  , 105
  , 106
  , 107
  , 108
  , 109
  , 110
  , 111
  , 112
  , 113
  , 114
  , 115
  , 116
  , 117
  , 118
  , 119
  , 120
  , 121
  , 122
  , 36
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 48
  , 49
  , 50
  , 51
  , 52
  , 53
  , 54
  , 55
  , 56
  , 57
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 65
  , 66
  , 67
  , 68
  , 69
  , 70
  , 71
  , 72
  , 73
  , 74
  , 75
  , 76
  , 77
  , 78
  , 79
  , 80
  , 81
  , 82
  , 83
  , 84
  , 85
  , 86
  , 87
  , 88
  , 89
  , 90
  , -1
  , -1
  , -1
  , -1
  , 95
  , -1
  , 97
  , 98
  , 99
  , 100
  , 101
  , 102
  , 103
  , 104
  , 105
  , 106
  , 107
  , 108
  , 109
  , 110
  , 111
  , 112
  , 113
  , 114
  , 115
  , 116
  , 117
  , 118
  , 119
  , 120
  , 121
  , 122
  , 36
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 48
  , 49
  , 50
  , 51
  , 52
  , 53
  , 54
  , 55
  , 56
  , 57
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 65
  , 66
  , 67
  , 68
  , 69
  , 70
  , 71
  , 72
  , 73
  , 74
  , 75
  , 76
  , 77
  , 78
  , 79
  , 80
  , 81
  , 82
  , 83
  , 84
  , 85
  , 86
  , 87
  , 88
  , 89
  , 90
  , -1
  , -1
  , -1
  , -1
  , 95
  , -1
  , 97
  , 98
  , 99
  , 100
  , 101
  , 102
  , 103
  , 104
  , 105
  , 106
  , 107
  , 108
  , 109
  , 110
  , 111
  , 112
  , 113
  , 114
  , 115
  , 116
  , 117
  , 118
  , 119
  , 120
  , 121
  , 122
  , 36
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 48
  , 49
  , 50
  , 51
  , 52
  , 53
  , 54
  , 55
  , 56
  , 57
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 65
  , 66
  , 67
  , 68
  , 69
  , 70
  , 71
  , 72
  , 73
  , 74
  , 75
  , 76
  , 77
  , 78
  , 79
  , 80
  , 81
  , 82
  , 83
  , 84
  , 85
  , 86
  , 87
  , 88
  , 89
  , 90
  , -1
  , -1
  , -1
  , -1
  , 95
  , -1
  , 97
  , 98
  , 99
  , 100
  , 101
  , 102
  , 103
  , 104
  , 105
  , 106
  , 107
  , 108
  , 109
  , 110
  , 111
  , 112
  , 113
  , 114
  , 115
  , 116
  , 117
  , 118
  , 119
  , 120
  , 121
  , 122
  , 36
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 48
  , 49
  , 50
  , 51
  , 52
  , 53
  , 54
  , 55
  , 56
  , 57
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 65
  , 66
  , 67
  , 68
  , 69
  , 70
  , 71
  , 72
  , 73
  , 74
  , 75
  , 76
  , 77
  , 78
  , 79
  , 80
  , 81
  , 82
  , 83
  , 84
  , 85
  , 86
  , 87
  , 88
  , 89
  , 90
  , -1
  , -1
  , -1
  , -1
  , 95
  , -1
  , 97
  , 98
  , 99
  , 100
  , 101
  , 102
  , 103
  , 104
  , 105
  , 106
  , 107
  , 108
  , 109
  , 110
  , 111
  , 112
  , 113
  , 114
  , 115
  , 116
  , 117
  , 118
  , 119
  , 120
  , 121
  , 122
  , 36
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 48
  , 49
  , 50
  , 51
  , 52
  , 53
  , 54
  , 55
  , 56
  , 57
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 65
  , 66
  , 67
  , 68
  , 69
  , 70
  , 71
  , 72
  , 73
  , 74
  , 75
  , 76
  , 77
  , 78
  , 79
  , 80
  , 81
  , 82
  , 83
  , 84
  , 85
  , 86
  , 87
  , 88
  , 89
  , 90
  , -1
  , -1
  , -1
  , -1
  , 95
  , -1
  , 97
  , 98
  , 99
  , 100
  , 101
  , 102
  , 103
  , 104
  , 105
  , 106
  , 107
  , 108
  , 109
  , 110
  , 111
  , 112
  , 113
  , 114
  , 115
  , 116
  , 117
  , 118
  , 119
  , 120
  , 121
  , 122
  , 36
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 48
  , 49
  , 50
  , 51
  , 52
  , 53
  , 54
  , 55
  , 56
  , 57
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 65
  , 66
  , 67
  , 68
  , 69
  , 70
  , 71
  , 72
  , 73
  , 74
  , 75
  , 76
  , 77
  , 78
  , 79
  , 80
  , 81
  , 82
  , 83
  , 84
  , 85
  , 86
  , 87
  , 88
  , 89
  , 90
  , -1
  , -1
  , -1
  , -1
  , 95
  , -1
  , 97
  , 98
  , 99
  , 100
  , 101
  , 102
  , 103
  , 104
  , 105
  , 106
  , 107
  , 108
  , 109
  , 110
  , 111
  , 112
  , 113
  , 114
  , 115
  , 116
  , 117
  , 118
  , 119
  , 120
  , 121
  , 122
  , 36
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 48
  , 49
  , 50
  , 51
  , 52
  , 53
  , 54
  , 55
  , 56
  , 57
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 65
  , 66
  , 67
  , 68
  , 69
  , 70
  , 71
  , 72
  , 73
  , 74
  , 75
  , 76
  , 77
  , 78
  , 79
  , 80
  , 81
  , 82
  , 83
  , 84
  , 85
  , 86
  , 87
  , 88
  , 89
  , 90
  , -1
  , -1
  , -1
  , -1
  , 95
  , -1
  , 97
  , 98
  , 99
  , 100
  , 101
  , 102
  , 103
  , 104
  , 105
  , 106
  , 107
  , 108
  , 109
  , 110
  , 111
  , 112
  , 113
  , 114
  , 115
  , 116
  , 117
  , 118
  , 119
  , 120
  , 121
  , 122
  , 36
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 48
  , 49
  , 50
  , 51
  , 52
  , 53
  , 54
  , 55
  , 56
  , 57
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 65
  , 66
  , 67
  , 68
  , 69
  , 70
  , 71
  , 72
  , 73
  , 74
  , 75
  , 76
  , 77
  , 78
  , 79
  , 80
  , 81
  , 82
  , 83
  , 84
  , 85
  , 86
  , 87
  , 88
  , 89
  , 90
  , -1
  , -1
  , -1
  , -1
  , 95
  , -1
  , 97
  , 98
  , 99
  , 100
  , 101
  , 102
  , 103
  , 104
  , 105
  , 106
  , 107
  , 108
  , 109
  , 110
  , 111
  , 112
  , 113
  , 114
  , 115
  , 116
  , 117
  , 118
  , 119
  , 120
  , 121
  , 122
  , 36
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 48
  , 49
  , 50
  , 51
  , 52
  , 53
  , 54
  , 55
  , 56
  , 57
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 65
  , 66
  , 67
  , 68
  , 69
  , 70
  , 71
  , 72
  , 73
  , 74
  , 75
  , 76
  , 77
  , 78
  , 79
  , 80
  , 81
  , 82
  , 83
  , 84
  , 85
  , 86
  , 87
  , 88
  , 89
  , 90
  , -1
  , -1
  , -1
  , -1
  , 95
  , -1
  , 97
  , 98
  , 99
  , 100
  , 101
  , 102
  , 103
  , 104
  , 105
  , 106
  , 107
  , 108
  , 109
  , 110
  , 111
  , 112
  , 113
  , 114
  , 115
  , 116
  , 117
  , 118
  , 119
  , 120
  , 121
  , 122
  , 36
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 48
  , 49
  , 50
  , 51
  , 52
  , 53
  , 54
  , 55
  , 56
  , 57
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 65
  , 66
  , 67
  , 68
  , 69
  , 70
  , 71
  , 72
  , 73
  , 74
  , 75
  , 76
  , 77
  , 78
  , 79
  , 80
  , 81
  , 82
  , 83
  , 84
  , 85
  , 86
  , 87
  , 88
  , 89
  , 90
  , -1
  , -1
  , -1
  , -1
  , 95
  , -1
  , 97
  , 98
  , 99
  , 100
  , 101
  , 102
  , 103
  , 104
  , 105
  , 106
  , 107
  , 108
  , 109
  , 110
  , 111
  , 112
  , 113
  , 114
  , 115
  , 116
  , 117
  , 118
  , 119
  , 120
  , 121
  , 122
  , 36
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 48
  , 49
  , 50
  , 51
  , 52
  , 53
  , 54
  , 55
  , 56
  , 57
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 65
  , 66
  , 67
  , 68
  , 69
  , 70
  , 71
  , 72
  , 73
  , 74
  , 75
  , 76
  , 77
  , 78
  , 79
  , 80
  , 81
  , 82
  , 83
  , 84
  , 85
  , 86
  , 87
  , 88
  , 89
  , 90
  , -1
  , -1
  , -1
  , -1
  , 95
  , -1
  , 97
  , 98
  , 99
  , 100
  , 101
  , 102
  , 103
  , 104
  , 105
  , 106
  , 107
  , 108
  , 109
  , 110
  , 111
  , 112
  , 113
  , 114
  , 115
  , 116
  , 117
  , 118
  , 119
  , 120
  , 121
  , 122
  , 36
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 48
  , 49
  , 50
  , 51
  , 52
  , 53
  , 54
  , 55
  , 56
  , 57
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 65
  , 66
  , 67
  , 68
  , 69
  , 70
  , 71
  , 72
  , 73
  , 74
  , 75
  , 76
  , 77
  , 78
  , 79
  , 80
  , 81
  , 82
  , 83
  , 84
  , 85
  , 86
  , 87
  , 88
  , 89
  , 90
  , -1
  , -1
  , -1
  , -1
  , 95
  , -1
  , 97
  , 98
  , 99
  , 100
  , 101
  , 102
  , 103
  , 104
  , 105
  , 106
  , 107
  , 108
  , 109
  , 110
  , 111
  , 112
  , 113
  , 114
  , 115
  , 116
  , 117
  , 118
  , 119
  , 120
  , 121
  , 122
  , 36
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 48
  , 49
  , 50
  , 51
  , 52
  , 53
  , 54
  , 55
  , 56
  , 57
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 65
  , 66
  , 67
  , 68
  , 69
  , 70
  , 71
  , 72
  , 73
  , 74
  , 75
  , 76
  , 77
  , 78
  , 79
  , 80
  , 81
  , 82
  , 83
  , 84
  , 85
  , 86
  , 87
  , 88
  , 89
  , 90
  , -1
  , -1
  , -1
  , -1
  , 95
  , -1
  , 97
  , 98
  , 99
  , 100
  , 101
  , 102
  , 103
  , 104
  , 105
  , 106
  , 107
  , 108
  , 109
  , 110
  , 111
  , 112
  , 113
  , 114
  , 115
  , 116
  , 117
  , 118
  , 119
  , 120
  , 121
  , 122
  , 36
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 48
  , 49
  , 50
  , 51
  , 52
  , 53
  , 54
  , 55
  , 56
  , 57
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 65
  , 66
  , 67
  , 68
  , 69
  , 70
  , 71
  , 72
  , 73
  , 74
  , 75
  , 76
  , 77
  , 78
  , 79
  , 80
  , 81
  , 82
  , 83
  , 84
  , 85
  , 86
  , 87
  , 88
  , 89
  , 90
  , -1
  , -1
  , -1
  , -1
  , 95
  , -1
  , 97
  , 98
  , 99
  , 100
  , 101
  , 102
  , 103
  , 104
  , 105
  , 106
  , 107
  , 108
  , 109
  , 110
  , 111
  , 112
  , 113
  , 114
  , 115
  , 116
  , 117
  , 118
  , 119
  , 120
  , 121
  , 122
  , 36
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 48
  , 49
  , 50
  , 51
  , 52
  , 53
  , 54
  , 55
  , 56
  , 57
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 65
  , 66
  , 67
  , 68
  , 69
  , 70
  , 71
  , 72
  , 73
  , 74
  , 75
  , 76
  , 77
  , 78
  , 79
  , 80
  , 81
  , 82
  , 83
  , 84
  , 85
  , 86
  , 87
  , 88
  , 89
  , 90
  , -1
  , -1
  , -1
  , -1
  , 95
  , -1
  , 97
  , 98
  , 99
  , 100
  , 101
  , 102
  , 103
  , 104
  , 105
  , 106
  , 107
  , 108
  , 109
  , 110
  , 111
  , 112
  , 113
  , 114
  , 115
  , 116
  , 117
  , 118
  , 119
  , 120
  , 121
  , 122
  , 36
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 48
  , 49
  , 50
  , 51
  , 52
  , 53
  , 54
  , 55
  , 56
  , 57
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 65
  , 66
  , 67
  , 68
  , 69
  , 70
  , 71
  , 72
  , 73
  , 74
  , 75
  , 76
  , 77
  , 78
  , 79
  , 80
  , 81
  , 82
  , 83
  , 84
  , 85
  , 86
  , 87
  , 88
  , 89
  , 90
  , -1
  , -1
  , -1
  , -1
  , 95
  , -1
  , 97
  , 98
  , 99
  , 100
  , 101
  , 102
  , 103
  , 104
  , 105
  , 106
  , 107
  , 108
  , 109
  , 110
  , 111
  , 112
  , 113
  , 114
  , 115
  , 116
  , 117
  , 118
  , 119
  , 120
  , 121
  , 122
  , 36
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 48
  , 49
  , 50
  , 51
  , 52
  , 53
  , 54
  , 55
  , 56
  , 57
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 65
  , 66
  , 67
  , 68
  , 69
  , 70
  , 71
  , 72
  , 73
  , 74
  , 75
  , 76
  , 77
  , 78
  , 79
  , 80
  , 81
  , 82
  , 83
  , 84
  , 85
  , 86
  , 87
  , 88
  , 89
  , 90
  , -1
  , -1
  , -1
  , -1
  , 95
  , -1
  , 97
  , 98
  , 99
  , 100
  , 101
  , 102
  , 103
  , 104
  , 105
  , 106
  , 107
  , 108
  , 109
  , 110
  , 111
  , 112
  , 113
  , 114
  , 115
  , 116
  , 117
  , 118
  , 119
  , 120
  , 121
  , 122
  , 36
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 48
  , 49
  , 50
  , 51
  , 52
  , 53
  , 54
  , 55
  , 56
  , 57
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 65
  , 66
  , 67
  , 68
  , 69
  , 70
  , 71
  , 72
  , 73
  , 74
  , 75
  , 76
  , 77
  , 78
  , 79
  , 80
  , 81
  , 82
  , 83
  , 84
  , 85
  , 86
  , 87
  , 88
  , 89
  , 90
  , -1
  , -1
  , -1
  , -1
  , 95
  , -1
  , 97
  , 98
  , 99
  , 100
  , 101
  , 102
  , 103
  , 104
  , 105
  , 106
  , 107
  , 108
  , 109
  , 110
  , 111
  , 112
  , 113
  , 114
  , 115
  , 116
  , 117
  , 118
  , 119
  , 120
  , 121
  , 122
  , 36
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 48
  , 49
  , 50
  , 51
  , 52
  , 53
  , 54
  , 55
  , 56
  , 57
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 65
  , 66
  , 67
  , 68
  , 69
  , 70
  , 71
  , 72
  , 73
  , 74
  , 75
  , 76
  , 77
  , 78
  , 79
  , 80
  , 81
  , 82
  , 83
  , 84
  , 85
  , 86
  , 87
  , 88
  , 89
  , 90
  , -1
  , -1
  , -1
  , -1
  , 95
  , -1
  , 97
  , 98
  , 99
  , 100
  , 101
  , 102
  , 103
  , 104
  , 105
  , 106
  , 107
  , 108
  , 109
  , 110
  , 111
  , 112
  , 113
  , 114
  , 115
  , 116
  , 117
  , 118
  , 119
  , 120
  , 121
  , 122
  , 36
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 48
  , 49
  , 50
  , 51
  , 52
  , 53
  , 54
  , 55
  , 56
  , 57
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 65
  , 66
  , 67
  , 68
  , 69
  , 70
  , 71
  , 72
  , 73
  , 74
  , 75
  , 76
  , 77
  , 78
  , 79
  , 80
  , 81
  , 82
  , 83
  , 84
  , 85
  , 86
  , 87
  , 88
  , 89
  , 90
  , -1
  , -1
  , -1
  , -1
  , 95
  , -1
  , 97
  , 98
  , 99
  , 100
  , 101
  , 102
  , 103
  , 104
  , 105
  , 106
  , 107
  , 108
  , 109
  , 110
  , 111
  , 112
  , 113
  , 114
  , 115
  , 116
  , 117
  , 118
  , 119
  , 120
  , 121
  , 122
  , 36
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 48
  , 49
  , 50
  , 51
  , 52
  , 53
  , 54
  , 55
  , 56
  , 57
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 65
  , 66
  , 67
  , 68
  , 69
  , 70
  , 71
  , 72
  , 73
  , 74
  , 75
  , 76
  , 77
  , 78
  , 79
  , 80
  , 81
  , 82
  , 83
  , 84
  , 85
  , 86
  , 87
  , 88
  , 89
  , 90
  , -1
  , -1
  , -1
  , -1
  , 95
  , -1
  , 97
  , 98
  , 99
  , 100
  , 101
  , 102
  , 103
  , 104
  , 105
  , 106
  , 107
  , 108
  , 109
  , 110
  , 111
  , 112
  , 113
  , 114
  , 115
  , 116
  , 117
  , 118
  , 119
  , 120
  , 121
  , 122
  , 36
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 48
  , 49
  , 50
  , 51
  , 52
  , 53
  , 54
  , 55
  , 56
  , 57
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 65
  , 66
  , 67
  , 68
  , 69
  , 70
  , 71
  , 72
  , 73
  , 74
  , 75
  , 76
  , 77
  , 78
  , 79
  , 80
  , 81
  , 82
  , 83
  , 84
  , 85
  , 86
  , 87
  , 88
  , 89
  , 90
  , -1
  , -1
  , -1
  , -1
  , 95
  , -1
  , 97
  , 98
  , 99
  , 100
  , 101
  , 102
  , 103
  , 104
  , 105
  , 106
  , 107
  , 108
  , 109
  , 110
  , 111
  , 112
  , 113
  , 114
  , 115
  , 116
  , 117
  , 118
  , 119
  , 120
  , 121
  , 122
  , 36
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 48
  , 49
  , 50
  , 51
  , 52
  , 53
  , 54
  , 55
  , 56
  , 57
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 65
  , 66
  , 67
  , 68
  , 69
  , 70
  , 71
  , 72
  , 73
  , 74
  , 75
  , 76
  , 77
  , 78
  , 79
  , 80
  , 81
  , 82
  , 83
  , 84
  , 85
  , 86
  , 87
  , 88
  , 89
  , 90
  , -1
  , -1
  , -1
  , -1
  , 95
  , -1
  , 97
  , 98
  , 99
  , 100
  , 101
  , 102
  , 103
  , 104
  , 105
  , 106
  , 107
  , 108
  , 109
  , 110
  , 111
  , 112
  , 113
  , 114
  , 115
  , 116
  , 117
  , 118
  , 119
  , 120
  , 121
  , 122
  , 36
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 48
  , 49
  , 50
  , 51
  , 52
  , 53
  , 54
  , 55
  , 56
  , 57
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 65
  , 66
  , 67
  , 68
  , 69
  , 70
  , 71
  , 72
  , 73
  , 74
  , 75
  , 76
  , 77
  , 78
  , 79
  , 80
  , 81
  , 82
  , 83
  , 84
  , 85
  , 86
  , 87
  , 88
  , 89
  , 90
  , -1
  , -1
  , -1
  , -1
  , 95
  , -1
  , 97
  , 98
  , 99
  , 100
  , 101
  , 102
  , 103
  , 104
  , 105
  , 106
  , 107
  , 108
  , 109
  , 110
  , 111
  , 112
  , 113
  , 114
  , 115
  , 116
  , 117
  , 118
  , 119
  , 120
  , 121
  , 122
  , 36
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 48
  , 49
  , 50
  , 51
  , 52
  , 53
  , 54
  , 55
  , 56
  , 57
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 65
  , 66
  , 67
  , 68
  , 69
  , 70
  , 71
  , 72
  , 73
  , 74
  , 75
  , 76
  , 77
  , 78
  , 79
  , 80
  , 81
  , 82
  , 83
  , 84
  , 85
  , 86
  , 87
  , 88
  , 89
  , 90
  , -1
  , -1
  , -1
  , -1
  , 95
  , -1
  , 97
  , 98
  , 99
  , 100
  , 101
  , 102
  , 103
  , 104
  , 105
  , 106
  , 107
  , 108
  , 109
  , 110
  , 111
  , 112
  , 113
  , 114
  , 115
  , 116
  , 117
  , 118
  , 119
  , 120
  , 121
  , 122
  , 36
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 48
  , 49
  , 50
  , 51
  , 52
  , 53
  , 54
  , 55
  , 56
  , 57
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 65
  , 66
  , 67
  , 68
  , 69
  , 70
  , 71
  , 72
  , 73
  , 74
  , 75
  , 76
  , 77
  , 78
  , 79
  , 80
  , 81
  , 82
  , 83
  , 84
  , 85
  , 86
  , 87
  , 88
  , 89
  , 90
  , -1
  , -1
  , -1
  , -1
  , 95
  , -1
  , 97
  , 98
  , 99
  , 100
  , 101
  , 102
  , 103
  , 104
  , 105
  , 106
  , 107
  , 108
  , 109
  , 110
  , 111
  , 112
  , 113
  , 114
  , 115
  , 116
  , 117
  , 118
  , 119
  , 120
  , 121
  , 122
  , 36
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 48
  , 49
  , 50
  , 51
  , 52
  , 53
  , 54
  , 55
  , 56
  , 57
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 65
  , 66
  , 67
  , 68
  , 69
  , 70
  , 71
  , 72
  , 73
  , 74
  , 75
  , 76
  , 77
  , 78
  , 79
  , 80
  , 81
  , 82
  , 83
  , 84
  , 85
  , 86
  , 87
  , 88
  , 89
  , 90
  , -1
  , -1
  , -1
  , -1
  , 95
  , -1
  , 97
  , 98
  , 99
  , 100
  , 101
  , 102
  , 103
  , 104
  , 105
  , 106
  , 107
  , 108
  , 109
  , 110
  , 111
  , 112
  , 113
  , 114
  , 115
  , 116
  , 117
  , 118
  , 119
  , 120
  , 121
  , 122
  , 36
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 48
  , 49
  , 50
  , 51
  , 52
  , 53
  , 54
  , 55
  , 56
  , 57
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 65
  , 66
  , 67
  , 68
  , 69
  , 70
  , 71
  , 72
  , 73
  , 74
  , 75
  , 76
  , 77
  , 78
  , 79
  , 80
  , 81
  , 82
  , 83
  , 84
  , 85
  , 86
  , 87
  , 88
  , 89
  , 90
  , -1
  , -1
  , -1
  , -1
  , 95
  , -1
  , 97
  , 98
  , 99
  , 100
  , 101
  , 102
  , 103
  , 104
  , 105
  , 106
  , 107
  , 108
  , 109
  , 110
  , 111
  , 112
  , 113
  , 114
  , 115
  , 116
  , 117
  , 118
  , 119
  , 120
  , 121
  , 122
  , 36
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 48
  , 49
  , 50
  , 51
  , 52
  , 53
  , 54
  , 55
  , 56
  , 57
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 65
  , 66
  , 67
  , 68
  , 69
  , 70
  , 71
  , 72
  , 73
  , 74
  , 75
  , 76
  , 77
  , 78
  , 79
  , 80
  , 81
  , 82
  , 83
  , 84
  , 85
  , 86
  , 87
  , 88
  , 89
  , 90
  , -1
  , -1
  , -1
  , -1
  , 95
  , -1
  , 97
  , 98
  , 99
  , 100
  , 101
  , 102
  , 103
  , 104
  , 105
  , 106
  , 107
  , 108
  , 109
  , 110
  , 111
  , 112
  , 113
  , 114
  , 115
  , 116
  , 117
  , 118
  , 119
  , 120
  , 121
  , 122
  , 36
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 48
  , 49
  , 50
  , 51
  , 52
  , 53
  , 54
  , 55
  , 56
  , 57
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 65
  , 66
  , 67
  , 68
  , 69
  , 70
  , 71
  , 72
  , 73
  , 74
  , 75
  , 76
  , 77
  , 78
  , 79
  , 80
  , 81
  , 82
  , 83
  , 84
  , 85
  , 86
  , 87
  , 88
  , 89
  , 90
  , -1
  , -1
  , -1
  , -1
  , 95
  , -1
  , 97
  , 98
  , 99
  , 100
  , 101
  , 102
  , 103
  , 104
  , 105
  , 106
  , 107
  , 108
  , 109
  , 110
  , 111
  , 112
  , 113
  , 114
  , 115
  , 116
  , 117
  , 118
  , 119
  , 120
  , 121
  , 122
  , 36
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 48
  , 49
  , 50
  , 51
  , 52
  , 53
  , 54
  , 55
  , 56
  , 57
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 65
  , 66
  , 67
  , 68
  , 69
  , 70
  , 71
  , 72
  , 73
  , 74
  , 75
  , 76
  , 77
  , 78
  , 79
  , 80
  , 81
  , 82
  , 83
  , 84
  , 85
  , 86
  , 87
  , 88
  , 89
  , 90
  , -1
  , -1
  , -1
  , -1
  , 95
  , -1
  , 97
  , 98
  , 99
  , 100
  , 101
  , 102
  , 103
  , 104
  , 105
  , 106
  , 107
  , 108
  , 109
  , 110
  , 111
  , 112
  , 113
  , 114
  , 115
  , 116
  , 117
  , 118
  , 119
  , 120
  , 121
  , 122
  , 36
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 48
  , 49
  , 50
  , 51
  , 52
  , 53
  , 54
  , 55
  , 56
  , 57
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 65
  , 66
  , 67
  , 68
  , 69
  , 70
  , 71
  , 72
  , 73
  , 74
  , 75
  , 76
  , 77
  , 78
  , 79
  , 80
  , 81
  , 82
  , 83
  , 84
  , 85
  , 86
  , 87
  , 88
  , 89
  , 90
  , -1
  , -1
  , -1
  , -1
  , 95
  , -1
  , 97
  , 98
  , 99
  , 100
  , 101
  , 102
  , 103
  , 104
  , 105
  , 106
  , 107
  , 108
  , 109
  , 110
  , 111
  , 112
  , 113
  , 114
  , 115
  , 116
  , 117
  , 118
  , 119
  , 120
  , 121
  , 122
  , 36
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 48
  , 49
  , 50
  , 51
  , 52
  , 53
  , 54
  , 55
  , 56
  , 57
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 65
  , 66
  , 67
  , 68
  , 69
  , 70
  , 71
  , 72
  , 73
  , 74
  , 75
  , 76
  , 77
  , 78
  , 79
  , 80
  , 81
  , 82
  , 83
  , 84
  , 85
  , 86
  , 87
  , 88
  , 89
  , 90
  , -1
  , -1
  , -1
  , -1
  , 95
  , -1
  , 97
  , 98
  , 99
  , 100
  , 101
  , 102
  , 103
  , 104
  , 105
  , 106
  , 107
  , 108
  , 109
  , 110
  , 111
  , 112
  , 113
  , 114
  , 115
  , 116
  , 117
  , 118
  , 119
  , 120
  , 121
  , 122
  , 36
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 48
  , 49
  , 50
  , 51
  , 52
  , 53
  , 54
  , 55
  , 56
  , 57
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 65
  , 66
  , 67
  , 68
  , 69
  , 70
  , 71
  , 72
  , 73
  , 74
  , 75
  , 76
  , 77
  , 78
  , 79
  , 80
  , 81
  , 82
  , 83
  , 84
  , 85
  , 86
  , 87
  , 88
  , 89
  , 90
  , -1
  , -1
  , -1
  , -1
  , 95
  , -1
  , 97
  , 98
  , 99
  , 100
  , 101
  , 102
  , 103
  , 104
  , 105
  , 106
  , 107
  , 108
  , 109
  , 110
  , 111
  , 112
  , 113
  , 114
  , 115
  , 116
  , 117
  , 118
  , 119
  , 120
  , 121
  , 122
  , 36
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 48
  , 49
  , 50
  , 51
  , 52
  , 53
  , 54
  , 55
  , 56
  , 57
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 65
  , 66
  , 67
  , 68
  , 69
  , 70
  , 71
  , 72
  , 73
  , 74
  , 75
  , 76
  , 77
  , 78
  , 79
  , 80
  , 81
  , 82
  , 83
  , 84
  , 85
  , 86
  , 87
  , 88
  , 89
  , 90
  , -1
  , -1
  , -1
  , -1
  , 95
  , -1
  , 97
  , 98
  , 99
  , 100
  , 101
  , 102
  , 103
  , 104
  , 105
  , 106
  , 107
  , 108
  , 109
  , 110
  , 111
  , 112
  , 113
  , 114
  , 115
  , 116
  , 117
  , 118
  , 119
  , 120
  , 121
  , 122
  , 36
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 48
  , 49
  , 50
  , 51
  , 52
  , 53
  , 54
  , 55
  , 56
  , 57
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 65
  , 66
  , 67
  , 68
  , 69
  , 70
  , 71
  , 72
  , 73
  , 74
  , 75
  , 76
  , 77
  , 78
  , 79
  , 80
  , 81
  , 82
  , 83
  , 84
  , 85
  , 86
  , 87
  , 88
  , 89
  , 90
  , -1
  , -1
  , -1
  , -1
  , 95
  , -1
  , 97
  , 98
  , 99
  , 100
  , 101
  , 102
  , 103
  , 104
  , 105
  , 106
  , 107
  , 108
  , 109
  , 110
  , 111
  , 112
  , 113
  , 114
  , 115
  , 116
  , 117
  , 118
  , 119
  , 120
  , 121
  , 122
  , 36
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 48
  , 49
  , 50
  , 51
  , 52
  , 53
  , 54
  , 55
  , 56
  , 57
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 65
  , 66
  , 67
  , 68
  , 69
  , 70
  , 71
  , 72
  , 73
  , 74
  , 75
  , 76
  , 77
  , 78
  , 79
  , 80
  , 81
  , 82
  , 83
  , 84
  , 85
  , 86
  , 87
  , 88
  , 89
  , 90
  , -1
  , -1
  , -1
  , -1
  , 95
  , -1
  , 97
  , 98
  , 99
  , 100
  , 101
  , 102
  , 103
  , 104
  , 105
  , 106
  , 107
  , 108
  , 109
  , 110
  , 111
  , 112
  , 113
  , 114
  , 115
  , 116
  , 117
  , 118
  , 119
  , 120
  , 121
  , 122
  , 36
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 48
  , 49
  , 50
  , 51
  , 52
  , 53
  , 54
  , 55
  , 56
  , 57
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 65
  , 66
  , 67
  , 68
  , 69
  , 70
  , 71
  , 72
  , 73
  , 74
  , 75
  , 76
  , 77
  , 78
  , 79
  , 80
  , 81
  , 82
  , 83
  , 84
  , 85
  , 86
  , 87
  , 88
  , 89
  , 90
  , -1
  , -1
  , -1
  , -1
  , 95
  , -1
  , 97
  , 98
  , 99
  , 100
  , 101
  , 102
  , 103
  , 104
  , 105
  , 106
  , 107
  , 108
  , 109
  , 110
  , 111
  , 112
  , 113
  , 114
  , 115
  , 116
  , 117
  , 118
  , 119
  , 120
  , 121
  , 122
  , 36
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 48
  , 49
  , 50
  , 51
  , 52
  , 53
  , 54
  , 55
  , 56
  , 57
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 65
  , 66
  , 67
  , 68
  , 69
  , 70
  , 71
  , 72
  , 73
  , 74
  , 75
  , 76
  , 77
  , 78
  , 79
  , 80
  , 81
  , 82
  , 83
  , 84
  , 85
  , 86
  , 87
  , 88
  , 89
  , 90
  , -1
  , -1
  , -1
  , -1
  , 95
  , -1
  , 97
  , 98
  , 99
  , 100
  , 101
  , 102
  , 103
  , 104
  , 105
  , 106
  , 107
  , 108
  , 109
  , 110
  , 111
  , 112
  , 113
  , 114
  , 115
  , 116
  , 117
  , 118
  , 119
  , 120
  , 121
  , 122
  , 36
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 48
  , 49
  , 50
  , 51
  , 52
  , 53
  , 54
  , 55
  , 56
  , 57
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 65
  , 66
  , 67
  , 68
  , 69
  , 70
  , 71
  , 72
  , 73
  , 74
  , 75
  , 76
  , 77
  , 78
  , 79
  , 80
  , 81
  , 82
  , 83
  , 84
  , 85
  , 86
  , 87
  , 88
  , 89
  , 90
  , -1
  , -1
  , -1
  , -1
  , 95
  , -1
  , 97
  , 98
  , 99
  , 100
  , 101
  , 102
  , 103
  , 104
  , 105
  , 106
  , 107
  , 108
  , 109
  , 110
  , 111
  , 112
  , 113
  , 114
  , 115
  , 116
  , 117
  , 118
  , 119
  , 120
  , 121
  , 122
  , 36
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 48
  , 49
  , 50
  , 51
  , 52
  , 53
  , 54
  , 55
  , 56
  , 57
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 65
  , 66
  , 67
  , 68
  , 69
  , 70
  , 71
  , 72
  , 73
  , 74
  , 75
  , 76
  , 77
  , 78
  , 79
  , 80
  , 81
  , 82
  , 83
  , 84
  , 85
  , 86
  , 87
  , 88
  , 89
  , 90
  , -1
  , -1
  , -1
  , -1
  , 95
  , -1
  , 97
  , 98
  , 99
  , 100
  , 101
  , 102
  , 103
  , 104
  , 105
  , 106
  , 107
  , 108
  , 109
  , 110
  , 111
  , 112
  , 113
  , 114
  , 115
  , 116
  , 117
  , 118
  , 119
  , 120
  , 121
  , 122
  , 36
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 48
  , 49
  , 50
  , 51
  , 52
  , 53
  , 54
  , 55
  , 56
  , 57
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 65
  , 66
  , 67
  , 68
  , 69
  , 70
  , 71
  , 72
  , 73
  , 74
  , 75
  , 76
  , 77
  , 78
  , 79
  , 80
  , 81
  , 82
  , 83
  , 84
  , 85
  , 86
  , 87
  , 88
  , 89
  , 90
  , -1
  , -1
  , -1
  , -1
  , 95
  , -1
  , 97
  , 98
  , 99
  , 100
  , 101
  , 102
  , 103
  , 104
  , 105
  , 106
  , 107
  , 108
  , 109
  , 110
  , 111
  , 112
  , 113
  , 114
  , 115
  , 116
  , 117
  , 118
  , 119
  , 120
  , 121
  , 122
  , 36
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 48
  , 49
  , 50
  , 51
  , 52
  , 53
  , 54
  , 55
  , 56
  , 57
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 65
  , 66
  , 67
  , 68
  , 69
  , 70
  , 71
  , 72
  , 73
  , 74
  , 75
  , 76
  , 77
  , 78
  , 79
  , 80
  , 81
  , 82
  , 83
  , 84
  , 85
  , 86
  , 87
  , 88
  , 89
  , 90
  , -1
  , -1
  , -1
  , -1
  , 95
  , -1
  , 97
  , 98
  , 99
  , 100
  , 101
  , 102
  , 103
  , 104
  , 105
  , 106
  , 107
  , 108
  , 109
  , 110
  , 111
  , 112
  , 113
  , 114
  , 115
  , 116
  , 117
  , 118
  , 119
  , 120
  , 121
  , 122
  , 36
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 48
  , 49
  , 50
  , 51
  , 52
  , 53
  , 54
  , 55
  , 56
  , 57
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 65
  , 66
  , 67
  , 68
  , 69
  , 70
  , 71
  , 72
  , 73
  , 74
  , 75
  , 76
  , 77
  , 78
  , 79
  , 80
  , 81
  , 82
  , 83
  , 84
  , 85
  , 86
  , 87
  , 88
  , 89
  , 90
  , -1
  , -1
  , -1
  , -1
  , 95
  , -1
  , 97
  , 98
  , 99
  , 100
  , 101
  , 102
  , 103
  , 104
  , 105
  , 106
  , 107
  , 108
  , 109
  , 110
  , 111
  , 112
  , 113
  , 114
  , 115
  , 116
  , 117
  , 118
  , 119
  , 120
  , 121
  , 122
  , 36
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 48
  , 49
  , 50
  , 51
  , 52
  , 53
  , 54
  , 55
  , 56
  , 57
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 65
  , 66
  , 67
  , 68
  , 69
  , 70
  , 71
  , 72
  , 73
  , 74
  , 75
  , 76
  , 77
  , 78
  , 79
  , 80
  , 81
  , 82
  , 83
  , 84
  , 85
  , 86
  , 87
  , 88
  , 89
  , 90
  , -1
  , -1
  , -1
  , -1
  , 95
  , -1
  , 97
  , 98
  , 99
  , 100
  , 101
  , 102
  , 103
  , 104
  , 105
  , 106
  , 107
  , 108
  , 109
  , 110
  , 111
  , 112
  , 113
  , 114
  , 115
  , 116
  , 117
  , 118
  , 119
  , 120
  , 121
  , 122
  , 36
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 48
  , 49
  , 50
  , 51
  , 52
  , 53
  , 54
  , 55
  , 56
  , 57
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 65
  , 66
  , 67
  , 68
  , 69
  , 70
  , 71
  , 72
  , 73
  , 74
  , 75
  , 76
  , 77
  , 78
  , 79
  , 80
  , 81
  , 82
  , 83
  , 84
  , 85
  , 86
  , 87
  , 88
  , 89
  , 90
  , -1
  , -1
  , -1
  , -1
  , 95
  , -1
  , 97
  , 98
  , 99
  , 100
  , 101
  , 102
  , 103
  , 104
  , 105
  , 106
  , 107
  , 108
  , 109
  , 110
  , 111
  , 112
  , 113
  , 114
  , 115
  , 116
  , 117
  , 118
  , 119
  , 120
  , 121
  , 122
  , 36
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 48
  , 49
  , 50
  , 51
  , 52
  , 53
  , 54
  , 55
  , 56
  , 57
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 65
  , 66
  , 67
  , 68
  , 69
  , 70
  , 71
  , 72
  , 73
  , 74
  , 75
  , 76
  , 77
  , 78
  , 79
  , 80
  , 81
  , 82
  , 83
  , 84
  , 85
  , 86
  , 87
  , 88
  , 89
  , 90
  , -1
  , -1
  , -1
  , -1
  , 95
  , -1
  , 97
  , 98
  , 99
  , 100
  , 101
  , 102
  , 103
  , 104
  , 105
  , 106
  , 107
  , 108
  , 109
  , 110
  , 111
  , 112
  , 113
  , 114
  , 115
  , 116
  , 117
  , 118
  , 119
  , 120
  , 121
  , 122
  , 36
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 48
  , 49
  , 50
  , 51
  , 52
  , 53
  , 54
  , 55
  , 56
  , 57
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 65
  , 66
  , 67
  , 68
  , 69
  , 70
  , 71
  , 72
  , 73
  , 74
  , 75
  , 76
  , 77
  , 78
  , 79
  , 80
  , 81
  , 82
  , 83
  , 84
  , 85
  , 86
  , 87
  , 88
  , 89
  , 90
  , -1
  , -1
  , -1
  , -1
  , 95
  , -1
  , 97
  , 98
  , 99
  , 100
  , 101
  , 102
  , 103
  , 104
  , 105
  , 106
  , 107
  , 108
  , 109
  , 110
  , 111
  , 112
  , 113
  , 114
  , 115
  , 116
  , 117
  , 118
  , 119
  , 120
  , 121
  , 122
  , 36
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 48
  , 49
  , 50
  , 51
  , 52
  , 53
  , 54
  , 55
  , 56
  , 57
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 65
  , 66
  , 67
  , 68
  , 69
  , 70
  , 71
  , 72
  , 73
  , 74
  , 75
  , 76
  , 77
  , 78
  , 79
  , 80
  , 81
  , 82
  , 83
  , 84
  , 85
  , 86
  , 87
  , 88
  , 89
  , 90
  , -1
  , -1
  , -1
  , -1
  , 95
  , -1
  , 97
  , 98
  , 99
  , 100
  , 101
  , 102
  , 103
  , 104
  , 105
  , 106
  , 107
  , 108
  , 109
  , 110
  , 111
  , 112
  , 113
  , 114
  , 115
  , 116
  , 117
  , 118
  , 119
  , 120
  , 121
  , 122
  , 36
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 48
  , 49
  , 50
  , 51
  , 52
  , 53
  , 54
  , 55
  , 56
  , 57
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 65
  , 66
  , 67
  , 68
  , 69
  , 70
  , 71
  , 72
  , 73
  , 74
  , 75
  , 76
  , 77
  , 78
  , 79
  , 80
  , 81
  , 82
  , 83
  , 84
  , 85
  , 86
  , 87
  , 88
  , 89
  , 90
  , -1
  , -1
  , -1
  , -1
  , 95
  , -1
  , 97
  , 98
  , 99
  , 100
  , 101
  , 102
  , 103
  , 104
  , 105
  , 106
  , 107
  , 108
  , 109
  , 110
  , 111
  , 112
  , 113
  , 114
  , 115
  , 116
  , 117
  , 118
  , 119
  , 120
  , 121
  , 122
  , 36
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 48
  , 49
  , 50
  , 51
  , 52
  , 53
  , 54
  , 55
  , 56
  , 57
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 65
  , 66
  , 67
  , 68
  , 69
  , 70
  , 71
  , 72
  , 73
  , 74
  , 75
  , 76
  , 77
  , 78
  , 79
  , 80
  , 81
  , 82
  , 83
  , 84
  , 85
  , 86
  , 87
  , 88
  , 89
  , 90
  , -1
  , -1
  , -1
  , -1
  , 95
  , -1
  , 97
  , 98
  , 99
  , 100
  , 101
  , 102
  , 103
  , 104
  , 105
  , 106
  , 107
  , 108
  , 109
  , 110
  , 111
  , 112
  , 113
  , 114
  , 115
  , 116
  , 117
  , 118
  , 119
  , 120
  , 121
  , 122
  , 36
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 48
  , 49
  , 50
  , 51
  , 52
  , 53
  , 54
  , 55
  , 56
  , 57
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 65
  , 66
  , 67
  , 68
  , 69
  , 70
  , 71
  , 72
  , 73
  , 74
  , 75
  , 76
  , 77
  , 78
  , 79
  , 80
  , 81
  , 82
  , 83
  , 84
  , 85
  , 86
  , 87
  , 88
  , 89
  , 90
  , -1
  , -1
  , -1
  , -1
  , 95
  , -1
  , 97
  , 98
  , 99
  , 100
  , 101
  , 102
  , 103
  , 104
  , 105
  , 106
  , 107
  , 108
  , 109
  , 110
  , 111
  , 112
  , 113
  , 114
  , 115
  , 116
  , 117
  , 118
  , 119
  , 120
  , 121
  , 122
  , 36
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 48
  , 49
  , 50
  , 51
  , 52
  , 53
  , 54
  , 55
  , 56
  , 57
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 65
  , 66
  , 67
  , 68
  , 69
  , 70
  , 71
  , 72
  , 73
  , 74
  , 75
  , 76
  , 77
  , 78
  , 79
  , 80
  , 81
  , 82
  , 83
  , 84
  , 85
  , 86
  , 87
  , 88
  , 89
  , 90
  , -1
  , -1
  , -1
  , -1
  , 95
  , -1
  , 97
  , 98
  , 99
  , 100
  , 101
  , 102
  , 103
  , 104
  , 105
  , 106
  , 107
  , 108
  , 109
  , 110
  , 111
  , 112
  , 113
  , 114
  , 115
  , 116
  , 117
  , 118
  , 119
  , 120
  , 121
  , 122
  , 36
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 48
  , 49
  , 50
  , 51
  , 52
  , 53
  , 54
  , 55
  , 56
  , 57
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 65
  , 66
  , 67
  , 68
  , 69
  , 70
  , 71
  , 72
  , 73
  , 74
  , 75
  , 76
  , 77
  , 78
  , 79
  , 80
  , 81
  , 82
  , 83
  , 84
  , 85
  , 86
  , 87
  , 88
  , 89
  , 90
  , -1
  , -1
  , -1
  , -1
  , 95
  , -1
  , 97
  , 98
  , 99
  , 100
  , 101
  , 102
  , 103
  , 104
  , 105
  , 106
  , 107
  , 108
  , 109
  , 110
  , 111
  , 112
  , 113
  , 114
  , 115
  , 116
  , 117
  , 118
  , 119
  , 120
  , 121
  , 122
  , 36
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 48
  , 49
  , 50
  , 51
  , 52
  , 53
  , 54
  , 55
  , 56
  , 57
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 65
  , 66
  , 67
  , 68
  , 69
  , 70
  , 71
  , 72
  , 73
  , 74
  , 75
  , 76
  , 77
  , 78
  , 79
  , 80
  , 81
  , 82
  , 83
  , 84
  , 85
  , 86
  , 87
  , 88
  , 89
  , 90
  , -1
  , -1
  , -1
  , -1
  , 95
  , -1
  , 97
  , 98
  , 99
  , 100
  , 101
  , 102
  , 103
  , 104
  , 105
  , 106
  , 107
  , 108
  , 109
  , 110
  , 111
  , 112
  , 113
  , 114
  , 115
  , 116
  , 117
  , 118
  , 119
  , 120
  , 121
  , 122
  , 36
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 48
  , 49
  , 50
  , 51
  , 52
  , 53
  , 54
  , 55
  , 56
  , 57
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 65
  , 66
  , 67
  , 68
  , 69
  , 70
  , 71
  , 72
  , 73
  , 74
  , 75
  , 76
  , 77
  , 78
  , 79
  , 80
  , 81
  , 82
  , 83
  , 84
  , 85
  , 86
  , 87
  , 88
  , 89
  , 90
  , -1
  , -1
  , -1
  , -1
  , 95
  , -1
  , 97
  , 98
  , 99
  , 100
  , 101
  , 102
  , 103
  , 104
  , 105
  , 106
  , 107
  , 108
  , 109
  , 110
  , 111
  , 112
  , 113
  , 114
  , 115
  , 116
  , 117
  , 118
  , 119
  , 120
  , 121
  , 122
  , 36
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 48
  , 49
  , 50
  , 51
  , 52
  , 53
  , 54
  , 55
  , 56
  , 57
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 65
  , 66
  , 67
  , 68
  , 69
  , 70
  , 71
  , 72
  , 73
  , 74
  , 75
  , 76
  , 77
  , 78
  , 79
  , 80
  , 81
  , 82
  , 83
  , 84
  , 85
  , 86
  , 87
  , 88
  , 89
  , 90
  , -1
  , -1
  , -1
  , -1
  , 95
  , -1
  , 97
  , 98
  , 99
  , 100
  , 101
  , 102
  , 103
  , 104
  , 105
  , 106
  , 107
  , 108
  , 109
  , 110
  , 111
  , 112
  , 113
  , 114
  , 115
  , 116
  , 117
  , 118
  , 119
  , 120
  , 121
  , 122
  , 36
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 48
  , 49
  , 50
  , 51
  , 52
  , 53
  , 54
  , 55
  , 56
  , 57
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 65
  , 66
  , 67
  , 68
  , 69
  , 70
  , 71
  , 72
  , 73
  , 74
  , 75
  , 76
  , 77
  , 78
  , 79
  , 80
  , 81
  , 82
  , 83
  , 84
  , 85
  , 86
  , 87
  , 88
  , 89
  , 90
  , -1
  , -1
  , -1
  , -1
  , 95
  , -1
  , 97
  , 98
  , 99
  , 100
  , 101
  , 102
  , 103
  , 104
  , 105
  , 106
  , 107
  , 108
  , 109
  , 110
  , 111
  , 112
  , 113
  , 114
  , 115
  , 116
  , 117
  , 118
  , 119
  , 120
  , 121
  , 122
  , 36
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 48
  , 49
  , 50
  , 51
  , 52
  , 53
  , 54
  , 55
  , 56
  , 57
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 65
  , 66
  , 67
  , 68
  , 69
  , 70
  , 71
  , 72
  , 73
  , 74
  , 75
  , 76
  , 77
  , 78
  , 79
  , 80
  , 81
  , 82
  , 83
  , 84
  , 85
  , 86
  , 87
  , 88
  , 89
  , 90
  , -1
  , -1
  , -1
  , -1
  , 95
  , -1
  , 97
  , 98
  , 99
  , 100
  , 101
  , 102
  , 103
  , 104
  , 105
  , 106
  , 107
  , 108
  , 109
  , 110
  , 111
  , 112
  , 113
  , 114
  , 115
  , 116
  , 117
  , 118
  , 119
  , 120
  , 121
  , 122
  , 36
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 48
  , 49
  , 50
  , 51
  , 52
  , 53
  , 54
  , 55
  , 56
  , 57
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 65
  , 66
  , 67
  , 68
  , 69
  , 70
  , 71
  , 72
  , 73
  , 74
  , 75
  , 76
  , 77
  , 78
  , 79
  , 80
  , 81
  , 82
  , 83
  , 84
  , 85
  , 86
  , 87
  , 88
  , 89
  , 90
  , -1
  , -1
  , -1
  , -1
  , 95
  , -1
  , 97
  , 98
  , 99
  , 100
  , 101
  , 102
  , 103
  , 104
  , 105
  , 106
  , 107
  , 108
  , 109
  , 110
  , 111
  , 112
  , 113
  , 114
  , 115
  , 116
  , 117
  , 118
  , 119
  , 120
  , 121
  , 122
  , 36
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 48
  , 49
  , 50
  , 51
  , 52
  , 53
  , 54
  , 55
  , 56
  , 57
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 65
  , 66
  , 67
  , 68
  , 69
  , 70
  , 71
  , 72
  , 73
  , 74
  , 75
  , 76
  , 77
  , 78
  , 79
  , 80
  , 81
  , 82
  , 83
  , 84
  , 85
  , 86
  , 87
  , 88
  , 89
  , 90
  , -1
  , -1
  , -1
  , -1
  , 95
  , -1
  , 97
  , 98
  , 99
  , 100
  , 101
  , 102
  , 103
  , 104
  , 105
  , 106
  , 107
  , 108
  , 109
  , 110
  , 111
  , 112
  , 113
  , 114
  , 115
  , 116
  , 117
  , 118
  , 119
  , 120
  , 121
  , 122
  , 36
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 48
  , 49
  , 50
  , 51
  , 52
  , 53
  , 54
  , 55
  , 56
  , 57
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 65
  , 66
  , 67
  , 68
  , 69
  , 70
  , 71
  , 72
  , 73
  , 74
  , 75
  , 76
  , 77
  , 78
  , 79
  , 80
  , 81
  , 82
  , 83
  , 84
  , 85
  , 86
  , 87
  , 88
  , 89
  , 90
  , -1
  , -1
  , -1
  , -1
  , 95
  , -1
  , 97
  , 98
  , 99
  , 100
  , 101
  , 102
  , 103
  , 104
  , 105
  , 106
  , 107
  , 108
  , 109
  , 110
  , 111
  , 112
  , 113
  , 114
  , 115
  , 116
  , 117
  , 118
  , 119
  , 120
  , 121
  , 122
  , 36
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 48
  , 49
  , 50
  , 51
  , 52
  , 53
  , 54
  , 55
  , 56
  , 57
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 65
  , 66
  , 67
  , 68
  , 69
  , 70
  , 71
  , 72
  , 73
  , 74
  , 75
  , 76
  , 77
  , 78
  , 79
  , 80
  , 81
  , 82
  , 83
  , 84
  , 85
  , 86
  , 87
  , 88
  , 89
  , 90
  , -1
  , -1
  , -1
  , -1
  , 95
  , -1
  , 97
  , 98
  , 99
  , 100
  , 101
  , 102
  , 103
  , 104
  , 105
  , 106
  , 107
  , 108
  , 109
  , 110
  , 111
  , 112
  , 113
  , 114
  , 115
  , 116
  , 117
  , 118
  , 119
  , 120
  , 121
  , 122
  , 36
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 48
  , 49
  , 50
  , 51
  , 52
  , 53
  , 54
  , 55
  , 56
  , 57
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 65
  , 66
  , 67
  , 68
  , 69
  , 70
  , 71
  , 72
  , 73
  , 74
  , 75
  , 76
  , 77
  , 78
  , 79
  , 80
  , 81
  , 82
  , 83
  , 84
  , 85
  , 86
  , 87
  , 88
  , 89
  , 90
  , -1
  , -1
  , -1
  , -1
  , 95
  , -1
  , 97
  , 98
  , 99
  , 100
  , 101
  , 102
  , 103
  , 104
  , 105
  , 106
  , 107
  , 108
  , 109
  , 110
  , 111
  , 112
  , 113
  , 114
  , 115
  , 116
  , 117
  , 118
  , 119
  , 120
  , 121
  , 122
  , 36
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 48
  , 49
  , 50
  , 51
  , 52
  , 53
  , 54
  , 55
  , 56
  , 57
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 65
  , 66
  , 67
  , 68
  , 69
  , 70
  , 71
  , 72
  , 73
  , 74
  , 75
  , 76
  , 77
  , 78
  , 79
  , 80
  , 81
  , 82
  , 83
  , 84
  , 85
  , 86
  , 87
  , 88
  , 89
  , 90
  , -1
  , -1
  , -1
  , -1
  , 95
  , -1
  , 97
  , 98
  , 99
  , 100
  , 101
  , 102
  , 103
  , 104
  , 105
  , 106
  , 107
  , 108
  , 109
  , 110
  , 111
  , 112
  , 113
  , 114
  , 115
  , 116
  , 117
  , 118
  , 119
  , 120
  , 121
  , 122
  , 36
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 48
  , 49
  , 50
  , 51
  , 52
  , 53
  , 54
  , 55
  , 56
  , 57
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 65
  , 66
  , 67
  , 68
  , 69
  , 70
  , 71
  , 72
  , 73
  , 74
  , 75
  , 76
  , 77
  , 78
  , 79
  , 80
  , 81
  , 82
  , 83
  , 84
  , 85
  , 86
  , 87
  , 88
  , 89
  , 90
  , -1
  , -1
  , -1
  , -1
  , 95
  , -1
  , 97
  , 98
  , 99
  , 100
  , 101
  , 102
  , 103
  , 104
  , 105
  , 106
  , 107
  , 108
  , 109
  , 110
  , 111
  , 112
  , 113
  , 114
  , 115
  , 116
  , 117
  , 118
  , 119
  , 120
  , 121
  , 122
  , 36
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 48
  , 49
  , 50
  , 51
  , 52
  , 53
  , 54
  , 55
  , 56
  , 57
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 65
  , 66
  , 67
  , 68
  , 69
  , 70
  , 71
  , 72
  , 73
  , 74
  , 75
  , 76
  , 77
  , 78
  , 79
  , 80
  , 81
  , 82
  , 83
  , 84
  , 85
  , 86
  , 87
  , 88
  , 89
  , 90
  , -1
  , -1
  , -1
  , -1
  , 95
  , -1
  , 97
  , 98
  , 99
  , 100
  , 101
  , 102
  , 103
  , 104
  , 105
  , 106
  , 107
  , 108
  , 109
  , 110
  , 111
  , 112
  , 113
  , 114
  , 115
  , 116
  , 117
  , 118
  , 119
  , 120
  , 121
  , 122
  , 36
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 48
  , 49
  , 50
  , 51
  , 52
  , 53
  , 54
  , 55
  , 56
  , 57
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 65
  , 66
  , 67
  , 68
  , 69
  , 70
  , 71
  , 72
  , 73
  , 74
  , 75
  , 76
  , 77
  , 78
  , 79
  , 80
  , 81
  , 82
  , 83
  , 84
  , 85
  , 86
  , 87
  , 88
  , 89
  , 90
  , -1
  , -1
  , -1
  , -1
  , 95
  , -1
  , 97
  , 98
  , 99
  , 100
  , 101
  , 102
  , 103
  , 104
  , 105
  , 106
  , 107
  , 108
  , 109
  , 110
  , 111
  , 112
  , 113
  , 114
  , 115
  , 116
  , 117
  , 118
  , 119
  , 120
  , 121
  , 122
  , 36
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 48
  , 49
  , 50
  , 51
  , 52
  , 53
  , 54
  , 55
  , 56
  , 57
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 65
  , 66
  , 67
  , 68
  , 69
  , 70
  , 71
  , 72
  , 73
  , 74
  , 75
  , 76
  , 77
  , 78
  , 79
  , 80
  , 81
  , 82
  , 83
  , 84
  , 85
  , 86
  , 87
  , 88
  , 89
  , 90
  , -1
  , -1
  , -1
  , -1
  , 95
  , -1
  , 97
  , 98
  , 99
  , 100
  , 101
  , 102
  , 103
  , 104
  , 105
  , 106
  , 107
  , 108
  , 109
  , 110
  , 111
  , 112
  , 113
  , 114
  , 115
  , 116
  , 117
  , 118
  , 119
  , 120
  , 121
  , 122
  , 36
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 48
  , 49
  , 50
  , 51
  , 52
  , 53
  , 54
  , 55
  , 56
  , 57
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 65
  , 66
  , 67
  , 68
  , 69
  , 70
  , 71
  , 72
  , 73
  , 74
  , 75
  , 76
  , 77
  , 78
  , 79
  , 80
  , 81
  , 82
  , 83
  , 84
  , 85
  , 86
  , 87
  , 88
  , 89
  , 90
  , -1
  , -1
  , -1
  , -1
  , 95
  , -1
  , 97
  , 98
  , 99
  , 100
  , 101
  , 102
  , 103
  , 104
  , 105
  , 106
  , 107
  , 108
  , 109
  , 110
  , 111
  , 112
  , 113
  , 114
  , 115
  , 116
  , 117
  , 118
  , 119
  , 120
  , 121
  , 122
  , 36
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 48
  , 49
  , 50
  , 51
  , 52
  , 53
  , 54
  , 55
  , 56
  , 57
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 65
  , 66
  , 67
  , 68
  , 69
  , 70
  , 71
  , 72
  , 73
  , 74
  , 75
  , 76
  , 77
  , 78
  , 79
  , 80
  , 81
  , 82
  , 83
  , 84
  , 85
  , 86
  , 87
  , 88
  , 89
  , 90
  , -1
  , -1
  , -1
  , -1
  , 95
  , -1
  , 97
  , 98
  , 99
  , 100
  , 101
  , 102
  , 103
  , 104
  , 105
  , 106
  , 107
  , 108
  , 109
  , 110
  , 111
  , 112
  , 113
  , 114
  , 115
  , 116
  , 117
  , 118
  , 119
  , 120
  , 121
  , 122
  , 36
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 48
  , 49
  , 50
  , 51
  , 52
  , 53
  , 54
  , 55
  , 56
  , 57
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 65
  , 66
  , 67
  , 68
  , 69
  , 70
  , 71
  , 72
  , 73
  , 74
  , 75
  , 76
  , 77
  , 78
  , 79
  , 80
  , 81
  , 82
  , 83
  , 84
  , 85
  , 86
  , 87
  , 88
  , 89
  , 90
  , -1
  , -1
  , -1
  , -1
  , 95
  , -1
  , 97
  , 98
  , 99
  , 100
  , 101
  , 102
  , 103
  , 104
  , 105
  , 106
  , 107
  , 108
  , 109
  , 110
  , 111
  , 112
  , 113
  , 114
  , 115
  , 116
  , 117
  , 118
  , 119
  , 120
  , 121
  , 122
  , 36
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 48
  , 49
  , 50
  , 51
  , 52
  , 53
  , 54
  , 55
  , 56
  , 57
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 65
  , 66
  , 67
  , 68
  , 69
  , 70
  , 71
  , 72
  , 73
  , 74
  , 75
  , 76
  , 77
  , 78
  , 79
  , 80
  , 81
  , 82
  , 83
  , 84
  , 85
  , 86
  , 87
  , 88
  , 89
  , 90
  , -1
  , -1
  , -1
  , -1
  , 95
  , -1
  , 97
  , 98
  , 99
  , 100
  , 101
  , 102
  , 103
  , 104
  , 105
  , 106
  , 107
  , 108
  , 109
  , 110
  , 111
  , 112
  , 113
  , 114
  , 115
  , 116
  , 117
  , 118
  , 119
  , 120
  , 121
  , 122
  , 36
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 48
  , 49
  , 50
  , 51
  , 52
  , 53
  , 54
  , 55
  , 56
  , 57
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 65
  , 66
  , 67
  , 68
  , 69
  , 70
  , 71
  , 72
  , 73
  , 74
  , 75
  , 76
  , 77
  , 78
  , 79
  , 80
  , 81
  , 82
  , 83
  , 84
  , 85
  , 86
  , 87
  , 88
  , 89
  , 90
  , -1
  , -1
  , -1
  , -1
  , 95
  , -1
  , 97
  , 98
  , 99
  , 100
  , 101
  , 102
  , 103
  , 104
  , 105
  , 106
  , 107
  , 108
  , 109
  , 110
  , 111
  , 112
  , 113
  , 114
  , 115
  , 116
  , 117
  , 118
  , 119
  , 120
  , 121
  , 122
  , 36
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 48
  , 49
  , 50
  , 51
  , 52
  , 53
  , 54
  , 55
  , 56
  , 57
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 65
  , 66
  , 67
  , 68
  , 69
  , 70
  , 71
  , 72
  , 73
  , 74
  , 75
  , 76
  , 77
  , 78
  , 79
  , 80
  , 81
  , 82
  , 83
  , 84
  , 85
  , 86
  , 87
  , 88
  , 89
  , 90
  , -1
  , -1
  , -1
  , -1
  , 95
  , -1
  , 97
  , 98
  , 99
  , 100
  , 101
  , 102
  , 103
  , 104
  , 105
  , 106
  , 107
  , 108
  , 109
  , 110
  , 111
  , 112
  , 113
  , 114
  , 115
  , 116
  , 117
  , 118
  , 119
  , 120
  , 121
  , 122
  , 36
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 48
  , 49
  , 50
  , 51
  , 52
  , 53
  , 54
  , 55
  , 56
  , 57
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 65
  , 66
  , 67
  , 68
  , 69
  , 70
  , 71
  , 72
  , 73
  , 74
  , 75
  , 76
  , 77
  , 78
  , 79
  , 80
  , 81
  , 82
  , 83
  , 84
  , 85
  , 86
  , 87
  , 88
  , 89
  , 90
  , -1
  , -1
  , -1
  , -1
  , 95
  , -1
  , 97
  , 98
  , 99
  , 100
  , 101
  , 102
  , 103
  , 104
  , 105
  , 106
  , 107
  , 108
  , 109
  , 110
  , 111
  , 112
  , 113
  , 114
  , 115
  , 116
  , 117
  , 118
  , 119
  , 120
  , 121
  , 122
  , 36
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 48
  , 49
  , 50
  , 51
  , 52
  , 53
  , 54
  , 55
  , 56
  , 57
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 65
  , 66
  , 67
  , 68
  , 69
  , 70
  , 71
  , 72
  , 73
  , 74
  , 75
  , 76
  , 77
  , 78
  , 79
  , 80
  , 81
  , 82
  , 83
  , 84
  , 85
  , 86
  , 87
  , 88
  , 89
  , 90
  , -1
  , -1
  , -1
  , -1
  , 95
  , -1
  , 97
  , 98
  , 99
  , 100
  , 101
  , 102
  , 103
  , 104
  , 105
  , 106
  , 107
  , 108
  , 109
  , 110
  , 111
  , 112
  , 113
  , 114
  , 115
  , 116
  , 117
  , 118
  , 119
  , 120
  , 121
  , 122
  , 36
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 48
  , 49
  , 50
  , 51
  , 52
  , 53
  , 54
  , 55
  , 56
  , 57
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 65
  , 66
  , 67
  , 68
  , 69
  , 70
  , 71
  , 72
  , 73
  , 74
  , 75
  , 76
  , 77
  , 78
  , 79
  , 80
  , 81
  , 82
  , 83
  , 84
  , 85
  , 86
  , 87
  , 88
  , 89
  , 90
  , -1
  , -1
  , -1
  , -1
  , 95
  , -1
  , 97
  , 98
  , 99
  , 100
  , 101
  , 102
  , 103
  , 104
  , 105
  , 106
  , 107
  , 108
  , 109
  , 110
  , 111
  , 112
  , 113
  , 114
  , 115
  , 116
  , 117
  , 118
  , 119
  , 120
  , 121
  , 122
  , 36
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 48
  , 49
  , 50
  , 51
  , 52
  , 53
  , 54
  , 55
  , 56
  , 57
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 65
  , 66
  , 67
  , 68
  , 69
  , 70
  , 71
  , 72
  , 73
  , 74
  , 75
  , 76
  , 77
  , 78
  , 79
  , 80
  , 81
  , 82
  , 83
  , 84
  , 85
  , 86
  , 87
  , 88
  , 89
  , 90
  , -1
  , -1
  , -1
  , -1
  , 95
  , -1
  , 97
  , 98
  , 99
  , 100
  , 101
  , 102
  , 103
  , 104
  , 105
  , 106
  , 107
  , 108
  , 109
  , 110
  , 111
  , 112
  , 113
  , 114
  , 115
  , 116
  , 117
  , 118
  , 119
  , 120
  , 121
  , 122
  , 36
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 48
  , 49
  , 50
  , 51
  , 52
  , 53
  , 54
  , 55
  , 56
  , 57
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 65
  , 66
  , 67
  , 68
  , 69
  , 70
  , 71
  , 72
  , 73
  , 74
  , 75
  , 76
  , 77
  , 78
  , 79
  , 80
  , 81
  , 82
  , 83
  , 84
  , 85
  , 86
  , 87
  , 88
  , 89
  , 90
  , -1
  , -1
  , -1
  , -1
  , 95
  , -1
  , 97
  , 98
  , 99
  , 100
  , 101
  , 102
  , 103
  , 104
  , 105
  , 106
  , 107
  , 108
  , 109
  , 110
  , 111
  , 112
  , 113
  , 114
  , 115
  , 116
  , 117
  , 118
  , 119
  , 120
  , 121
  , 122
  , 36
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 48
  , 49
  , 50
  , 51
  , 52
  , 53
  , 54
  , 55
  , 56
  , 57
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 65
  , 66
  , 67
  , 68
  , 69
  , 70
  , 71
  , 72
  , 73
  , 74
  , 75
  , 76
  , 77
  , 78
  , 79
  , 80
  , 81
  , 82
  , 83
  , 84
  , 85
  , 86
  , 87
  , 88
  , 89
  , 90
  , -1
  , -1
  , -1
  , -1
  , 95
  , -1
  , 97
  , 98
  , 99
  , 100
  , 101
  , 102
  , 103
  , 104
  , 105
  , 106
  , 107
  , 108
  , 109
  , 110
  , 111
  , 112
  , 113
  , 114
  , 115
  , 116
  , 117
  , 118
  , 119
  , 120
  , 121
  , 122
  , 36
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 48
  , 49
  , 50
  , 51
  , 52
  , 53
  , 54
  , 55
  , 56
  , 57
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 65
  , 66
  , 67
  , 68
  , 69
  , 70
  , 71
  , 72
  , 73
  , 74
  , 75
  , 76
  , 77
  , 78
  , 79
  , 80
  , 81
  , 82
  , 83
  , 84
  , 85
  , 86
  , 87
  , 88
  , 89
  , 90
  , -1
  , -1
  , -1
  , -1
  , 95
  , -1
  , 97
  , 98
  , 99
  , 100
  , 101
  , 102
  , 103
  , 104
  , 105
  , 106
  , 107
  , 108
  , 109
  , 110
  , 111
  , 112
  , 113
  , 114
  , 115
  , 116
  , 117
  , 118
  , 119
  , 120
  , 121
  , 122
  , 36
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 48
  , 49
  , 50
  , 51
  , 52
  , 53
  , 54
  , 55
  , 56
  , 57
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 65
  , 66
  , 67
  , 68
  , 69
  , 70
  , 71
  , 72
  , 73
  , 74
  , 75
  , 76
  , 77
  , 78
  , 79
  , 80
  , 81
  , 82
  , 83
  , 84
  , 85
  , 86
  , 87
  , 88
  , 89
  , 90
  , -1
  , -1
  , -1
  , -1
  , 95
  , -1
  , 97
  , 98
  , 99
  , 100
  , 101
  , 102
  , 103
  , 104
  , 105
  , 106
  , 107
  , 108
  , 109
  , 110
  , 111
  , 112
  , 113
  , 114
  , 115
  , 116
  , 117
  , 118
  , 119
  , 120
  , 121
  , 122
  , 36
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 48
  , 49
  , 50
  , 51
  , 52
  , 53
  , 54
  , 55
  , 56
  , 57
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 65
  , 66
  , 67
  , 68
  , 69
  , 70
  , 71
  , 72
  , 73
  , 74
  , 75
  , 76
  , 77
  , 78
  , 79
  , 80
  , 81
  , 82
  , 83
  , 84
  , 85
  , 86
  , 87
  , 88
  , 89
  , 90
  , -1
  , -1
  , -1
  , -1
  , 95
  , -1
  , 97
  , 98
  , 99
  , 100
  , 101
  , 102
  , 103
  , 104
  , 105
  , 106
  , 107
  , 108
  , 109
  , 110
  , 111
  , 112
  , 113
  , 114
  , 115
  , 116
  , 117
  , 118
  , 119
  , 120
  , 121
  , 122
  , 36
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 48
  , 49
  , 50
  , 51
  , 52
  , 53
  , 54
  , 55
  , 56
  , 57
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 65
  , 66
  , 67
  , 68
  , 69
  , 70
  , 71
  , 72
  , 73
  , 74
  , 75
  , 76
  , 77
  , 78
  , 79
  , 80
  , 81
  , 82
  , 83
  , 84
  , 85
  , 86
  , 87
  , 88
  , 89
  , 90
  , -1
  , -1
  , -1
  , -1
  , 95
  , -1
  , 97
  , 98
  , 99
  , 100
  , 101
  , 102
  , 103
  , 104
  , 105
  , 106
  , 107
  , 108
  , 109
  , 110
  , 111
  , 112
  , 113
  , 114
  , 115
  , 116
  , 117
  , 118
  , 119
  , 120
  , 121
  , 122
  , 36
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 48
  , 49
  , 50
  , 51
  , 52
  , 53
  , 54
  , 55
  , 56
  , 57
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 65
  , 66
  , 67
  , 68
  , 69
  , 70
  , 71
  , 72
  , 73
  , 74
  , 75
  , 76
  , 77
  , 78
  , 79
  , 80
  , 81
  , 82
  , 83
  , 84
  , 85
  , 86
  , 87
  , 88
  , 89
  , 90
  , -1
  , -1
  , -1
  , -1
  , 95
  , -1
  , 97
  , 98
  , 99
  , 100
  , 101
  , 102
  , 103
  , 104
  , 105
  , 106
  , 107
  , 108
  , 109
  , 110
  , 111
  , 112
  , 113
  , 114
  , 115
  , 116
  , 117
  , 118
  , 119
  , 120
  , 121
  , 122
  , 36
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 48
  , 49
  , 50
  , 51
  , 52
  , 53
  , 54
  , 55
  , 56
  , 57
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 65
  , 66
  , 67
  , 68
  , 69
  , 70
  , 71
  , 72
  , 73
  , 74
  , 75
  , 76
  , 77
  , 78
  , 79
  , 80
  , 81
  , 82
  , 83
  , 84
  , 85
  , 86
  , 87
  , 88
  , 89
  , 90
  , -1
  , -1
  , -1
  , -1
  , 95
  , -1
  , 97
  , 98
  , 99
  , 100
  , 101
  , 102
  , 103
  , 104
  , 105
  , 106
  , 107
  , 108
  , 109
  , 110
  , 111
  , 112
  , 113
  , 114
  , 115
  , 116
  , 117
  , 118
  , 119
  , 120
  , 121
  , 122
  , 36
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 48
  , 49
  , 50
  , 51
  , 52
  , 53
  , 54
  , 55
  , 56
  , 57
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 65
  , 66
  , 67
  , 68
  , 69
  , 70
  , 71
  , 72
  , 73
  , 74
  , 75
  , 76
  , 77
  , 78
  , 79
  , 80
  , 81
  , 82
  , 83
  , 84
  , 85
  , 86
  , 87
  , 88
  , 89
  , 90
  , -1
  , -1
  , -1
  , -1
  , 95
  , -1
  , 97
  , 98
  , 99
  , 100
  , 101
  , 102
  , 103
  , 104
  , 105
  , 106
  , 107
  , 108
  , 109
  , 110
  , 111
  , 112
  , 113
  , 114
  , 115
  , 116
  , 117
  , 118
  , 119
  , 120
  , 121
  , 122
  , 36
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 48
  , 49
  , 50
  , 51
  , 52
  , 53
  , 54
  , 55
  , 56
  , 57
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 65
  , 66
  , 67
  , 68
  , 69
  , 70
  , 71
  , 72
  , 73
  , 74
  , 75
  , 76
  , 77
  , 78
  , 79
  , 80
  , 81
  , 82
  , 83
  , 84
  , 85
  , 86
  , 87
  , 88
  , 89
  , 90
  , -1
  , -1
  , -1
  , -1
  , 95
  , -1
  , 97
  , 98
  , 99
  , 100
  , 101
  , 102
  , 103
  , 104
  , 105
  , 106
  , 107
  , 108
  , 109
  , 110
  , 111
  , 112
  , 113
  , 114
  , 115
  , 116
  , 117
  , 118
  , 119
  , 120
  , 121
  , 122
  , 36
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 48
  , 49
  , 50
  , 51
  , 52
  , 53
  , 54
  , 55
  , 56
  , 57
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 65
  , 66
  , 67
  , 68
  , 69
  , 70
  , 71
  , 72
  , 73
  , 74
  , 75
  , 76
  , 77
  , 78
  , 79
  , 80
  , 81
  , 82
  , 83
  , 84
  , 85
  , 86
  , 87
  , 88
  , 89
  , 90
  , -1
  , -1
  , -1
  , -1
  , 95
  , -1
  , 97
  , 98
  , 99
  , 100
  , 101
  , 102
  , 103
  , 104
  , 105
  , 106
  , 107
  , 108
  , 109
  , 110
  , 111
  , 112
  , 113
  , 114
  , 115
  , 116
  , 117
  , 118
  , 119
  , 120
  , 121
  , 122
  , 36
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 48
  , 49
  , 50
  , 51
  , 52
  , 53
  , 54
  , 55
  , 56
  , 57
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 65
  , 66
  , 67
  , 68
  , 69
  , 70
  , 71
  , 72
  , 73
  , 74
  , 75
  , 76
  , 77
  , 78
  , 79
  , 80
  , 81
  , 82
  , 83
  , 84
  , 85
  , 86
  , 87
  , 88
  , 89
  , 90
  , -1
  , -1
  , -1
  , -1
  , 95
  , -1
  , 97
  , 98
  , 99
  , 100
  , 101
  , 102
  , 103
  , 104
  , 105
  , 106
  , 107
  , 108
  , 109
  , 110
  , 111
  , 112
  , 113
  , 114
  , 115
  , 116
  , 117
  , 118
  , 119
  , 120
  , 121
  , 122
  , 36
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 48
  , 49
  , 50
  , 51
  , 52
  , 53
  , 54
  , 55
  , 56
  , 57
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 65
  , 66
  , 67
  , 68
  , 69
  , 70
  , 71
  , 72
  , 73
  , 74
  , 75
  , 76
  , 77
  , 78
  , 79
  , 80
  , 81
  , 82
  , 83
  , 84
  , 85
  , 86
  , 87
  , 88
  , 89
  , 90
  , -1
  , -1
  , -1
  , -1
  , 95
  , -1
  , 97
  , 98
  , 99
  , 100
  , 101
  , 102
  , 103
  , 104
  , 105
  , 106
  , 107
  , 108
  , 109
  , 110
  , 111
  , 112
  , 113
  , 114
  , 115
  , 116
  , 117
  , 118
  , 119
  , 120
  , 121
  , 122
  , 36
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 48
  , 49
  , 50
  , 51
  , 52
  , 53
  , 54
  , 55
  , 56
  , 57
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 65
  , 66
  , 67
  , 68
  , 69
  , 70
  , 71
  , 72
  , 73
  , 74
  , 75
  , 76
  , 77
  , 78
  , 79
  , 80
  , 81
  , 82
  , 83
  , 84
  , 85
  , 86
  , 87
  , 88
  , 89
  , 90
  , -1
  , -1
  , -1
  , -1
  , 95
  , -1
  , 97
  , 98
  , 99
  , 100
  , 101
  , 102
  , 103
  , 104
  , 105
  , 106
  , 107
  , 108
  , 109
  , 110
  , 111
  , 112
  , 113
  , 114
  , 115
  , 116
  , 117
  , 118
  , 119
  , 120
  , 121
  , 122
  , 36
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 48
  , 49
  , 50
  , 51
  , 52
  , 53
  , 54
  , 55
  , 56
  , 57
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 65
  , 66
  , 67
  , 68
  , 69
  , 70
  , 71
  , 72
  , 73
  , 74
  , 75
  , 76
  , 77
  , 78
  , 79
  , 80
  , 81
  , 82
  , 83
  , 84
  , 85
  , 86
  , 87
  , 88
  , 89
  , 90
  , -1
  , -1
  , -1
  , -1
  , 95
  , -1
  , 97
  , 98
  , 99
  , 100
  , 101
  , 102
  , 103
  , 104
  , 105
  , 106
  , 107
  , 108
  , 109
  , 110
  , 111
  , 112
  , 113
  , 114
  , 115
  , 116
  , 117
  , 118
  , 119
  , 120
  , 121
  , 122
  , 36
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 48
  , 49
  , 50
  , 51
  , 52
  , 53
  , 54
  , 55
  , 56
  , 57
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 65
  , 66
  , 67
  , 68
  , 69
  , 70
  , 71
  , 72
  , 73
  , 74
  , 75
  , 76
  , 77
  , 78
  , 79
  , 80
  , 81
  , 82
  , 83
  , 84
  , 85
  , 86
  , 87
  , 88
  , 89
  , 90
  , -1
  , -1
  , -1
  , -1
  , 95
  , -1
  , 97
  , 98
  , 99
  , 100
  , 101
  , 102
  , 103
  , 104
  , 105
  , 106
  , 107
  , 108
  , 109
  , 110
  , 111
  , 112
  , 113
  , 114
  , 115
  , 116
  , 117
  , 118
  , 119
  , 120
  , 121
  , 122
  , 36
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 48
  , 49
  , 50
  , 51
  , 52
  , 53
  , 54
  , 55
  , 56
  , 57
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 65
  , 66
  , 67
  , 68
  , 69
  , 70
  , 71
  , 72
  , 73
  , 74
  , 75
  , 76
  , 77
  , 78
  , 79
  , 80
  , 81
  , 82
  , 83
  , 84
  , 85
  , 86
  , 87
  , 88
  , 89
  , 90
  , -1
  , -1
  , -1
  , -1
  , 95
  , -1
  , 97
  , 98
  , 99
  , 100
  , 101
  , 102
  , 103
  , 104
  , 105
  , 106
  , 107
  , 108
  , 109
  , 110
  , 111
  , 112
  , 113
  , 114
  , 115
  , 116
  , 117
  , 118
  , 119
  , 120
  , 121
  , 122
  , 36
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 48
  , 49
  , 50
  , 51
  , 52
  , 53
  , 54
  , 55
  , 56
  , 57
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 65
  , 66
  , 67
  , 68
  , 69
  , 70
  , 71
  , 72
  , 73
  , 74
  , 75
  , 76
  , 77
  , 78
  , 79
  , 80
  , 81
  , 82
  , 83
  , 84
  , 85
  , 86
  , 87
  , 88
  , 89
  , 90
  , -1
  , -1
  , -1
  , -1
  , 95
  , -1
  , 97
  , 98
  , 99
  , 100
  , 101
  , 102
  , 103
  , 104
  , 105
  , 106
  , 107
  , 108
  , 109
  , 110
  , 111
  , 112
  , 113
  , 114
  , 115
  , 116
  , 117
  , 118
  , 119
  , 120
  , 121
  , 122
  , 36
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 48
  , 49
  , 50
  , 51
  , 52
  , 53
  , 54
  , 55
  , 56
  , 57
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 65
  , 66
  , 67
  , 68
  , 69
  , 70
  , 71
  , 72
  , 73
  , 74
  , 75
  , 76
  , 77
  , 78
  , 79
  , 80
  , 81
  , 82
  , 83
  , 84
  , 85
  , 86
  , 87
  , 88
  , 89
  , 90
  , -1
  , -1
  , -1
  , -1
  , 95
  , -1
  , 97
  , 98
  , 99
  , 100
  , 101
  , 102
  , 103
  , 104
  , 105
  , 106
  , 107
  , 108
  , 109
  , 110
  , 111
  , 112
  , 113
  , 114
  , 115
  , 116
  , 117
  , 118
  , 119
  , 120
  , 121
  , 122
  , 36
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 48
  , 49
  , 50
  , 51
  , 52
  , 53
  , 54
  , 55
  , 56
  , 57
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 65
  , 66
  , 67
  , 68
  , 69
  , 70
  , 71
  , 72
  , 73
  , 74
  , 75
  , 76
  , 77
  , 78
  , 79
  , 80
  , 81
  , 82
  , 83
  , 84
  , 85
  , 86
  , 87
  , 88
  , 89
  , 90
  , -1
  , -1
  , -1
  , -1
  , 95
  , -1
  , 97
  , 98
  , 99
  , 100
  , 101
  , 102
  , 103
  , 104
  , 105
  , 106
  , 107
  , 108
  , 109
  , 110
  , 111
  , 112
  , 113
  , 114
  , 115
  , 116
  , 117
  , 118
  , 119
  , 120
  , 121
  , 122
  , 36
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 48
  , 49
  , 50
  , 51
  , 52
  , 53
  , 54
  , 55
  , 56
  , 57
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 65
  , 66
  , 67
  , 68
  , 69
  , 70
  , 71
  , 72
  , 73
  , 74
  , 75
  , 76
  , 77
  , 78
  , 79
  , 80
  , 81
  , 82
  , 83
  , 84
  , 85
  , 86
  , 87
  , 88
  , 89
  , 90
  , -1
  , -1
  , -1
  , -1
  , 95
  , -1
  , 97
  , 98
  , 99
  , 100
  , 101
  , 102
  , 103
  , 104
  , 105
  , 106
  , 107
  , 108
  , 109
  , 110
  , 111
  , 112
  , 113
  , 114
  , 115
  , 116
  , 117
  , 118
  , 119
  , 120
  , 121
  , 122
  , 36
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 48
  , 49
  , 50
  , 51
  , 52
  , 53
  , 54
  , 55
  , 56
  , 57
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 65
  , 66
  , 67
  , 68
  , 69
  , 70
  , 71
  , 72
  , 73
  , 74
  , 75
  , 76
  , 77
  , 78
  , 79
  , 80
  , 81
  , 82
  , 83
  , 84
  , 85
  , 86
  , 87
  , 88
  , 89
  , 90
  , -1
  , -1
  , -1
  , -1
  , 95
  , -1
  , 97
  , 98
  , 99
  , 100
  , 101
  , 102
  , 103
  , 104
  , 105
  , 106
  , 107
  , 108
  , 109
  , 110
  , 111
  , 112
  , 113
  , 114
  , 115
  , 116
  , 117
  , 118
  , 119
  , 120
  , 121
  , 122
  , 36
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 48
  , 49
  , 50
  , 51
  , 52
  , 53
  , 54
  , 55
  , 56
  , 57
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 65
  , 66
  , 67
  , 68
  , 69
  , 70
  , 71
  , 72
  , 73
  , 74
  , 75
  , 76
  , 77
  , 78
  , 79
  , 80
  , 81
  , 82
  , 83
  , 84
  , 85
  , 86
  , 87
  , 88
  , 89
  , 90
  , -1
  , -1
  , -1
  , -1
  , 95
  , -1
  , 97
  , 98
  , 99
  , 100
  , 101
  , 102
  , 103
  , 104
  , 105
  , 106
  , 107
  , 108
  , 109
  , 110
  , 111
  , 112
  , 113
  , 114
  , 115
  , 116
  , 117
  , 118
  , 119
  , 120
  , 121
  , 122
  , 36
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 48
  , 49
  , 50
  , 51
  , 52
  , 53
  , 54
  , 55
  , 56
  , 57
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 65
  , 66
  , 67
  , 68
  , 69
  , 70
  , 71
  , 72
  , 73
  , 74
  , 75
  , 76
  , 77
  , 78
  , 79
  , 80
  , 81
  , 82
  , 83
  , 84
  , 85
  , 86
  , 87
  , 88
  , 89
  , 90
  , -1
  , -1
  , -1
  , -1
  , 95
  , -1
  , 97
  , 98
  , 99
  , 100
  , 101
  , 102
  , 103
  , 104
  , 105
  , 106
  , 107
  , 108
  , 109
  , 110
  , 111
  , 112
  , 113
  , 114
  , 115
  , 116
  , 117
  , 118
  , 119
  , 120
  , 121
  , 122
  , 36
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 48
  , 49
  , 50
  , 51
  , 52
  , 53
  , 54
  , 55
  , 56
  , 57
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 65
  , 66
  , 67
  , 68
  , 69
  , 70
  , 71
  , 72
  , 73
  , 74
  , 75
  , 76
  , 77
  , 78
  , 79
  , 80
  , 81
  , 82
  , 83
  , 84
  , 85
  , 86
  , 87
  , 88
  , 89
  , 90
  , -1
  , -1
  , -1
  , -1
  , 95
  , -1
  , 97
  , 98
  , 99
  , 100
  , 101
  , 102
  , 103
  , 104
  , 105
  , 106
  , 107
  , 108
  , 109
  , 110
  , 111
  , 112
  , 113
  , 114
  , 115
  , 116
  , 117
  , 118
  , 119
  , 120
  , 121
  , 122
  , 36
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 48
  , 49
  , 50
  , 51
  , 52
  , 53
  , 54
  , 55
  , 56
  , 57
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 65
  , 66
  , 67
  , 68
  , 69
  , 70
  , 71
  , 72
  , 73
  , 74
  , 75
  , 76
  , 77
  , 78
  , 79
  , 80
  , 81
  , 82
  , 83
  , 84
  , 85
  , 86
  , 87
  , 88
  , 89
  , 90
  , -1
  , -1
  , -1
  , -1
  , 95
  , -1
  , 97
  , 98
  , 99
  , 100
  , 101
  , 102
  , 103
  , 104
  , 105
  , 106
  , 107
  , 108
  , 109
  , 110
  , 111
  , 112
  , 113
  , 114
  , 115
  , 116
  , 117
  , 118
  , 119
  , 120
  , 121
  , 122
  , 36
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 48
  , 49
  , 50
  , 51
  , 52
  , 53
  , 54
  , 55
  , 56
  , 57
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 65
  , 66
  , 67
  , 68
  , 69
  , 70
  , 71
  , 72
  , 73
  , 74
  , 75
  , 76
  , 77
  , 78
  , 79
  , 80
  , 81
  , 82
  , 83
  , 84
  , 85
  , 86
  , 87
  , 88
  , 89
  , 90
  , -1
  , -1
  , -1
  , -1
  , 95
  , -1
  , 97
  , 98
  , 99
  , 100
  , 101
  , 102
  , 103
  , 104
  , 105
  , 106
  , 107
  , 108
  , 109
  , 110
  , 111
  , 112
  , 113
  , 114
  , 115
  , 116
  , 117
  , 118
  , 119
  , 120
  , 121
  , 122
  , 36
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 48
  , 49
  , 50
  , 51
  , 52
  , 53
  , 54
  , 55
  , 56
  , 57
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 65
  , 66
  , 67
  , 68
  , 69
  , 70
  , 71
  , 72
  , 73
  , 74
  , 75
  , 76
  , 77
  , 78
  , 79
  , 80
  , 81
  , 82
  , 83
  , 84
  , 85
  , 86
  , 87
  , 88
  , 89
  , 90
  , -1
  , -1
  , -1
  , -1
  , 95
  , -1
  , 97
  , 98
  , 99
  , 100
  , 101
  , 102
  , 103
  , 104
  , 105
  , 106
  , 107
  , 108
  , 109
  , 110
  , 111
  , 112
  , 113
  , 114
  , 115
  , 116
  , 117
  , 118
  , 119
  , 120
  , 121
  , 122
  , 36
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 48
  , 49
  , 50
  , 51
  , 52
  , 53
  , 54
  , 55
  , 56
  , 57
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 65
  , 66
  , 67
  , 68
  , 69
  , 70
  , 71
  , 72
  , 73
  , 74
  , 75
  , 76
  , 77
  , 78
  , 79
  , 80
  , 81
  , 82
  , 83
  , 84
  , 85
  , 86
  , 87
  , 88
  , 89
  , 90
  , -1
  , -1
  , -1
  , -1
  , 95
  , -1
  , 97
  , 98
  , 99
  , 100
  , 101
  , 102
  , 103
  , 104
  , 105
  , 106
  , 107
  , 108
  , 109
  , 110
  , 111
  , 112
  , 113
  , 114
  , 115
  , 116
  , 117
  , 118
  , 119
  , 120
  , 121
  , 122
  , 36
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 48
  , 49
  , 50
  , 51
  , 52
  , 53
  , 54
  , 55
  , 56
  , 57
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 65
  , 66
  , 67
  , 68
  , 69
  , 70
  , 71
  , 72
  , 73
  , 74
  , 75
  , 76
  , 77
  , 78
  , 79
  , 80
  , 81
  , 82
  , 83
  , 84
  , 85
  , 86
  , 87
  , 88
  , 89
  , 90
  , -1
  , -1
  , -1
  , -1
  , 95
  , -1
  , 97
  , 98
  , 99
  , 100
  , 101
  , 102
  , 103
  , 104
  , 105
  , 106
  , 107
  , 108
  , 109
  , 110
  , 111
  , 112
  , 113
  , 114
  , 115
  , 116
  , 117
  , 118
  , 119
  , 120
  , 121
  , 122
  , 36
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 48
  , 49
  , 50
  , 51
  , 52
  , 53
  , 54
  , 55
  , 56
  , 57
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 65
  , 66
  , 67
  , 68
  , 69
  , 70
  , 71
  , 72
  , 73
  , 74
  , 75
  , 76
  , 77
  , 78
  , 79
  , 80
  , 81
  , 82
  , 83
  , 84
  , 85
  , 86
  , 87
  , 88
  , 89
  , 90
  , -1
  , -1
  , -1
  , -1
  , 95
  , -1
  , 97
  , 98
  , 99
  , 100
  , 101
  , 102
  , 103
  , 104
  , 105
  , 106
  , 107
  , 108
  , 109
  , 110
  , 111
  , 112
  , 113
  , 114
  , 115
  , 116
  , 117
  , 118
  , 119
  , 120
  , 121
  , 122
  , 36
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 48
  , 49
  , 50
  , 51
  , 52
  , 53
  , 54
  , 55
  , 56
  , 57
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 65
  , 66
  , 67
  , 68
  , 69
  , 70
  , 71
  , 72
  , 73
  , 74
  , 75
  , 76
  , 77
  , 78
  , 79
  , 80
  , 81
  , 82
  , 83
  , 84
  , 85
  , 86
  , 87
  , 88
  , 89
  , 90
  , -1
  , -1
  , -1
  , -1
  , 95
  , -1
  , 97
  , 98
  , 99
  , 100
  , 101
  , 102
  , 103
  , 104
  , 105
  , 106
  , 107
  , 108
  , 109
  , 110
  , 111
  , 112
  , 113
  , 114
  , 115
  , 116
  , 117
  , 118
  , 119
  , 120
  , 121
  , 122
  , 36
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 48
  , 49
  , 50
  , 51
  , 52
  , 53
  , 54
  , 55
  , 56
  , 57
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 65
  , 66
  , 67
  , 68
  , 69
  , 70
  , 71
  , 72
  , 73
  , 74
  , 75
  , 76
  , 77
  , 78
  , 79
  , 80
  , 81
  , 82
  , 83
  , 84
  , 85
  , 86
  , 87
  , 88
  , 89
  , 90
  , -1
  , -1
  , -1
  , -1
  , 95
  , -1
  , 97
  , 98
  , 99
  , 100
  , 101
  , 102
  , 103
  , 104
  , 105
  , 106
  , 107
  , 108
  , 109
  , 110
  , 111
  , 112
  , 113
  , 114
  , 115
  , 116
  , 117
  , 118
  , 119
  , 120
  , 121
  , 122
  , 36
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 48
  , 49
  , 50
  , 51
  , 52
  , 53
  , 54
  , 55
  , 56
  , 57
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 65
  , 66
  , 67
  , 68
  , 69
  , 70
  , 71
  , 72
  , 73
  , 74
  , 75
  , 76
  , 77
  , 78
  , 79
  , 80
  , 81
  , 82
  , 83
  , 84
  , 85
  , 86
  , 87
  , 88
  , 89
  , 90
  , -1
  , -1
  , -1
  , -1
  , 95
  , -1
  , 97
  , 98
  , 99
  , 100
  , 101
  , 102
  , 103
  , 104
  , 105
  , 106
  , 107
  , 108
  , 109
  , 110
  , 111
  , 112
  , 113
  , 114
  , 115
  , 116
  , 117
  , 118
  , 119
  , 120
  , 121
  , 122
  , 36
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 48
  , 49
  , 50
  , 51
  , 52
  , 53
  , 54
  , 55
  , 56
  , 57
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 65
  , 66
  , 67
  , 68
  , 69
  , 70
  , 71
  , 72
  , 73
  , 74
  , 75
  , 76
  , 77
  , 78
  , 79
  , 80
  , 81
  , 82
  , 83
  , 84
  , 85
  , 86
  , 87
  , 88
  , 89
  , 90
  , -1
  , -1
  , -1
  , -1
  , 95
  , -1
  , 97
  , 98
  , 99
  , 100
  , 101
  , 102
  , 103
  , 104
  , 105
  , 106
  , 107
  , 108
  , 109
  , 110
  , 111
  , 112
  , 113
  , 114
  , 115
  , 116
  , 117
  , 118
  , 119
  , 120
  , 121
  , 122
  , 36
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 48
  , 49
  , 50
  , 51
  , 52
  , 53
  , 54
  , 55
  , 56
  , 57
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 65
  , 66
  , 67
  , 68
  , 69
  , 70
  , 71
  , 72
  , 73
  , 74
  , 75
  , 76
  , 77
  , 78
  , 79
  , 80
  , 81
  , 82
  , 83
  , 84
  , 85
  , 86
  , 87
  , 88
  , 89
  , 90
  , -1
  , -1
  , -1
  , -1
  , 95
  , -1
  , 97
  , 98
  , 99
  , 100
  , 101
  , 102
  , 103
  , 104
  , 105
  , 106
  , 107
  , 108
  , 109
  , 110
  , 111
  , 112
  , 113
  , 114
  , 115
  , 116
  , 117
  , 118
  , 119
  , 120
  , 121
  , 122
  , 36
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 48
  , 49
  , 50
  , 51
  , 52
  , 53
  , 54
  , 55
  , 56
  , 57
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 65
  , 66
  , 67
  , 68
  , 69
  , 70
  , 71
  , 72
  , 73
  , 74
  , 75
  , 76
  , 77
  , 78
  , 79
  , 80
  , 81
  , 82
  , 83
  , 84
  , 85
  , 86
  , 87
  , 88
  , 89
  , 90
  , -1
  , -1
  , -1
  , -1
  , 95
  , -1
  , 97
  , 98
  , 99
  , 100
  , 101
  , 102
  , 103
  , 104
  , 105
  , 106
  , 107
  , 108
  , 109
  , 110
  , 111
  , 112
  , 113
  , 114
  , 115
  , 116
  , 117
  , 118
  , 119
  , 120
  , 121
  , 122
  , 36
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 48
  , 49
  , 50
  , 51
  , 52
  , 53
  , 54
  , 55
  , 56
  , 57
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 65
  , 66
  , 67
  , 68
  , 69
  , 70
  , 71
  , 72
  , 73
  , 74
  , 75
  , 76
  , 77
  , 78
  , 79
  , 80
  , 81
  , 82
  , 83
  , 84
  , 85
  , 86
  , 87
  , 88
  , 89
  , 90
  , -1
  , -1
  , -1
  , -1
  , 95
  , -1
  , 97
  , 98
  , 99
  , 100
  , 101
  , 102
  , 103
  , 104
  , 105
  , 106
  , 107
  , 108
  , 109
  , 110
  , 111
  , 112
  , 113
  , 114
  , 115
  , 116
  , 117
  , 118
  , 119
  , 120
  , 121
  , 122
  , 36
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 48
  , 49
  , 50
  , 51
  , 52
  , 53
  , 54
  , 55
  , 56
  , 57
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 65
  , 66
  , 67
  , 68
  , 69
  , 70
  , 71
  , 72
  , 73
  , 74
  , 75
  , 76
  , 77
  , 78
  , 79
  , 80
  , 81
  , 82
  , 83
  , 84
  , 85
  , 86
  , 87
  , 88
  , 89
  , 90
  , -1
  , -1
  , -1
  , -1
  , 95
  , -1
  , 97
  , 98
  , 99
  , 100
  , 101
  , 102
  , 103
  , 104
  , 105
  , 106
  , 107
  , 108
  , 109
  , 110
  , 111
  , 112
  , 113
  , 114
  , 115
  , 116
  , 117
  , 118
  , 119
  , 120
  , 121
  , 122
  , 36
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 48
  , 49
  , 50
  , 51
  , 52
  , 53
  , 54
  , 55
  , 56
  , 57
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 65
  , 66
  , 67
  , 68
  , 69
  , 70
  , 71
  , 72
  , 73
  , 74
  , 75
  , 76
  , 77
  , 78
  , 79
  , 80
  , 81
  , 82
  , 83
  , 84
  , 85
  , 86
  , 87
  , 88
  , 89
  , 90
  , -1
  , -1
  , -1
  , -1
  , 95
  , -1
  , 97
  , 98
  , 99
  , 100
  , 101
  , 102
  , 103
  , 104
  , 105
  , 106
  , 107
  , 108
  , 109
  , 110
  , 111
  , 112
  , 113
  , 114
  , 115
  , 116
  , 117
  , 118
  , 119
  , 120
  , 121
  , 122
  , 36
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 48
  , 49
  , 50
  , 51
  , 52
  , 53
  , 54
  , 55
  , 56
  , 57
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 65
  , 66
  , 67
  , 68
  , 69
  , 70
  , 71
  , 72
  , 73
  , 74
  , 75
  , 76
  , 77
  , 78
  , 79
  , 80
  , 81
  , 82
  , 83
  , 84
  , 85
  , 86
  , 87
  , 88
  , 89
  , 90
  , -1
  , -1
  , -1
  , -1
  , 95
  , -1
  , 97
  , 98
  , 99
  , 100
  , 101
  , 102
  , 103
  , 104
  , 105
  , 106
  , 107
  , 108
  , 109
  , 110
  , 111
  , 112
  , 113
  , 114
  , 115
  , 116
  , 117
  , 118
  , 119
  , 120
  , 121
  , 122
  , 36
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 48
  , 49
  , 50
  , 51
  , 52
  , 53
  , 54
  , 55
  , 56
  , 57
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 65
  , 66
  , 67
  , 68
  , 69
  , 70
  , 71
  , 72
  , 73
  , 74
  , 75
  , 76
  , 77
  , 78
  , 79
  , 80
  , 81
  , 82
  , 83
  , 84
  , 85
  , 86
  , 87
  , 88
  , 89
  , 90
  , -1
  , -1
  , -1
  , -1
  , 95
  , -1
  , 97
  , 98
  , 99
  , 100
  , 101
  , 102
  , 103
  , 104
  , 105
  , 106
  , 107
  , 108
  , 109
  , 110
  , 111
  , 112
  , 113
  , 114
  , 115
  , 116
  , 117
  , 118
  , 119
  , 120
  , 121
  , 122
  , 36
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 48
  , 49
  , 50
  , 51
  , 52
  , 53
  , 54
  , 55
  , 56
  , 57
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 65
  , 66
  , 67
  , 68
  , 69
  , 70
  , 71
  , 72
  , 73
  , 74
  , 75
  , 76
  , 77
  , 78
  , 79
  , 80
  , 81
  , 82
  , 83
  , 84
  , 85
  , 86
  , 87
  , 88
  , 89
  , 90
  , -1
  , -1
  , -1
  , -1
  , 95
  , -1
  , 97
  , 98
  , 99
  , 100
  , 101
  , 102
  , 103
  , 104
  , 105
  , 106
  , 107
  , 108
  , 109
  , 110
  , 111
  , 112
  , 113
  , 114
  , 115
  , 116
  , 117
  , 118
  , 119
  , 120
  , 121
  , 122
  , 36
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 48
  , 49
  , 50
  , 51
  , 52
  , 53
  , 54
  , 55
  , 56
  , 57
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 65
  , 66
  , 67
  , 68
  , 69
  , 70
  , 71
  , 72
  , 73
  , 74
  , 75
  , 76
  , 77
  , 78
  , 79
  , 80
  , 81
  , 82
  , 83
  , 84
  , 85
  , 86
  , 87
  , 88
  , 89
  , 90
  , -1
  , -1
  , -1
  , -1
  , 95
  , -1
  , 97
  , 98
  , 99
  , 100
  , 101
  , 102
  , 103
  , 104
  , 105
  , 106
  , 107
  , 108
  , 109
  , 110
  , 111
  , 112
  , 113
  , 114
  , 115
  , 116
  , 117
  , 118
  , 119
  , 120
  , 121
  , 122
  , 36
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 48
  , 49
  , 50
  , 51
  , 52
  , 53
  , 54
  , 55
  , 56
  , 57
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 65
  , 66
  , 67
  , 68
  , 69
  , 70
  , 71
  , 72
  , 73
  , 74
  , 75
  , 76
  , 77
  , 78
  , 79
  , 80
  , 81
  , 82
  , 83
  , 84
  , 85
  , 86
  , 87
  , 88
  , 89
  , 90
  , -1
  , -1
  , -1
  , -1
  , 95
  , -1
  , 97
  , 98
  , 99
  , 100
  , 101
  , 102
  , 103
  , 104
  , 105
  , 106
  , 107
  , 108
  , 109
  , 110
  , 111
  , 112
  , 113
  , 114
  , 115
  , 116
  , 117
  , 118
  , 119
  , 120
  , 121
  , 122
  , 36
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 48
  , 49
  , 50
  , 51
  , 52
  , 53
  , 54
  , 55
  , 56
  , 57
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 65
  , 66
  , 67
  , 68
  , 69
  , 70
  , 71
  , 72
  , 73
  , 74
  , 75
  , 76
  , 77
  , 78
  , 79
  , 80
  , 81
  , 82
  , 83
  , 84
  , 85
  , 86
  , 87
  , 88
  , 89
  , 90
  , -1
  , -1
  , -1
  , -1
  , 95
  , -1
  , 97
  , 98
  , 99
  , 100
  , 101
  , 102
  , 103
  , 104
  , 105
  , 106
  , 107
  , 108
  , 109
  , 110
  , 111
  , 112
  , 113
  , 114
  , 115
  , 116
  , 117
  , 118
  , 119
  , 120
  , 121
  , 122
  , 36
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 48
  , 49
  , 50
  , 51
  , 52
  , 53
  , 54
  , 55
  , 56
  , 57
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 65
  , 66
  , 67
  , 68
  , 69
  , 70
  , 71
  , 72
  , 73
  , 74
  , 75
  , 76
  , 77
  , 78
  , 79
  , 80
  , 81
  , 82
  , 83
  , 84
  , 85
  , 86
  , 87
  , 88
  , 89
  , 90
  , -1
  , -1
  , -1
  , -1
  , 95
  , -1
  , 97
  , 98
  , 99
  , 100
  , 101
  , 102
  , 103
  , 104
  , 105
  , 106
  , 107
  , 108
  , 109
  , 110
  , 111
  , 112
  , 113
  , 114
  , 115
  , 116
  , 117
  , 118
  , 119
  , 120
  , 121
  , 122
  , 36
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 48
  , 49
  , 50
  , 51
  , 52
  , 53
  , 54
  , 55
  , 56
  , 57
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 65
  , 66
  , 67
  , 68
  , 69
  , 70
  , 71
  , 72
  , 73
  , 74
  , 75
  , 76
  , 77
  , 78
  , 79
  , 80
  , 81
  , 82
  , 83
  , 84
  , 85
  , 86
  , 87
  , 88
  , 89
  , 90
  , -1
  , -1
  , -1
  , -1
  , 95
  , -1
  , 97
  , 98
  , 99
  , 100
  , 101
  , 102
  , 103
  , 104
  , 105
  , 106
  , 107
  , 108
  , 109
  , 110
  , 111
  , 112
  , 113
  , 114
  , 115
  , 116
  , 117
  , 118
  , 119
  , 120
  , 121
  , 122
  , 36
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 48
  , 49
  , 50
  , 51
  , 52
  , 53
  , 54
  , 55
  , 56
  , 57
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 65
  , 66
  , 67
  , 68
  , 69
  , 70
  , 71
  , 72
  , 73
  , 74
  , 75
  , 76
  , 77
  , 78
  , 79
  , 80
  , 81
  , 82
  , 83
  , 84
  , 85
  , 86
  , 87
  , 88
  , 89
  , 90
  , -1
  , -1
  , -1
  , -1
  , 95
  , -1
  , 97
  , 98
  , 99
  , 100
  , 101
  , 102
  , 103
  , 104
  , 105
  , 106
  , 107
  , 108
  , 109
  , 110
  , 111
  , 112
  , 113
  , 114
  , 115
  , 116
  , 117
  , 118
  , 119
  , 120
  , 121
  , 122
  , 36
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 48
  , 49
  , 50
  , 51
  , 52
  , 53
  , 54
  , 55
  , 56
  , 57
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 65
  , 66
  , 67
  , 68
  , 69
  , 70
  , 71
  , 72
  , 73
  , 74
  , 75
  , 76
  , 77
  , 78
  , 79
  , 80
  , 81
  , 82
  , 83
  , 84
  , 85
  , 86
  , 87
  , 88
  , 89
  , 90
  , -1
  , -1
  , -1
  , -1
  , 95
  , -1
  , 97
  , 98
  , 99
  , 100
  , 101
  , 102
  , 103
  , 104
  , 105
  , 106
  , 107
  , 108
  , 109
  , 110
  , 111
  , 112
  , 113
  , 114
  , 115
  , 116
  , 117
  , 118
  , 119
  , 120
  , 121
  , 122
  , 36
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 48
  , 49
  , 50
  , 51
  , 52
  , 53
  , 54
  , 55
  , 56
  , 57
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 65
  , 66
  , 67
  , 68
  , 69
  , 70
  , 71
  , 72
  , 73
  , 74
  , 75
  , 76
  , 77
  , 78
  , 79
  , 80
  , 81
  , 82
  , 83
  , 84
  , 85
  , 86
  , 87
  , 88
  , 89
  , 90
  , -1
  , -1
  , -1
  , -1
  , 95
  , -1
  , 97
  , 98
  , 99
  , 100
  , 101
  , 102
  , 103
  , 104
  , 105
  , 106
  , 107
  , 108
  , 109
  , 110
  , 111
  , 112
  , 113
  , 114
  , 115
  , 116
  , 117
  , 118
  , 119
  , 120
  , 121
  , 122
  , 36
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 48
  , 49
  , 50
  , 51
  , 52
  , 53
  , 54
  , 55
  , 56
  , 57
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 65
  , 66
  , 67
  , 68
  , 69
  , 70
  , 71
  , 72
  , 73
  , 74
  , 75
  , 76
  , 77
  , 78
  , 79
  , 80
  , 81
  , 82
  , 83
  , 84
  , 85
  , 86
  , 87
  , 88
  , 89
  , 90
  , -1
  , -1
  , -1
  , -1
  , 95
  , -1
  , 97
  , 98
  , 99
  , 100
  , 101
  , 102
  , 103
  , 104
  , 105
  , 106
  , 107
  , 108
  , 109
  , 110
  , 111
  , 112
  , 113
  , 114
  , 115
  , 116
  , 117
  , 118
  , 119
  , 120
  , 121
  , 122
  , 36
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 48
  , 49
  , 50
  , 51
  , 52
  , 53
  , 54
  , 55
  , 56
  , 57
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 65
  , 66
  , 67
  , 68
  , 69
  , 70
  , 71
  , 72
  , 73
  , 74
  , 75
  , 76
  , 77
  , 78
  , 79
  , 80
  , 81
  , 82
  , 83
  , 84
  , 85
  , 86
  , 87
  , 88
  , 89
  , 90
  , -1
  , -1
  , -1
  , -1
  , 95
  , -1
  , 97
  , 98
  , 99
  , 100
  , 101
  , 102
  , 103
  , 104
  , 105
  , 106
  , 107
  , 108
  , 109
  , 110
  , 111
  , 112
  , 113
  , 114
  , 115
  , 116
  , 117
  , 118
  , 119
  , 120
  , 121
  , 122
  , 36
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 48
  , 49
  , 50
  , 51
  , 52
  , 53
  , 54
  , 55
  , 56
  , 57
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 65
  , 66
  , 67
  , 68
  , 69
  , 70
  , 71
  , 72
  , 73
  , 74
  , 75
  , 76
  , 77
  , 78
  , 79
  , 80
  , 81
  , 82
  , 83
  , 84
  , 85
  , 86
  , 87
  , 88
  , 89
  , 90
  , -1
  , -1
  , -1
  , -1
  , 95
  , -1
  , 97
  , 98
  , 99
  , 100
  , 101
  , 102
  , 103
  , 104
  , 105
  , 106
  , 107
  , 108
  , 109
  , 110
  , 111
  , 112
  , 113
  , 114
  , 115
  , 116
  , 117
  , 118
  , 119
  , 120
  , 121
  , 122
  , 36
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 48
  , 49
  , 50
  , 51
  , 52
  , 53
  , 54
  , 55
  , 56
  , 57
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 65
  , 66
  , 67
  , 68
  , 69
  , 70
  , 71
  , 72
  , 73
  , 74
  , 75
  , 76
  , 77
  , 78
  , 79
  , 80
  , 81
  , 82
  , 83
  , 84
  , 85
  , 86
  , 87
  , 88
  , 89
  , 90
  , -1
  , -1
  , -1
  , -1
  , 95
  , -1
  , 97
  , 98
  , 99
  , 100
  , 101
  , 102
  , 103
  , 104
  , 105
  , 106
  , 107
  , 108
  , 109
  , 110
  , 111
  , 112
  , 113
  , 114
  , 115
  , 116
  , 117
  , 118
  , 119
  , 120
  , 121
  , 122
  , 36
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 48
  , 49
  , 50
  , 51
  , 52
  , 53
  , 54
  , 55
  , 56
  , 57
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 65
  , 66
  , 67
  , 68
  , 69
  , 70
  , 71
  , 72
  , 73
  , 74
  , 75
  , 76
  , 77
  , 78
  , 79
  , 80
  , 81
  , 82
  , 83
  , 84
  , 85
  , 86
  , 87
  , 88
  , 89
  , 90
  , -1
  , -1
  , -1
  , -1
  , 95
  , -1
  , 97
  , 98
  , 99
  , 100
  , 101
  , 102
  , 103
  , 104
  , 105
  , 106
  , 107
  , 108
  , 109
  , 110
  , 111
  , 112
  , 113
  , 114
  , 115
  , 116
  , 117
  , 118
  , 119
  , 120
  , 121
  , 122
  , 36
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 48
  , 49
  , 50
  , 51
  , 52
  , 53
  , 54
  , 55
  , 56
  , 57
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 65
  , 66
  , 67
  , 68
  , 69
  , 70
  , 71
  , 72
  , 73
  , 74
  , 75
  , 76
  , 77
  , 78
  , 79
  , 80
  , 81
  , 82
  , 83
  , 84
  , 85
  , 86
  , 87
  , 88
  , 89
  , 90
  , -1
  , -1
  , -1
  , -1
  , 95
  , -1
  , 97
  , 98
  , 99
  , 100
  , 101
  , 102
  , 103
  , 104
  , 105
  , 106
  , 107
  , 108
  , 109
  , 110
  , 111
  , 112
  , 113
  , 114
  , 115
  , 116
  , 117
  , 118
  , 119
  , 120
  , 121
  , 122
  , 36
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 48
  , 49
  , 50
  , 51
  , 52
  , 53
  , 54
  , 55
  , 56
  , 57
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 65
  , 66
  , 67
  , 68
  , 69
  , 70
  , 71
  , 72
  , 73
  , 74
  , 75
  , 76
  , 77
  , 78
  , 79
  , 80
  , 81
  , 82
  , 83
  , 84
  , 85
  , 86
  , 87
  , 88
  , 89
  , 90
  , -1
  , -1
  , -1
  , -1
  , 95
  , -1
  , 97
  , 98
  , 99
  , 100
  , 101
  , 102
  , 103
  , 104
  , 105
  , 106
  , 107
  , 108
  , 109
  , 110
  , 111
  , 112
  , 113
  , 114
  , 115
  , 116
  , 117
  , 118
  , 119
  , 120
  , 121
  , 122
  , 36
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 48
  , 49
  , 50
  , 51
  , 52
  , 53
  , 54
  , 55
  , 56
  , 57
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 65
  , 66
  , 67
  , 68
  , 69
  , 70
  , 71
  , 72
  , 73
  , 74
  , 75
  , 76
  , 77
  , 78
  , 79
  , 80
  , 81
  , 82
  , 83
  , 84
  , 85
  , 86
  , 87
  , 88
  , 89
  , 90
  , -1
  , -1
  , -1
  , -1
  , 95
  , -1
  , 97
  , 98
  , 99
  , 100
  , 101
  , 102
  , 103
  , 104
  , 105
  , 106
  , 107
  , 108
  , 109
  , 110
  , 111
  , 112
  , 113
  , 114
  , 115
  , 116
  , 117
  , 118
  , 119
  , 120
  , 121
  , 122
  , 36
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 48
  , 49
  , 50
  , 51
  , 52
  , 53
  , 54
  , 55
  , 56
  , 57
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 65
  , 66
  , 67
  , 68
  , 69
  , 70
  , 71
  , 72
  , 73
  , 74
  , 75
  , 76
  , 77
  , 78
  , 79
  , 80
  , 81
  , 82
  , 83
  , 84
  , 85
  , 86
  , 87
  , 88
  , 89
  , 90
  , -1
  , -1
  , -1
  , -1
  , 95
  , -1
  , 97
  , 98
  , 99
  , 100
  , 101
  , 102
  , 103
  , 104
  , 105
  , 106
  , 107
  , 108
  , 109
  , 110
  , 111
  , 112
  , 113
  , 114
  , 115
  , 116
  , 117
  , 118
  , 119
  , 120
  , 121
  , 122
  , 36
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 48
  , 49
  , 50
  , 51
  , 52
  , 53
  , 54
  , 55
  , 56
  , 57
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 65
  , 66
  , 67
  , 68
  , 69
  , 70
  , 71
  , 72
  , 73
  , 74
  , 75
  , 76
  , 77
  , 78
  , 79
  , 80
  , 81
  , 82
  , 83
  , 84
  , 85
  , 86
  , 87
  , 88
  , 89
  , 90
  , -1
  , -1
  , -1
  , -1
  , 95
  , -1
  , 97
  , 98
  , 99
  , 100
  , 101
  , 102
  , 103
  , 104
  , 105
  , 106
  , 107
  , 108
  , 109
  , 110
  , 111
  , 112
  , 113
  , 114
  , 115
  , 116
  , 117
  , 118
  , 119
  , 120
  , 121
  , 122
  , 36
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 48
  , 49
  , 50
  , 51
  , 52
  , 53
  , 54
  , 55
  , 56
  , 57
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 65
  , 66
  , 67
  , 68
  , 69
  , 70
  , 71
  , 72
  , 73
  , 74
  , 75
  , 76
  , 77
  , 78
  , 79
  , 80
  , 81
  , 82
  , 83
  , 84
  , 85
  , 86
  , 87
  , 88
  , 89
  , 90
  , -1
  , -1
  , -1
  , -1
  , 95
  , -1
  , 97
  , 98
  , 99
  , 100
  , 101
  , 102
  , 103
  , 104
  , 105
  , 106
  , 107
  , 108
  , 109
  , 110
  , 111
  , 112
  , 113
  , 114
  , 115
  , 116
  , 117
  , 118
  , 119
  , 120
  , 121
  , 122
  , 36
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 48
  , 49
  , 50
  , 51
  , 52
  , 53
  , 54
  , 55
  , 56
  , 57
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 65
  , 66
  , 67
  , 68
  , 69
  , 70
  , 71
  , 72
  , 73
  , 74
  , 75
  , 76
  , 77
  , 78
  , 79
  , 80
  , 81
  , 82
  , 83
  , 84
  , 85
  , 86
  , 87
  , 88
  , 89
  , 90
  , -1
  , -1
  , -1
  , -1
  , 95
  , -1
  , 97
  , 98
  , 99
  , 100
  , 101
  , 102
  , 103
  , 104
  , 105
  , 106
  , 107
  , 108
  , 109
  , 110
  , 111
  , 112
  , 113
  , 114
  , 115
  , 116
  , 117
  , 118
  , 119
  , 120
  , 121
  , 122
  , 36
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 48
  , 49
  , 50
  , 51
  , 52
  , 53
  , 54
  , 55
  , 56
  , 57
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 65
  , 66
  , 67
  , 68
  , 69
  , 70
  , 71
  , 72
  , 73
  , 74
  , 75
  , 76
  , 77
  , 78
  , 79
  , 80
  , 81
  , 82
  , 83
  , 84
  , 85
  , 86
  , 87
  , 88
  , 89
  , 90
  , -1
  , -1
  , -1
  , -1
  , 95
  , -1
  , 97
  , 98
  , 99
  , 100
  , 101
  , 102
  , 103
  , 104
  , 105
  , 106
  , 107
  , 108
  , 109
  , 110
  , 111
  , 112
  , 113
  , 114
  , 115
  , 116
  , 117
  , 118
  , 119
  , 120
  , 121
  , 122
  , 36
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 48
  , 49
  , 50
  , 51
  , 52
  , 53
  , 54
  , 55
  , 56
  , 57
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 65
  , 66
  , 67
  , 68
  , 69
  , 70
  , 71
  , 72
  , 73
  , 74
  , 75
  , 76
  , 77
  , 78
  , 79
  , 80
  , 81
  , 82
  , 83
  , 84
  , 85
  , 86
  , 87
  , 88
  , 89
  , 90
  , -1
  , -1
  , -1
  , -1
  , 95
  , -1
  , 97
  , 98
  , 99
  , 100
  , 101
  , 102
  , 103
  , 104
  , 105
  , 106
  , 107
  , 108
  , 109
  , 110
  , 111
  , 112
  , 113
  , 114
  , 115
  , 116
  , 117
  , 118
  , 119
  , 120
  , 121
  , 122
  , 36
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 48
  , 49
  , 50
  , 51
  , 52
  , 53
  , 54
  , 55
  , 56
  , 57
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 65
  , 66
  , 67
  , 68
  , 69
  , 70
  , 71
  , 72
  , 73
  , 74
  , 75
  , 76
  , 77
  , 78
  , 79
  , 80
  , 81
  , 82
  , 83
  , 84
  , 85
  , 86
  , 87
  , 88
  , 89
  , 90
  , -1
  , -1
  , -1
  , -1
  , 95
  , -1
  , 97
  , 98
  , 99
  , 100
  , 101
  , 102
  , 103
  , 104
  , 105
  , 106
  , 107
  , 108
  , 109
  , 110
  , 111
  , 112
  , 113
  , 114
  , 115
  , 116
  , 117
  , 118
  , 119
  , 120
  , 121
  , 122
  , 36
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 48
  , 49
  , 50
  , 51
  , 52
  , 53
  , 54
  , 55
  , 56
  , 57
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 65
  , 66
  , 67
  , 68
  , 69
  , 70
  , 71
  , 72
  , 73
  , 74
  , 75
  , 76
  , 77
  , 78
  , 79
  , 80
  , 81
  , 82
  , 83
  , 84
  , 85
  , 86
  , 87
  , 88
  , 89
  , 90
  , -1
  , -1
  , -1
  , -1
  , 95
  , -1
  , 97
  , 98
  , 99
  , 100
  , 101
  , 102
  , 103
  , 104
  , 105
  , 106
  , 107
  , 108
  , 109
  , 110
  , 111
  , 112
  , 113
  , 114
  , 115
  , 116
  , 117
  , 118
  , 119
  , 120
  , 121
  , 122
  , 36
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 48
  , 49
  , 50
  , 51
  , 52
  , 53
  , 54
  , 55
  , 56
  , 57
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 65
  , 66
  , 67
  , 68
  , 69
  , 70
  , 71
  , 72
  , 73
  , 74
  , 75
  , 76
  , 77
  , 78
  , 79
  , 80
  , 81
  , 82
  , 83
  , 84
  , 85
  , 86
  , 87
  , 88
  , 89
  , 90
  , -1
  , -1
  , -1
  , -1
  , 95
  , -1
  , 97
  , 98
  , 99
  , 100
  , 101
  , 102
  , 103
  , 104
  , 105
  , 106
  , 107
  , 108
  , 109
  , 110
  , 111
  , 112
  , 113
  , 114
  , 115
  , 116
  , 117
  , 118
  , 119
  , 120
  , 121
  , 122
  , 36
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 48
  , 49
  , 50
  , 51
  , 52
  , 53
  , 54
  , 55
  , 56
  , 57
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 65
  , 66
  , 67
  , 68
  , 69
  , 70
  , 71
  , 72
  , 73
  , 74
  , 75
  , 76
  , 77
  , 78
  , 79
  , 80
  , 81
  , 82
  , 83
  , 84
  , 85
  , 86
  , 87
  , 88
  , 89
  , 90
  , -1
  , -1
  , -1
  , -1
  , 95
  , -1
  , 97
  , 98
  , 99
  , 100
  , 101
  , 102
  , 103
  , 104
  , 105
  , 106
  , 107
  , 108
  , 109
  , 110
  , 111
  , 112
  , 113
  , 114
  , 115
  , 116
  , 117
  , 118
  , 119
  , 120
  , 121
  , 122
  , 36
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 48
  , 49
  , 50
  , 51
  , 52
  , 53
  , 54
  , 55
  , 56
  , 57
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 65
  , 66
  , 67
  , 68
  , 69
  , 70
  , 71
  , 72
  , 73
  , 74
  , 75
  , 76
  , 77
  , 78
  , 79
  , 80
  , 81
  , 82
  , 83
  , 84
  , 85
  , 86
  , 87
  , 88
  , 89
  , 90
  , -1
  , -1
  , -1
  , -1
  , 95
  , -1
  , 97
  , 98
  , 99
  , 100
  , 101
  , 102
  , 103
  , 104
  , 105
  , 106
  , 107
  , 108
  , 109
  , 110
  , 111
  , 112
  , 113
  , 114
  , 115
  , 116
  , 117
  , 118
  , 119
  , 120
  , 121
  , 122
  , 36
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 48
  , 49
  , 50
  , 51
  , 52
  , 53
  , 54
  , 55
  , 56
  , 57
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 65
  , 66
  , 67
  , 68
  , 69
  , 70
  , 71
  , 72
  , 73
  , 74
  , 75
  , 76
  , 77
  , 78
  , 79
  , 80
  , 81
  , 82
  , 83
  , 84
  , 85
  , 86
  , 87
  , 88
  , 89
  , 90
  , -1
  , -1
  , -1
  , -1
  , 95
  , -1
  , 97
  , 98
  , 99
  , 100
  , 101
  , 102
  , 103
  , 104
  , 105
  , 106
  , 107
  , 108
  , 109
  , 110
  , 111
  , 112
  , 113
  , 114
  , 115
  , 116
  , 117
  , 118
  , 119
  , 120
  , 121
  , 122
  , 36
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 48
  , 49
  , 50
  , 51
  , 52
  , 53
  , 54
  , 55
  , 56
  , 57
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 65
  , 66
  , 67
  , 68
  , 69
  , 70
  , 71
  , 72
  , 73
  , 74
  , 75
  , 76
  , 77
  , 78
  , 79
  , 80
  , 81
  , 82
  , 83
  , 84
  , 85
  , 86
  , 87
  , 88
  , 89
  , 90
  , -1
  , -1
  , -1
  , -1
  , 95
  , -1
  , 97
  , 98
  , 99
  , 100
  , 101
  , 102
  , 103
  , 104
  , 105
  , 106
  , 107
  , 108
  , 109
  , 110
  , 111
  , 112
  , 113
  , 114
  , 115
  , 116
  , 117
  , 118
  , 119
  , 120
  , 121
  , 122
  , 36
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 48
  , 49
  , 50
  , 51
  , 52
  , 53
  , 54
  , 55
  , 56
  , 57
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 65
  , 66
  , 67
  , 68
  , 69
  , 70
  , 71
  , 72
  , 73
  , 74
  , 75
  , 76
  , 77
  , 78
  , 79
  , 80
  , 81
  , 82
  , 83
  , 84
  , 85
  , 86
  , 87
  , 88
  , 89
  , 90
  , -1
  , -1
  , -1
  , -1
  , 95
  , -1
  , 97
  , 98
  , 99
  , 100
  , 101
  , 102
  , 103
  , 104
  , 105
  , 106
  , 107
  , 108
  , 109
  , 110
  , 111
  , 112
  , 113
  , 114
  , 115
  , 116
  , 117
  , 118
  , 119
  , 120
  , 121
  , 122
  , 36
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 48
  , 49
  , 50
  , 51
  , 52
  , 53
  , 54
  , 55
  , 56
  , 57
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 65
  , 66
  , 67
  , 68
  , 69
  , 70
  , 71
  , 72
  , 73
  , 74
  , 75
  , 76
  , 77
  , 78
  , 79
  , 80
  , 81
  , 82
  , 83
  , 84
  , 85
  , 86
  , 87
  , 88
  , 89
  , 90
  , -1
  , -1
  , -1
  , -1
  , 95
  , -1
  , 97
  , 98
  , 99
  , 100
  , 101
  , 102
  , 103
  , 104
  , 105
  , 106
  , 107
  , 108
  , 109
  , 110
  , 111
  , 112
  , 113
  , 114
  , 115
  , 116
  , 117
  , 118
  , 119
  , 120
  , 121
  , 122
  , 36
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 48
  , 49
  , 50
  , 51
  , 52
  , 53
  , 54
  , 55
  , 56
  , 57
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 65
  , 66
  , 67
  , 68
  , 69
  , 70
  , 71
  , 72
  , 73
  , 74
  , 75
  , 76
  , 77
  , 78
  , 79
  , 80
  , 81
  , 82
  , 83
  , 84
  , 85
  , 86
  , 87
  , 88
  , 89
  , 90
  , -1
  , -1
  , -1
  , -1
  , 95
  , -1
  , 97
  , 98
  , 99
  , 100
  , 101
  , 102
  , 103
  , 104
  , 105
  , 106
  , 107
  , 108
  , 109
  , 110
  , 111
  , 112
  , 113
  , 114
  , 115
  , 116
  , 117
  , 118
  , 119
  , 120
  , 121
  , 122
  , 36
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 48
  , 49
  , 50
  , 51
  , 52
  , 53
  , 54
  , 55
  , 56
  , 57
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 65
  , 66
  , 67
  , 68
  , 69
  , 70
  , 71
  , 72
  , 73
  , 74
  , 75
  , 76
  , 77
  , 78
  , 79
  , 80
  , 81
  , 82
  , 83
  , 84
  , 85
  , 86
  , 87
  , 88
  , 89
  , 90
  , -1
  , -1
  , -1
  , -1
  , 95
  , -1
  , 97
  , 98
  , 99
  , 100
  , 101
  , 102
  , 103
  , 104
  , 105
  , 106
  , 107
  , 108
  , 109
  , 110
  , 111
  , 112
  , 113
  , 114
  , 115
  , 116
  , 117
  , 118
  , 119
  , 120
  , 121
  , 122
  , 36
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 48
  , 49
  , 50
  , 51
  , 52
  , 53
  , 54
  , 55
  , 56
  , 57
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 65
  , 66
  , 67
  , 68
  , 69
  , 70
  , 71
  , 72
  , 73
  , 74
  , 75
  , 76
  , 77
  , 78
  , 79
  , 80
  , 81
  , 82
  , 83
  , 84
  , 85
  , 86
  , 87
  , 88
  , 89
  , 90
  , -1
  , -1
  , -1
  , -1
  , 95
  , -1
  , 97
  , 98
  , 99
  , 100
  , 101
  , 102
  , 103
  , 104
  , 105
  , 106
  , 107
  , 108
  , 109
  , 110
  , 111
  , 112
  , 113
  , 114
  , 115
  , 116
  , 117
  , 118
  , 119
  , 120
  , 121
  , 122
  , 36
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 48
  , 49
  , 50
  , 51
  , 52
  , 53
  , 54
  , 55
  , 56
  , 57
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 65
  , 66
  , 67
  , 68
  , 69
  , 70
  , 71
  , 72
  , 73
  , 74
  , 75
  , 76
  , 77
  , 78
  , 79
  , 80
  , 81
  , 82
  , 83
  , 84
  , 85
  , 86
  , 87
  , 88
  , 89
  , 90
  , -1
  , -1
  , -1
  , -1
  , 95
  , -1
  , 97
  , 98
  , 99
  , 100
  , 101
  , 102
  , 103
  , 104
  , 105
  , 106
  , 107
  , 108
  , 109
  , 110
  , 111
  , 112
  , 113
  , 114
  , 115
  , 116
  , 117
  , 118
  , 119
  , 120
  , 121
  , 122
  , 36
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 48
  , 49
  , 50
  , 51
  , 52
  , 53
  , 54
  , 55
  , 56
  , 57
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 65
  , 66
  , 67
  , 68
  , 69
  , 70
  , 71
  , 72
  , 73
  , 74
  , 75
  , 76
  , 77
  , 78
  , 79
  , 80
  , 81
  , 82
  , 83
  , 84
  , 85
  , 86
  , 87
  , 88
  , 89
  , 90
  , -1
  , -1
  , -1
  , -1
  , 95
  , -1
  , 97
  , 98
  , 99
  , 100
  , 101
  , 102
  , 103
  , 104
  , 105
  , 106
  , 107
  , 108
  , 109
  , 110
  , 111
  , 112
  , 113
  , 114
  , 115
  , 116
  , 117
  , 118
  , 119
  , 120
  , 121
  , 122
  , 36
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 48
  , 49
  , 50
  , 51
  , 52
  , 53
  , 54
  , 55
  , 56
  , 57
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 65
  , 66
  , 67
  , 68
  , 69
  , 70
  , 71
  , 72
  , 73
  , 74
  , 75
  , 76
  , 77
  , 78
  , 79
  , 80
  , 81
  , 82
  , 83
  , 84
  , 85
  , 86
  , 87
  , 88
  , 89
  , 90
  , -1
  , -1
  , -1
  , -1
  , 95
  , -1
  , 97
  , 98
  , 99
  , 100
  , 101
  , 102
  , 103
  , 104
  , 105
  , 106
  , 107
  , 108
  , 109
  , 110
  , 111
  , 112
  , 113
  , 114
  , 115
  , 116
  , 117
  , 118
  , 119
  , 120
  , 121
  , 122
  , 36
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 48
  , 49
  , 50
  , 51
  , 52
  , 53
  , 54
  , 55
  , 56
  , 57
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 65
  , 66
  , 67
  , 68
  , 69
  , 70
  , 71
  , 72
  , 73
  , 74
  , 75
  , 76
  , 77
  , 78
  , 79
  , 80
  , 81
  , 82
  , 83
  , 84
  , 85
  , 86
  , 87
  , 88
  , 89
  , 90
  , -1
  , -1
  , -1
  , -1
  , 95
  , -1
  , 97
  , 98
  , 99
  , 100
  , 101
  , 102
  , 103
  , 104
  , 105
  , 106
  , 107
  , 108
  , 109
  , 110
  , 111
  , 112
  , 113
  , 114
  , 115
  , 116
  , 117
  , 118
  , 119
  , 120
  , 121
  , 122
  , 36
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 48
  , 49
  , 50
  , 51
  , 52
  , 53
  , 54
  , 55
  , 56
  , 57
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 65
  , 66
  , 67
  , 68
  , 69
  , 70
  , 71
  , 72
  , 73
  , 74
  , 75
  , 76
  , 77
  , 78
  , 79
  , 80
  , 81
  , 82
  , 83
  , 84
  , 85
  , 86
  , 87
  , 88
  , 89
  , 90
  , -1
  , -1
  , -1
  , -1
  , 95
  , -1
  , 97
  , 98
  , 99
  , 100
  , 101
  , 102
  , 103
  , 104
  , 105
  , 106
  , 107
  , 108
  , 109
  , 110
  , 111
  , 112
  , 113
  , 114
  , 115
  , 116
  , 117
  , 118
  , 119
  , 120
  , 121
  , 122
  , 36
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 48
  , 49
  , 50
  , 51
  , 52
  , 53
  , 54
  , 55
  , 56
  , 57
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 65
  , 66
  , 67
  , 68
  , 69
  , 70
  , 71
  , 72
  , 73
  , 74
  , 75
  , 76
  , 77
  , 78
  , 79
  , 80
  , 81
  , 82
  , 83
  , 84
  , 85
  , 86
  , 87
  , 88
  , 89
  , 90
  , -1
  , -1
  , -1
  , -1
  , 95
  , -1
  , 97
  , 98
  , 99
  , 100
  , 101
  , 102
  , 103
  , 104
  , 105
  , 106
  , 107
  , 108
  , 109
  , 110
  , 111
  , 112
  , 113
  , 114
  , 115
  , 116
  , 117
  , 118
  , 119
  , 120
  , 121
  , 122
  , 36
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 48
  , 49
  , 50
  , 51
  , 52
  , 53
  , 54
  , 55
  , 56
  , 57
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 65
  , 66
  , 67
  , 68
  , 69
  , 70
  , 71
  , 72
  , 73
  , 74
  , 75
  , 76
  , 77
  , 78
  , 79
  , 80
  , 81
  , 82
  , 83
  , 84
  , 85
  , 86
  , 87
  , 88
  , 89
  , 90
  , -1
  , -1
  , -1
  , -1
  , 95
  , -1
  , 97
  , 98
  , 99
  , 100
  , 101
  , 102
  , 103
  , 104
  , 105
  , 106
  , 107
  , 108
  , 109
  , 110
  , 111
  , 112
  , 113
  , 114
  , 115
  , 116
  , 117
  , 118
  , 119
  , 120
  , 121
  , 122
  , 36
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 48
  , 49
  , 50
  , 51
  , 52
  , 53
  , 54
  , 55
  , 56
  , 57
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 65
  , 66
  , 67
  , 68
  , 69
  , 70
  , 71
  , 72
  , 73
  , 74
  , 75
  , 76
  , 77
  , 78
  , 79
  , 80
  , 81
  , 82
  , 83
  , 84
  , 85
  , 86
  , 87
  , 88
  , 89
  , 90
  , -1
  , -1
  , -1
  , -1
  , 95
  , -1
  , 97
  , 98
  , 99
  , 100
  , 101
  , 102
  , 103
  , 104
  , 105
  , 106
  , 107
  , 108
  , 109
  , 110
  , 111
  , 112
  , 113
  , 114
  , 115
  , 116
  , 117
  , 118
  , 119
  , 120
  , 121
  , 122
  , 36
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 48
  , 49
  , 50
  , 51
  , 52
  , 53
  , 54
  , 55
  , 56
  , 57
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 65
  , 66
  , 67
  , 68
  , 69
  , 70
  , 71
  , 72
  , 73
  , 74
  , 75
  , 76
  , 77
  , 78
  , 79
  , 80
  , 81
  , 82
  , 83
  , 84
  , 85
  , 86
  , 87
  , 88
  , 89
  , 90
  , -1
  , -1
  , -1
  , -1
  , 95
  , -1
  , 97
  , 98
  , 99
  , 100
  , 101
  , 102
  , 103
  , 104
  , 105
  , 106
  , 107
  , 108
  , 109
  , 110
  , 111
  , 112
  , 113
  , 114
  , 115
  , 116
  , 117
  , 118
  , 119
  , 120
  , 121
  , 122
  , 36
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 48
  , 49
  , 50
  , 51
  , 52
  , 53
  , 54
  , 55
  , 56
  , 57
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 65
  , 66
  , 67
  , 68
  , 69
  , 70
  , 71
  , 72
  , 73
  , 74
  , 75
  , 76
  , 77
  , 78
  , 79
  , 80
  , 81
  , 82
  , 83
  , 84
  , 85
  , 86
  , 87
  , 88
  , 89
  , 90
  , -1
  , -1
  , -1
  , -1
  , 95
  , -1
  , 97
  , 98
  , 99
  , 100
  , 101
  , 102
  , 103
  , 104
  , 105
  , 106
  , 107
  , 108
  , 109
  , 110
  , 111
  , 112
  , 113
  , 114
  , 115
  , 116
  , 117
  , 118
  , 119
  , 120
  , 121
  , 122
  , 36
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 48
  , 49
  , 50
  , 51
  , 52
  , 53
  , 54
  , 55
  , 56
  , 57
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 65
  , 66
  , 67
  , 68
  , 69
  , 70
  , 71
  , 72
  , 73
  , 74
  , 75
  , 76
  , 77
  , 78
  , 79
  , 80
  , 81
  , 82
  , 83
  , 84
  , 85
  , 86
  , 87
  , 88
  , 89
  , 90
  , -1
  , -1
  , -1
  , -1
  , 95
  , -1
  , 97
  , 98
  , 99
  , 100
  , 101
  , 102
  , 103
  , 104
  , 105
  , 106
  , 107
  , 108
  , 109
  , 110
  , 111
  , 112
  , 113
  , 114
  , 115
  , 116
  , 117
  , 118
  , 119
  , 120
  , 121
  , 122
  , 36
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 48
  , 49
  , 50
  , 51
  , 52
  , 53
  , 54
  , 55
  , 56
  , 57
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 65
  , 66
  , 67
  , 68
  , 69
  , 70
  , 71
  , 72
  , 73
  , 74
  , 75
  , 76
  , 77
  , 78
  , 79
  , 80
  , 81
  , 82
  , 83
  , 84
  , 85
  , 86
  , 87
  , 88
  , 89
  , 90
  , -1
  , -1
  , -1
  , -1
  , 95
  , -1
  , 97
  , 98
  , 99
  , 100
  , 101
  , 102
  , 103
  , 104
  , 105
  , 106
  , 107
  , 108
  , 109
  , 110
  , 111
  , 112
  , 113
  , 114
  , 115
  , 116
  , 117
  , 118
  , 119
  , 120
  , 121
  , 122
  , 36
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 48
  , 49
  , 50
  , 51
  , 52
  , 53
  , 54
  , 55
  , 56
  , 57
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 65
  , 66
  , 67
  , 68
  , 69
  , 70
  , 71
  , 72
  , 73
  , 74
  , 75
  , 76
  , 77
  , 78
  , 79
  , 80
  , 81
  , 82
  , 83
  , 84
  , 85
  , 86
  , 87
  , 88
  , 89
  , 90
  , -1
  , -1
  , -1
  , -1
  , 95
  , -1
  , 97
  , 98
  , 99
  , 100
  , 101
  , 102
  , 103
  , 104
  , 105
  , 106
  , 107
  , 108
  , 109
  , 110
  , 111
  , 112
  , 113
  , 114
  , 115
  , 116
  , 117
  , 118
  , 119
  , 120
  , 121
  , 122
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  ]

alex_deflt :: Array Int Int
alex_deflt = listArray (0 :: Int, 392)
  [ -1
  , 60
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 33
  , 33
  , -1
  , 38
  , 38
  , -1
  , 41
  , 41
  , -1
  , 45
  , 45
  , 46
  , 46
  , -1
  , 52
  , 52
  , -1
  , 58
  , 58
  , 60
  , 60
  , 60
  , 63
  , 63
  , 64
  , -1
  , -1
  , 64
  , 64
  , 3
  , -1
  , -1
  , 3
  , 3
  , 3
  , -1
  , 60
  , 74
  , 74
  , 74
  , 64
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , 74
  , -1
  , -1
  , 74
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  , -1
  ]

alex_accept = listArray (0 :: Int, 392)
  [ AlexAccNone
  , AlexAccNone
  , AlexAccNone
  , AlexAccNone
  , AlexAccNone
  , AlexAccNone
  , AlexAccNone
  , AlexAccNone
  , AlexAccNone
  , AlexAccNone
  , AlexAccNone
  , AlexAccNone
  , AlexAccNone
  , AlexAccNone
  , AlexAccNone
  , AlexAccNone
  , AlexAccNone
  , AlexAccNone
  , AlexAccNone
  , AlexAccNone
  , AlexAccNone
  , AlexAccNone
  , AlexAccNone
  , AlexAccNone
  , AlexAccNone
  , AlexAccNone
  , AlexAccNone
  , AlexAccNone
  , AlexAccNone
  , AlexAccNone
  , AlexAccNone
  , AlexAccNone
  , AlexAccNone
  , AlexAccNone
  , AlexAccNone
  , AlexAccNone
  , AlexAccNone
  , AlexAccNone
  , AlexAccNone
  , AlexAccNone
  , AlexAccNone
  , AlexAccNone
  , AlexAccNone
  , AlexAccNone
  , AlexAccNone
  , AlexAccNone
  , AlexAccNone
  , AlexAccNone
  , AlexAccNone
  , AlexAccNone
  , AlexAccNone
  , AlexAccNone
  , AlexAccNone
  , AlexAccNone
  , AlexAccNone
  , AlexAccNone
  , AlexAccNone
  , AlexAccNone
  , AlexAccNone
  , AlexAccNone
  , AlexAccNone
  , AlexAccNone
  , AlexAccNone
  , AlexAccNone
  , AlexAccNone
  , AlexAccNone
  , AlexAccNone
  , AlexAccNone
  , AlexAccNone
  , AlexAccNone
  , AlexAccNone
  , AlexAccNone
  , AlexAccNone
  , AlexAccNone
  , AlexAccNone
  , AlexAccSkip
  , AlexAccSkip
  , AlexAccSkip
  , AlexAcc 314
  , AlexAcc 313
  , AlexAcc 312
  , AlexAcc 311
  , AlexAcc 310
  , AlexAcc 309
  , AlexAcc 308
  , AlexAcc 307
  , AlexAcc 306
  , AlexAcc 305
  , AlexAcc 304
  , AlexAcc 303
  , AlexAcc 302
  , AlexAcc 301
  , AlexAcc 300
  , AlexAcc 299
  , AlexAcc 298
  , AlexAcc 297
  , AlexAcc 296
  , AlexAcc 295
  , AlexAcc 294
  , AlexAcc 293
  , AlexAcc 292
  , AlexAcc 291
  , AlexAcc 290
  , AlexAcc 289
  , AlexAcc 288
  , AlexAcc 287
  , AlexAcc 286
  , AlexAcc 285
  , AlexAcc 284
  , AlexAcc 283
  , AlexAcc 282
  , AlexAcc 281
  , AlexAcc 280
  , AlexAcc 279
  , AlexAcc 278
  , AlexAcc 277
  , AlexAcc 276
  , AlexAcc 275
  , AlexAcc 274
  , AlexAcc 273
  , AlexAcc 272
  , AlexAcc 271
  , AlexAcc 270
  , AlexAcc 269
  , AlexAcc 268
  , AlexAcc 267
  , AlexAcc 266
  , AlexAcc 265
  , AlexAcc 264
  , AlexAcc 263
  , AlexAcc 262
  , AlexAcc 261
  , AlexAcc 260
  , AlexAcc 259
  , AlexAcc 258
  , AlexAcc 257
  , AlexAcc 256
  , AlexAcc 255
  , AlexAcc 254
  , AlexAcc 253
  , AlexAcc 252
  , AlexAcc 251
  , AlexAcc 250
  , AlexAcc 249
  , AlexAcc 248
  , AlexAcc 247
  , AlexAcc 246
  , AlexAcc 245
  , AlexAcc 244
  , AlexAcc 243
  , AlexAcc 242
  , AlexAcc 241
  , AlexAcc 240
  , AlexAcc 239
  , AlexAcc 238
  , AlexAcc 237
  , AlexAcc 236
  , AlexAcc 235
  , AlexAcc 234
  , AlexAcc 233
  , AlexAcc 232
  , AlexAcc 231
  , AlexAcc 230
  , AlexAcc 229
  , AlexAcc 228
  , AlexAcc 227
  , AlexAcc 226
  , AlexAcc 225
  , AlexAcc 224
  , AlexAcc 223
  , AlexAcc 222
  , AlexAcc 221
  , AlexAcc 220
  , AlexAcc 219
  , AlexAcc 218
  , AlexAcc 217
  , AlexAcc 216
  , AlexAcc 215
  , AlexAcc 214
  , AlexAcc 213
  , AlexAcc 212
  , AlexAcc 211
  , AlexAcc 210
  , AlexAcc 209
  , AlexAcc 208
  , AlexAcc 207
  , AlexAcc 206
  , AlexAcc 205
  , AlexAcc 204
  , AlexAcc 203
  , AlexAcc 202
  , AlexAcc 201
  , AlexAcc 200
  , AlexAcc 199
  , AlexAcc 198
  , AlexAcc 197
  , AlexAcc 196
  , AlexAcc 195
  , AlexAcc 194
  , AlexAcc 193
  , AlexAcc 192
  , AlexAcc 191
  , AlexAcc 190
  , AlexAcc 189
  , AlexAcc 188
  , AlexAcc 187
  , AlexAcc 186
  , AlexAcc 185
  , AlexAcc 184
  , AlexAcc 183
  , AlexAcc 182
  , AlexAcc 181
  , AlexAcc 180
  , AlexAcc 179
  , AlexAcc 178
  , AlexAcc 177
  , AlexAcc 176
  , AlexAcc 175
  , AlexAcc 174
  , AlexAcc 173
  , AlexAcc 172
  , AlexAcc 171
  , AlexAcc 170
  , AlexAcc 169
  , AlexAcc 168
  , AlexAcc 167
  , AlexAcc 166
  , AlexAcc 165
  , AlexAcc 164
  , AlexAcc 163
  , AlexAcc 162
  , AlexAcc 161
  , AlexAcc 160
  , AlexAcc 159
  , AlexAcc 158
  , AlexAcc 157
  , AlexAcc 156
  , AlexAcc 155
  , AlexAcc 154
  , AlexAcc 153
  , AlexAcc 152
  , AlexAcc 151
  , AlexAcc 150
  , AlexAcc 149
  , AlexAcc 148
  , AlexAcc 147
  , AlexAcc 146
  , AlexAcc 145
  , AlexAcc 144
  , AlexAcc 143
  , AlexAcc 142
  , AlexAcc 141
  , AlexAcc 140
  , AlexAcc 139
  , AlexAcc 138
  , AlexAcc 137
  , AlexAcc 136
  , AlexAcc 135
  , AlexAcc 134
  , AlexAcc 133
  , AlexAcc 132
  , AlexAcc 131
  , AlexAcc 130
  , AlexAcc 129
  , AlexAcc 128
  , AlexAcc 127
  , AlexAcc 126
  , AlexAcc 125
  , AlexAcc 124
  , AlexAcc 123
  , AlexAcc 122
  , AlexAcc 121
  , AlexAcc 120
  , AlexAcc 119
  , AlexAcc 118
  , AlexAcc 117
  , AlexAcc 116
  , AlexAcc 115
  , AlexAcc 114
  , AlexAcc 113
  , AlexAcc 112
  , AlexAcc 111
  , AlexAcc 110
  , AlexAcc 109
  , AlexAcc 108
  , AlexAcc 107
  , AlexAcc 106
  , AlexAcc 105
  , AlexAcc 104
  , AlexAcc 103
  , AlexAcc 102
  , AlexAcc 101
  , AlexAcc 100
  , AlexAcc 99
  , AlexAcc 98
  , AlexAcc 97
  , AlexAcc 96
  , AlexAcc 95
  , AlexAcc 94
  , AlexAcc 93
  , AlexAcc 92
  , AlexAcc 91
  , AlexAcc 90
  , AlexAcc 89
  , AlexAcc 88
  , AlexAcc 87
  , AlexAcc 86
  , AlexAcc 85
  , AlexAcc 84
  , AlexAcc 83
  , AlexAcc 82
  , AlexAcc 81
  , AlexAcc 80
  , AlexAcc 79
  , AlexAcc 78
  , AlexAcc 77
  , AlexAcc 76
  , AlexAcc 75
  , AlexAcc 74
  , AlexAcc 73
  , AlexAcc 72
  , AlexAcc 71
  , AlexAcc 70
  , AlexAcc 69
  , AlexAcc 68
  , AlexAcc 67
  , AlexAcc 66
  , AlexAcc 65
  , AlexAcc 64
  , AlexAcc 63
  , AlexAcc 62
  , AlexAcc 61
  , AlexAcc 60
  , AlexAcc 59
  , AlexAcc 58
  , AlexAcc 57
  , AlexAcc 56
  , AlexAcc 55
  , AlexAcc 54
  , AlexAcc 53
  , AlexAcc 52
  , AlexAcc 51
  , AlexAcc 50
  , AlexAcc 49
  , AlexAcc 48
  , AlexAcc 47
  , AlexAcc 46
  , AlexAcc 45
  , AlexAcc 44
  , AlexAcc 43
  , AlexAcc 42
  , AlexAcc 41
  , AlexAcc 40
  , AlexAcc 39
  , AlexAcc 38
  , AlexAcc 37
  , AlexAcc 36
  , AlexAcc 35
  , AlexAcc 34
  , AlexAcc 33
  , AlexAcc 32
  , AlexAcc 31
  , AlexAcc 30
  , AlexAcc 29
  , AlexAcc 28
  , AlexAcc 27
  , AlexAcc 26
  , AlexAcc 25
  , AlexAcc 24
  , AlexAcc 23
  , AlexAcc 22
  , AlexAcc 21
  , AlexAcc 20
  , AlexAcc 19
  , AlexAcc 18
  , AlexAcc 17
  , AlexAcc 16
  , AlexAcc 15
  , AlexAcc 14
  , AlexAcc 13
  , AlexAcc 12
  , AlexAcc 11
  , AlexAcc 10
  , AlexAcc 9
  , AlexAcc 8
  , AlexAcc 7
  , AlexAcc 6
  , AlexAcc 5
  , AlexAcc 4
  , AlexAcc 3
  , AlexAcc 2
  , AlexAcc 1
  , AlexAcc 0
  ]

alex_actions = array (0 :: Int, 315)
  [ (314,alex_action_2)
  , (313,alex_action_3)
  , (312,alex_action_4)
  , (311,alex_action_5)
  , (310,alex_action_6)
  , (309,alex_action_7)
  , (308,alex_action_8)
  , (307,alex_action_9)
  , (306,alex_action_10)
  , (305,alex_action_11)
  , (304,alex_action_12)
  , (303,alex_action_13)
  , (302,alex_action_14)
  , (301,alex_action_15)
  , (300,alex_action_16)
  , (299,alex_action_17)
  , (298,alex_action_18)
  , (297,alex_action_19)
  , (296,alex_action_20)
  , (295,alex_action_21)
  , (294,alex_action_22)
  , (293,alex_action_23)
  , (292,alex_action_24)
  , (291,alex_action_25)
  , (290,alex_action_26)
  , (289,alex_action_27)
  , (288,alex_action_28)
  , (287,alex_action_29)
  , (286,alex_action_30)
  , (285,alex_action_31)
  , (284,alex_action_32)
  , (283,alex_action_33)
  , (282,alex_action_34)
  , (281,alex_action_35)
  , (280,alex_action_36)
  , (279,alex_action_37)
  , (278,alex_action_38)
  , (277,alex_action_39)
  , (276,alex_action_40)
  , (275,alex_action_41)
  , (274,alex_action_42)
  , (273,alex_action_43)
  , (272,alex_action_44)
  , (271,alex_action_45)
  , (270,alex_action_46)
  , (269,alex_action_47)
  , (268,alex_action_48)
  , (267,alex_action_49)
  , (266,alex_action_50)
  , (265,alex_action_51)
  , (264,alex_action_52)
  , (263,alex_action_53)
  , (262,alex_action_54)
  , (261,alex_action_55)
  , (260,alex_action_56)
  , (259,alex_action_57)
  , (258,alex_action_58)
  , (257,alex_action_59)
  , (256,alex_action_60)
  , (255,alex_action_61)
  , (254,alex_action_61)
  , (253,alex_action_61)
  , (252,alex_action_62)
  , (251,alex_action_62)
  , (250,alex_action_62)
  , (249,alex_action_63)
  , (248,alex_action_64)
  , (247,alex_action_65)
  , (246,alex_action_66)
  , (245,alex_action_67)
  , (244,alex_action_68)
  , (243,alex_action_68)
  , (242,alex_action_69)
  , (241,alex_action_70)
  , (240,alex_action_71)
  , (239,alex_action_72)
  , (238,alex_action_73)
  , (237,alex_action_74)
  , (236,alex_action_75)
  , (235,alex_action_75)
  , (234,alex_action_75)
  , (233,alex_action_75)
  , (232,alex_action_75)
  , (231,alex_action_75)
  , (230,alex_action_75)
  , (229,alex_action_75)
  , (228,alex_action_75)
  , (227,alex_action_75)
  , (226,alex_action_75)
  , (225,alex_action_75)
  , (224,alex_action_75)
  , (223,alex_action_75)
  , (222,alex_action_75)
  , (221,alex_action_75)
  , (220,alex_action_75)
  , (219,alex_action_75)
  , (218,alex_action_75)
  , (217,alex_action_75)
  , (216,alex_action_75)
  , (215,alex_action_75)
  , (214,alex_action_75)
  , (213,alex_action_75)
  , (212,alex_action_75)
  , (211,alex_action_75)
  , (210,alex_action_75)
  , (209,alex_action_75)
  , (208,alex_action_75)
  , (207,alex_action_75)
  , (206,alex_action_75)
  , (205,alex_action_75)
  , (204,alex_action_75)
  , (203,alex_action_75)
  , (202,alex_action_75)
  , (201,alex_action_75)
  , (200,alex_action_75)
  , (199,alex_action_75)
  , (198,alex_action_75)
  , (197,alex_action_75)
  , (196,alex_action_75)
  , (195,alex_action_75)
  , (194,alex_action_75)
  , (193,alex_action_75)
  , (192,alex_action_75)
  , (191,alex_action_75)
  , (190,alex_action_75)
  , (189,alex_action_75)
  , (188,alex_action_75)
  , (187,alex_action_75)
  , (186,alex_action_75)
  , (185,alex_action_75)
  , (184,alex_action_75)
  , (183,alex_action_75)
  , (182,alex_action_75)
  , (181,alex_action_75)
  , (180,alex_action_75)
  , (179,alex_action_75)
  , (178,alex_action_75)
  , (177,alex_action_75)
  , (176,alex_action_75)
  , (175,alex_action_75)
  , (174,alex_action_75)
  , (173,alex_action_75)
  , (172,alex_action_75)
  , (171,alex_action_75)
  , (170,alex_action_75)
  , (169,alex_action_75)
  , (168,alex_action_75)
  , (167,alex_action_75)
  , (166,alex_action_75)
  , (165,alex_action_75)
  , (164,alex_action_75)
  , (163,alex_action_75)
  , (162,alex_action_75)
  , (161,alex_action_75)
  , (160,alex_action_75)
  , (159,alex_action_75)
  , (158,alex_action_75)
  , (157,alex_action_75)
  , (156,alex_action_75)
  , (155,alex_action_75)
  , (154,alex_action_75)
  , (153,alex_action_75)
  , (152,alex_action_75)
  , (151,alex_action_75)
  , (150,alex_action_75)
  , (149,alex_action_75)
  , (148,alex_action_75)
  , (147,alex_action_75)
  , (146,alex_action_75)
  , (145,alex_action_75)
  , (144,alex_action_75)
  , (143,alex_action_75)
  , (142,alex_action_75)
  , (141,alex_action_75)
  , (140,alex_action_75)
  , (139,alex_action_75)
  , (138,alex_action_75)
  , (137,alex_action_75)
  , (136,alex_action_75)
  , (135,alex_action_75)
  , (134,alex_action_75)
  , (133,alex_action_75)
  , (132,alex_action_75)
  , (131,alex_action_75)
  , (130,alex_action_75)
  , (129,alex_action_75)
  , (128,alex_action_75)
  , (127,alex_action_75)
  , (126,alex_action_75)
  , (125,alex_action_75)
  , (124,alex_action_75)
  , (123,alex_action_75)
  , (122,alex_action_75)
  , (121,alex_action_75)
  , (120,alex_action_75)
  , (119,alex_action_75)
  , (118,alex_action_75)
  , (117,alex_action_75)
  , (116,alex_action_75)
  , (115,alex_action_75)
  , (114,alex_action_75)
  , (113,alex_action_75)
  , (112,alex_action_75)
  , (111,alex_action_75)
  , (110,alex_action_75)
  , (109,alex_action_75)
  , (108,alex_action_75)
  , (107,alex_action_75)
  , (106,alex_action_75)
  , (105,alex_action_75)
  , (104,alex_action_75)
  , (103,alex_action_75)
  , (102,alex_action_75)
  , (101,alex_action_75)
  , (100,alex_action_75)
  , (99,alex_action_75)
  , (98,alex_action_75)
  , (97,alex_action_75)
  , (96,alex_action_75)
  , (95,alex_action_75)
  , (94,alex_action_75)
  , (93,alex_action_75)
  , (92,alex_action_75)
  , (91,alex_action_75)
  , (90,alex_action_75)
  , (89,alex_action_75)
  , (88,alex_action_75)
  , (87,alex_action_75)
  , (86,alex_action_75)
  , (85,alex_action_75)
  , (84,alex_action_75)
  , (83,alex_action_75)
  , (82,alex_action_75)
  , (81,alex_action_75)
  , (80,alex_action_75)
  , (79,alex_action_75)
  , (78,alex_action_75)
  , (77,alex_action_75)
  , (76,alex_action_75)
  , (75,alex_action_75)
  , (74,alex_action_75)
  , (73,alex_action_75)
  , (72,alex_action_75)
  , (71,alex_action_75)
  , (70,alex_action_75)
  , (69,alex_action_75)
  , (68,alex_action_75)
  , (67,alex_action_75)
  , (66,alex_action_75)
  , (65,alex_action_75)
  , (64,alex_action_75)
  , (63,alex_action_75)
  , (62,alex_action_75)
  , (61,alex_action_75)
  , (60,alex_action_75)
  , (59,alex_action_75)
  , (58,alex_action_75)
  , (57,alex_action_75)
  , (56,alex_action_75)
  , (55,alex_action_75)
  , (54,alex_action_75)
  , (53,alex_action_75)
  , (52,alex_action_75)
  , (51,alex_action_75)
  , (50,alex_action_75)
  , (49,alex_action_75)
  , (48,alex_action_75)
  , (47,alex_action_75)
  , (46,alex_action_76)
  , (45,alex_action_77)
  , (44,alex_action_78)
  , (43,alex_action_79)
  , (42,alex_action_80)
  , (41,alex_action_81)
  , (40,alex_action_82)
  , (39,alex_action_83)
  , (38,alex_action_84)
  , (37,alex_action_85)
  , (36,alex_action_86)
  , (35,alex_action_87)
  , (34,alex_action_88)
  , (33,alex_action_89)
  , (32,alex_action_90)
  , (31,alex_action_91)
  , (30,alex_action_92)
  , (29,alex_action_93)
  , (28,alex_action_94)
  , (27,alex_action_95)
  , (26,alex_action_96)
  , (25,alex_action_97)
  , (24,alex_action_98)
  , (23,alex_action_99)
  , (22,alex_action_100)
  , (21,alex_action_101)
  , (20,alex_action_102)
  , (19,alex_action_103)
  , (18,alex_action_104)
  , (17,alex_action_105)
  , (16,alex_action_106)
  , (15,alex_action_107)
  , (14,alex_action_108)
  , (13,alex_action_109)
  , (12,alex_action_110)
  , (11,alex_action_111)
  , (10,alex_action_112)
  , (9,alex_action_113)
  , (8,alex_action_114)
  , (7,alex_action_115)
  , (6,alex_action_116)
  , (5,alex_action_117)
  , (4,alex_action_118)
  , (3,alex_action_119)
  , (2,alex_action_120)
  , (1,alex_action_121)
  , (0,alex_action_122)
  ]

{-# LINE 173 "Lexer.x" #-}


pickyReadOct :: String -> Integer
pickyReadOct s =
  if not $ null remStr
  then lexicalError $ "Non-octal digit '" ++ take 1 remStr ++ "' in \"" ++ s ++ "\"."
  else n
    where (n,remStr) = head $ readOct s

readHexExp :: (Floating a, Eq a) => String -> a
readHexExp initial =
    let (m, suf) = head $ readHex initial
        (e, _) = case suf of
                      p:s | toLower p == 'p' -> head $ readHex s
                      _                      -> (0, "")
     in m ** e

readCharTok :: String -> Char
readCharTok s = head . convChar . dropQuotes $ s
readStringTok :: String -> String
readStringTok = convChar . dropQuotes

dropQuotes :: String -> String
dropQuotes s = take (length s - 2) (tail s)

-- Converts a sequence of (unquoted) Java character literals, including
-- escapes, into the sequence of corresponding Chars. The calls to
-- 'lexicalError' double-check that this function is consistent with
-- the lexer rules for character and string literals. This function
-- could be expressed as another Alex lexer, but it's simple enough
-- to implement by hand.
convChar :: String -> String
convChar ('\\':'u':s@(d1:d2:d3:d4:s')) =
  -- TODO: this is the wrong place for handling unicode escapes
  -- according to the Java Language Specification. Unicode escapes can
  -- appear anywhere in the source text, and are best processed
  -- before lexing.
  if all isHexDigit [d1,d2,d3,d4]
  then toEnum (read ['0','x',d1,d2,d3,d4]):convChar s'
  else lexicalError $ "bad unicode escape \"\\u" ++ take 4 s ++ "\""
convChar ('\\':'u':s) =
  lexicalError $ "bad unicode escape \"\\u" ++ take 4 s ++ "\""
convChar ('\\':c:s) =
  if isOctDigit c
  then convOctal maxRemainingOctals
  else (case c of
          'b' -> '\b'
          'f' -> '\f'
          'n' -> '\n'
          'r' -> '\r'
          't' -> '\t'
          '\'' -> '\''
          '\\' -> '\\'
          '"' -> '"'
          _ -> badEscape):convChar s
  where maxRemainingOctals =
          if c <= '3' then 2 else 1
        convOctal n =
          let octals = takeWhile isOctDigit $ take n s
              noctals = length octals
              toChar = toEnum . fst . head . readOct
          in toChar (c:octals):convChar (drop noctals s)
        badEscape = lexicalError $ "bad escape \"\\" ++ c:"\""
convChar ("\\") =
  lexicalError "bad escape \"\\\""
convChar (x:s) = x:convChar s
convChar "" = ""

lexicalError :: String -> a
lexicalError = error . ("lexical error: " ++)

data L a = L Pos a
  deriving (Show, Eq)

-- (line, column)
type Pos = (Int, Int)

pos :: AlexPosn -> Pos
pos (AlexPn _ l c) = (l,c)

data Token
    -- Keywords
    = KW_Abstract
    | KW_AnnInterface
    | KW_Assert
    | KW_Boolean
    | KW_Break
    | KW_Byte
    | KW_Case
    | KW_Catch
    | KW_Char
    | KW_Class
    | KW_Const
    | KW_Continue
    | KW_Default
    | KW_Do
    | KW_Double
    | KW_Else
    | KW_Enum
    | KW_Extends
    | KW_Final
    | KW_Finally
    | KW_Float
    | KW_For
    | KW_Goto
    | KW_If
    | KW_Implements
    | KW_Import
    | KW_Instanceof
    | KW_Int
    | KW_Interface
    | KW_Long
    | KW_Native
    | KW_New
    | KW_Package
    | KW_Private
    | KW_Protected
    | KW_Public
    | KW_Return
    | KW_Short
    | KW_Static
    | KW_Strictfp
    | KW_Super
    | KW_Switch
    | KW_Synchronized
    | KW_This
    | KW_Throw
    | KW_Throws
    | KW_Transient
    | KW_Try
    | KW_Void
    | KW_Volatile
    | KW_While

    -- Separators
    | OpenParen
    | CloseParen
    | OpenSquare
    | CloseSquare
    | OpenCurly
    | CloseCurly
    | SemiColon
    | Comma
    | Period
    | LambdaArrow
    | MethodRefSep

    -- Literals
    | IntTok  Integer
    | LongTok Integer
    | DoubleTok Double
    | FloatTok Double
    | CharTok Char
    | StringTok String
    | BoolTok Bool
    | NullTok

    -- Identifiers
    | IdentTok String

    -- Operators
    | Op_Equal
    | Op_GThan
    | Op_LThan
    | Op_Bang
    | Op_Tilde
    | Op_Query
    | Op_Colon
    | Op_Equals
    | Op_LThanE
    | Op_GThanE
    | Op_BangE
    | Op_AAnd
    | Op_OOr
    | Op_PPlus
    | Op_MMinus
    | Op_Plus
    | Op_Minus
    | Op_Star
    | Op_Slash
    | Op_And
    | Op_Or
    | Op_Caret
    | Op_Percent
    | Op_LShift
    | Op_PlusE
    | Op_MinusE
    | Op_StarE
    | Op_SlashE
    | Op_AndE
    | Op_OrE
    | Op_CaretE
    | Op_PercentE
    | Op_LShiftE
    | Op_RShiftE
    | Op_RRShiftE
    | Op_AtSign
  deriving (Show, Eq)

lexer :: String -> [L Token]
lexer = alexScanTokens


alex_action_2 =  \p _ -> L (pos p) $ KW_AnnInterface 
alex_action_3 =  \p _ -> L (pos p) $ KW_Abstract     
alex_action_4 =  \p _ -> L (pos p) $ KW_Assert       
alex_action_5 =  \p _ -> L (pos p) $ KW_Boolean      
alex_action_6 =  \p _ -> L (pos p) $ KW_Break        
alex_action_7 =  \p _ -> L (pos p) $ KW_Byte         
alex_action_8 =  \p _ -> L (pos p) $ KW_Case         
alex_action_9 =  \p _ -> L (pos p) $ KW_Catch        
alex_action_10 =  \p _ -> L (pos p) $ KW_Char         
alex_action_11 =  \p _ -> L (pos p) $ KW_Class        
alex_action_12 =  \p _ -> L (pos p) $ KW_Const        
alex_action_13 =  \p _ -> L (pos p) $ KW_Continue     
alex_action_14 =  \p _ -> L (pos p) $ KW_Default      
alex_action_15 =  \p _ -> L (pos p) $ KW_Do           
alex_action_16 =  \p _ -> L (pos p) $ KW_Double       
alex_action_17 =  \p _ -> L (pos p) $ KW_Else         
alex_action_18 =  \p _ -> L (pos p) $ KW_Enum         
alex_action_19 =  \p _ -> L (pos p) $ KW_Extends      
alex_action_20 =  \p _ -> L (pos p) $ KW_Final        
alex_action_21 =  \p _ -> L (pos p) $ KW_Finally      
alex_action_22 =  \p _ -> L (pos p) $ KW_Float        
alex_action_23 =  \p _ -> L (pos p) $ KW_For          
alex_action_24 =  \p _ -> L (pos p) $ KW_Goto         
alex_action_25 =  \p _ -> L (pos p) $ KW_If           
alex_action_26 =  \p _ -> L (pos p) $ KW_Implements   
alex_action_27 =  \p _ -> L (pos p) $ KW_Import       
alex_action_28 =  \p _ -> L (pos p) $ KW_Instanceof   
alex_action_29 =  \p _ -> L (pos p) $ KW_Int          
alex_action_30 =  \p _ -> L (pos p) $ KW_Interface    
alex_action_31 =  \p _ -> L (pos p) $ KW_Long         
alex_action_32 =  \p _ -> L (pos p) $ KW_Native       
alex_action_33 =  \p _ -> L (pos p) $ KW_New          
alex_action_34 =  \p _ -> L (pos p) $ KW_Package      
alex_action_35 =  \p _ -> L (pos p) $ KW_Private      
alex_action_36 =  \p _ -> L (pos p) $ KW_Protected    
alex_action_37 =  \p _ -> L (pos p) $ KW_Public       
alex_action_38 =  \p _ -> L (pos p) $ KW_Return       
alex_action_39 =  \p _ -> L (pos p) $ KW_Short        
alex_action_40 =  \p _ -> L (pos p) $ KW_Static       
alex_action_41 =  \p _ -> L (pos p) $ KW_Strictfp     
alex_action_42 =  \p _ -> L (pos p) $ KW_Super        
alex_action_43 =  \p _ -> L (pos p) $ KW_Switch       
alex_action_44 =  \p _ -> L (pos p) $ KW_Synchronized 
alex_action_45 =  \p _ -> L (pos p) $ KW_This         
alex_action_46 =  \p _ -> L (pos p) $ KW_Throw        
alex_action_47 =  \p _ -> L (pos p) $ KW_Throws       
alex_action_48 =  \p _ -> L (pos p) $ KW_Transient    
alex_action_49 =  \p _ -> L (pos p) $ KW_Try          
alex_action_50 =  \p _ -> L (pos p) $ KW_Void         
alex_action_51 =  \p _ -> L (pos p) $ KW_Volatile     
alex_action_52 =  \p _ -> L (pos p) $ KW_While        
alex_action_53 =  \p _ -> L (pos p) $ IntTok 0        
alex_action_54 =  \p _ -> L (pos p) $ LongTok 0       
alex_action_55 =  \p s -> L (pos p) $ IntTok (pickyReadOct s) 
alex_action_56 =  \p s -> L (pos p) $ LongTok (pickyReadOct (init s)) 
alex_action_57 =  \p s -> L (pos p) $ IntTok (read s) 
alex_action_58 =  \p s -> L (pos p) $ LongTok (read (init s)) 
alex_action_59 =  \p s -> L (pos p) $ IntTok (fst . head $ readHex (drop 2 s)) 
alex_action_60 =  \p s -> L (pos p) $ LongTok (fst . head $ readHex (init (drop 2 s))) 
alex_action_61 =  \p s -> L (pos p) $ DoubleTok (fst . head $ readFloat $ '0':s) 
alex_action_62 =  \p s -> L (pos p) $ DoubleTok (fst . head $ readFloat $ '0':s) 
alex_action_63 =  \p s -> L (pos p) $ FloatTok  (fst . head $ readFloat $ '0':s) 
alex_action_64 =  \p s -> L (pos p) $ FloatTok  (fst . head $ readFloat $ '0':s) 
alex_action_65 =  \p s -> L (pos p) $ DoubleTok (fst . head $ readFloat s) 
alex_action_66 =  \p s -> L (pos p) $ DoubleTok (fst . head $ readFloat s) 
alex_action_67 =  \p s -> L (pos p) $ FloatTok  (fst . head $ readFloat s) 
alex_action_68 =  \p s -> L (pos p) $ DoubleTok (readHexExp (drop 2 s)) 
alex_action_69 =  \p s -> L (pos p) $ FloatTok  (readHexExp (drop 2 s)) 
alex_action_70 =  \p _ -> L (pos p) $ BoolTok True    
alex_action_71 =  \p _ -> L (pos p) $ BoolTok False   
alex_action_72 =  \p s -> L (pos p) $ CharTok (readCharTok s) 
alex_action_73 =  \p s -> L (pos p) $ StringTok (readStringTok s) 
alex_action_74 = \p _ -> L (pos p) $ NullTok 
alex_action_75 =  \p s -> L (pos p) $ IdentTok s 
alex_action_76 =  \p _ -> L (pos p) $ OpenParen       
alex_action_77 =  \p _ -> L (pos p) $ CloseParen      
alex_action_78 =  \p _ -> L (pos p) $ OpenSquare      
alex_action_79 =  \p _ -> L (pos p) $ CloseSquare     
alex_action_80 =  \p _ -> L (pos p) $ OpenCurly       
alex_action_81 =  \p _ -> L (pos p) $ CloseCurly      
alex_action_82 =  \p _ -> L (pos p) $ SemiColon       
alex_action_83 =  \p _ -> L (pos p) $ Comma           
alex_action_84 =  \p _ -> L (pos p) $ Period          
alex_action_85 =  \p _ -> L (pos p) $ LambdaArrow     
alex_action_86 =  \p _ -> L (pos p) $ MethodRefSep    
alex_action_87 =  \p _ -> L (pos p) $ Op_Equal        
alex_action_88 =  \p _ -> L (pos p) $ Op_GThan        
alex_action_89 =  \p _ -> L (pos p) $ Op_LThan        
alex_action_90 =  \p _ -> L (pos p) $ Op_Bang         
alex_action_91 =  \p _ -> L (pos p) $ Op_Tilde        
alex_action_92 =  \p _ -> L (pos p) $ Op_Query        
alex_action_93 =  \p _ -> L (pos p) $ Op_Colon        
alex_action_94 =  \p _ -> L (pos p) $ Op_Equals       
alex_action_95 =  \p _ -> L (pos p) $ Op_LThanE       
alex_action_96 =  \p _ -> L (pos p) $ Op_GThanE       
alex_action_97 =  \p _ -> L (pos p) $ Op_BangE        
alex_action_98 =  \p _ -> L (pos p) $ Op_AAnd         
alex_action_99 =  \p _ -> L (pos p) $ Op_OOr          
alex_action_100 =  \p _ -> L (pos p) $ Op_PPlus        
alex_action_101 =  \p _ -> L (pos p) $ Op_MMinus       
alex_action_102 =  \p _ -> L (pos p) $ Op_Plus         
alex_action_103 =  \p _ -> L (pos p) $ Op_Minus        
alex_action_104 =  \p _ -> L (pos p) $ Op_Star         
alex_action_105 =  \p _ -> L (pos p) $ Op_Slash        
alex_action_106 =  \p _ -> L (pos p) $ Op_And          
alex_action_107 =  \p _ -> L (pos p) $ Op_Or           
alex_action_108 =  \p _ -> L (pos p) $ Op_Caret        
alex_action_109 =  \p _ -> L (pos p) $ Op_Percent      
alex_action_110 =  \p _ -> L (pos p) $ Op_LShift       
alex_action_111 =  \p _ -> L (pos p) $ Op_PlusE        
alex_action_112 =  \p _ -> L (pos p) $ Op_MinusE       
alex_action_113 =  \p _ -> L (pos p) $ Op_StarE        
alex_action_114 =  \p _ -> L (pos p) $ Op_SlashE       
alex_action_115 =  \p _ -> L (pos p) $ Op_AndE         
alex_action_116 =  \p _ -> L (pos p) $ Op_OrE          
alex_action_117 =  \p _ -> L (pos p) $ Op_CaretE       
alex_action_118 =  \p _ -> L (pos p) $ Op_PercentE     
alex_action_119 =  \p _ -> L (pos p) $ Op_LShiftE      
alex_action_120 =  \p _ -> L (pos p) $ Op_RShiftE      
alex_action_121 =  \p _ -> L (pos p) $ Op_RRShiftE     
alex_action_122 =  \p _ -> L (pos p) $ Op_AtSign       
{-# LINE 1 "templates/GenericTemplate.hs" #-}
{-# LINE 1 "templates/GenericTemplate.hs" #-}
{-# LINE 1 "<built-in>" #-}
{-# LINE 15 "<built-in>" #-}
{-# LINE 1 "/usr/local/Cellar/ghc/8.2.1/lib/ghc-8.2.1/include/ghcversion.h" #-}
















{-# LINE 16 "<built-in>" #-}
{-# LINE 1 "/var/folders/cb/97yq0wgj167gl60_pbxlyc540000gn/T/ghc10915_0/ghc_2.h" #-}













































































































































































































{-# LINE 17 "<built-in>" #-}
{-# LINE 1 "templates/GenericTemplate.hs" #-}
-- -----------------------------------------------------------------------------
-- ALEX TEMPLATE
--
-- This code is in the PUBLIC DOMAIN; you may copy it freely and use
-- it for any purpose whatsoever.

-- -----------------------------------------------------------------------------
-- INTERNALS and main scanner engine


{-# LINE 21 "templates/GenericTemplate.hs" #-}


{-# LINE 51 "templates/GenericTemplate.hs" #-}


{-# LINE 72 "templates/GenericTemplate.hs" #-}
alexIndexInt16OffAddr arr off = arr ! off



{-# LINE 93 "templates/GenericTemplate.hs" #-}
alexIndexInt32OffAddr arr off = arr ! off



{-# LINE 105 "templates/GenericTemplate.hs" #-}
quickIndex arr i = arr ! i


-- -----------------------------------------------------------------------------
-- Main lexing routines

data AlexReturn a
  = AlexEOF
  | AlexError  !AlexInput
  | AlexSkip   !AlexInput !Int
  | AlexToken  !AlexInput !Int a

-- alexScan :: AlexInput -> StartCode -> AlexReturn a
alexScan input (sc)
  = alexScanUser undefined input (sc)

alexScanUser user input (sc)
  = case alex_scan_tkn user input (0) input sc AlexNone of
  (AlexNone, input') ->
    case alexGetByte input of
      Nothing ->



                                   AlexEOF
      Just _ ->



                                   AlexError input'

  (AlexLastSkip input'' len, _) ->



    AlexSkip input'' len

  (AlexLastAcc k input''' len, _) ->



    AlexToken input''' len (alex_actions ! k)


-- Push the input through the DFA, remembering the most recent accepting
-- state it encountered.

alex_scan_tkn user orig_input len input s last_acc =
  input `seq` -- strict in the input
  let
  new_acc = (check_accs (alex_accept `quickIndex` (s)))
  in
  new_acc `seq`
  case alexGetByte input of
     Nothing -> (new_acc, input)
     Just (c, new_input) ->



      case fromIntegral c of { (ord_c) ->
        let
                base   = alexIndexInt32OffAddr alex_base s
                offset = (base + ord_c)
                check  = alexIndexInt16OffAddr alex_check offset

                new_s = if (offset >= (0)) && (check == ord_c)
                          then alexIndexInt16OffAddr alex_table offset
                          else alexIndexInt16OffAddr alex_deflt s
        in
        case new_s of
            (-1) -> (new_acc, input)
                -- on an error, we want to keep the input *before* the
                -- character that failed, not after.
            _ -> alex_scan_tkn user orig_input (if c < 0x80 || c >= 0xC0 then (len + (1)) else len)
                                                -- note that the length is increased ONLY if this is the 1st byte in a char encoding)
                        new_input new_s new_acc
      }
  where
        check_accs (AlexAccNone) = last_acc
        check_accs (AlexAcc a  ) = AlexLastAcc a input (len)
        check_accs (AlexAccSkip) = AlexLastSkip  input (len)

        check_accs (AlexAccPred a predx rest)
           | predx user orig_input (len) input
           = AlexLastAcc a input (len)
           | otherwise
           = check_accs rest
        check_accs (AlexAccSkipPred predx rest)
           | predx user orig_input (len) input
           = AlexLastSkip input (len)
           | otherwise
           = check_accs rest


data AlexLastAcc
  = AlexNone
  | AlexLastAcc !Int !AlexInput !Int
  | AlexLastSkip     !AlexInput !Int

data AlexAcc user
  = AlexAccNone
  | AlexAcc Int
  | AlexAccSkip

  | AlexAccPred Int (AlexAccPred user) (AlexAcc user)
  | AlexAccSkipPred (AlexAccPred user) (AlexAcc user)

type AlexAccPred user = user -> AlexInput -> Int -> AlexInput -> Bool

-- -----------------------------------------------------------------------------
-- Predicates on a rule

alexAndPred p1 p2 user in1 len in2
  = p1 user in1 len in2 && p2 user in1 len in2

--alexPrevCharIsPred :: Char -> AlexAccPred _
alexPrevCharIs c _ input _ _ = c == alexInputPrevChar input

alexPrevCharMatches f _ input _ _ = f (alexInputPrevChar input)

--alexPrevCharIsOneOfPred :: Array Char Bool -> AlexAccPred _
alexPrevCharIsOneOf arr _ input _ _ = arr ! alexInputPrevChar input

--alexRightContext :: Int -> AlexAccPred _
alexRightContext (sc) user _ _ input =
     case alex_scan_tkn user input (0) input sc AlexNone of
          (AlexNone, _) -> False
          _ -> True
        -- TODO: there's no need to find the longest
        -- match when checking the right context, just
        -- the first match will do.

